local rs_loaded = false
addHook("ThinkFrame", do
	if RingSlinger and not rs_loaded
		rs_loaded = true;
		
		print("Loaded RingSlinger support for Team New")

		RingSlinger.Skins["sonicnew"] = {
			ammo = 50, --Not much ammo
			weapons = {RSWPN_SCATTER, RSWPN_BOUNCE} --Weapons that i think will fit him the best.
		}
		RingSlinger.Skins["recenttails"] = {
			ammo = 75,
			weapons = {RSWPN_FLASH, RSWPN_ACCEL}
		}
		RingSlinger.Skins["leknux"] = {
			ammo = 100,
			weapons = {RSWPN_STONE, RSWPN_FLAME}
		}
	end
end)

local ScriptLoaded = false

local WallExhaust = function(player)
	if player.exhaustjump and player.exhaustjump == 1
		local maxtime = 15
		player.exhaustmeter = FRACUNIT/4
		return false
	end
	return false
end
local function IsInZ(mobj, mo)
	if mo.z > (mobj.z+mobj.height)
		return
	end
	if (mobj.z-mobj.height) > (mo.z+mo.height)
		return
	end
	return true
end
local function AcceptThose(mo, mobj)
	if SNEW_CyloopInteract[mo.type]
		if (mo.flags & MF2_DONTDRAW)
		or (mo.sprite == SPR_NULL)
			return false --You cant beat the living rings out of nothing (Emblem places and dig spots)
		else
			return true --But you can punch trees
		end
	end
	local p
	if mobj and mobj.valid
		if mobj.player and mobj.player.valid
			p = mobj.player
		else
			if mobj.target and mobj.target.valid
			and mobj.target.player and mobj.target.player.valid
				p = mobj.target.player
			end
		end
	end
	if mo.player and mo.player.valid
		local player = mo.player
		if player and player.valid
		and player.playerstate == PST_LIVE
		and player.powers[pw_carry] != CR_NIGHTSMODE
		and not player.spectator
			if not mobj
				return true
			end
			if not multiplayer
				return true
			end
			if (gametyperules & GTR_FRIENDLYFIRE)
			or friendlyfire
				return true
			else
				if (gametyperules & GTR_FRIENDLY)
					return false
				else
					if p and p.valid
						if (gametyperules & GTR_TEAMS)
							if p.ctfteam == player.ctfteam
								return false
							else
								return true
							end
						else
							return true
						end
					else
						return true
					end
				end
			end
		end
	end
	if (mo.flags & (MF_ENEMY|MF_BOSS)) --If not in list then if has these flags
		return true
	end
	if (mo.flags & MF_SHOOTABLE) --If doesnt have these flags you gotta have MF_SHOOTABLE
		return true
	end
	return false --Everything failed.
end

local function DoCyloopPunch(mo,mobj)
				local hitfx = function(mo,mobj)
					//mobj hurt by mo
					local shake = false
					if (mo and mo.player and mo.player == consoleplayer)
					or (mobj and mobj.player and mobj.player == consoleplayer)
						shake = true
					end
					if mobj.type == MT_SPARRINGDUMMY
						S_StartSound(mobj,sfx_s3k6e)
					elseif mobj.battleobject
						S_StartSoundAtVolume(mobj,sfx_s3kaa, 120)
					end
					local sc = 2
					if not player
						S_StartSoundAtVolume(mo,sfx_s3k49, 220)
						S_StartSound(mobj,sfx_s3k96)
						if shake
							P_StartQuake(9*FRACUNIT, 2)
						end
					end
					local vfx = P_SpawnMobjFromMobj(mobj, 0, 0, mobj.height/2, MT_SPINDUST)
					if vfx.valid
						vfx.scale = mobj.scale * sc/5
						vfx.destscale = vfx.scale * 3
						vfx.colorized = true
						vfx.color = SKINCOLOR_WHITE
						vfx.state = S_BCEBOOM
					end
				end
				
				local x = mo.x+mo.momx
				local y = mo.y+mo.momy
				local left = x-(mo.radius*2)
				local right = x+(mo.radius*2)
				local bottom = y-(mo.radius*2)
				local top = y+(mo.radius*2)
				searchBlockmap("objects", function(mo,mobj)
					if mo and mo.valid
						local player = mo.player
						if mobj and mobj.valid
						and mobj != mo
						and AcceptThose(mobj, mo)
						and IsInZ(mo,mobj)
							if not mobj.cycontact
								mobj.cycontact = 3
								if not SNEW_CyloopInteract[mobj.type] --Normal objects
									if (mobj.flags & MF_BOSS) --Cannot send bosses to space.
										P_DamageMobj(mobj, mo, mo, 1, DMG_ELECTRIC)
									else
										table.insert(N_CyloopEnemies,mobj) --Send the enemy upward
										mobj.lastbasher = mo
										mobj.cycontact = TICRATE*5
										P_SetObjectMomZ(mobj, FixedMul(mo.scale,12*FRACUNIT), true)
										mobj.cylaunch = 5
										mobj.basht = true
										mobj.cylooped = true
										mobj.docylooper = false
										mobj.addroll = ANG15
										if mobj.player and mobj.player.valid
											local p = mobj.player
											if p and p.valid
											and p.playerstate == PST_LIVE
											and p.powers[pw_carry] != CR_NIGHTSMODE
											and not p.spectator
												p.jumprecon = 0
											end
										end
										if P_RandomRange(0, 1) == 0 mobj.addroll = -$ end
									end
								else
									SNEW_CyloopInteract[mobj.type](mo, mobj) --If an interactable then do its thing
									mobj.recyloop = TICRATE
								end
								if mobj.player and mobj.player.valid --If enemy is a player then apply tumble
									local mom = R_PointToAngle2(0,0,mo.momx,mo.momy)
									if not R_PointToDist2(0,0,mo.momx,mo.momy)
										mom = player.drawangle
									end
									CBW_Battle.ApplyCooldown(mobj.player,TICRATE*2,false)
								end
								if not SNEW_CyloopInteract[mobj.type]
									local mom = R_PointToAngle2(0,0,mo.momx,mo.momy)
									if not R_PointToDist2(0,0,mo.momx,mo.momy)
										mom = player.drawangle
									end
									P_InstaThrust(mobj, mom, 5*FRACUNIT)
								end
								mobj.removecy = TICRATE
								
								local s = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_THOK) --Visuals
								s.color = mo.color
								s.blendmode = AST_ADD
								s.fuse = TICRATE
								s.tics = 15
								s.spriteyscale = FRACUNIT/3*2
								s.expandx = true
								table.insert(N_CyloopEnemies,s)
								player.powers[pw_flashing] = 5
								
								hitfx(mo,mobj) --Battle mod hit effect
								if R_PointToDist2(0,0,mo.momx,mo.momy) > 5*FRACUNIT --Half momentum
									P_InstaThrust(mo, R_PointToAngle2(0,0,mo.momx,mo.momy), 5*FRACUNIT)
								else
									local mom = R_PointToAngle2(0,0,mo.momx,mo.momy)
									if not R_PointToDist2(0,0,mo.momx,mo.momy)
										mom = player.drawangle
									end
									P_InstaThrust(mo, mom, -(5*FRACUNIT)/2)
								end
								mo.momz = -$/5
								player.nobash = TICRATE
							end
						end
					end
				end,mo,left,right,bottom,top)
end

addHook("ThinkFrame", function()
	if not(ScriptLoaded)
		and CBW_Battle
		then
		ScriptLoaded = true
		local B = CBW_Battle
				
		local Cypunch = function(mo,doaction)
			local player = mo.player
			
			player.actiontext = "Cypunch"
			player.actionrings = 15
			player.action2text = nil
			player.action2rings = 0
			
			if not(B.CanDoAction(player))
				player.actionstate = 0
				return end	
	
			if player.actionstate == 0
				if doaction == 1
				and CanUse(player)
					player.actionstate = 1
					player.actiontime = 0
					B.PayRings(player)
					S_StartSound(mo,sfx_s3k3c)
					
				end
			end
			
			if player.actionstate == 1
				player.actiontime = $+1
				
				P_SetObjectMomZ(mo,P_MobjFlip(mo)*mo.scale,0)
				player.pflags = ($|PF_SPINNING)&~PF_NOJUMPDAMAGE
				mo.state = S_PLAY_SPINDASH
				if R_PointToDist2(0,0,mo.momx,mo.momy) < 5*FRACUNIT
					P_InstaThrust(mo,mo.angle,5*FRACUNIT)
				end
				
				if player.actiontime >= 5
					player.actionstate = 2
					player.actiontime = 0
				end
			end
			
			if player.actionstate == 2
				player.actiontime = $+1
				
				B.ApplyCooldown(player,TICRATE)
				mo.state = S_PLAY_WALK
				mo.frame = G
				mo.tics = 20
				if not (player.actiontime&3)
					local b = P_SpawnGhostMobj(mo)
					b.state = S_PLAY_WALK
					b.frame = G
					b.tics = 12
					b.fuse = 15
					b.colorized = true
					b.destscale = mo.scale/4*5
					P_InstaThrust(b,mo.angle,-15*FRACUNIT)
				end
				
				player.pflags = $&~(PF_SPINNING)
				player.drawangle = mo.angle
				
				DoCyloopPunch(mo,mobj)
				
				if player.actiontime >= 15
					if not P_IsObjectOnGround(mo)
						mo.state = S_PLAY_FALL
					end
					player.actionstate = 0
					player.actiontime = 0
				end
			end
		end
		
		local CypunchPower = function(player)
			if player.actionstate == 2
				B.SetPriority(player,2,1,nil,1,1,"cypunch")
			end
		end
		
		CBW_Battle.SkinVars["sonicnew"] = {
			flags = SKINVARS_NOSPINSHIELD, --No guard because he has bash.
			weight = 100,
			special = Cypunch,
			func_priority = CypunchPower,
			func_exhaust = WallExhaust,
			shields = 1,
			guard_frame = C
		}
		CBW_Battle.SkinVars["recenttails"] = {
			flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD, --He needs guard becuase of his Frontiers Damage thing.
			weight = 100,
			shields = 1,
			special = B.Action.TailSwipe, --No ideas so just tail swipe
			guard_frame = 2,
			func_priority_ext = B.Action.TailSwipe_Priority,
			sprites = {
				S_TAILS_SWIPE
			}
		}
		
		local MaxCharge = function(mo,doaction)
			local player = mo.player
			
			player.actiontext = "Quick Charge"
			if player.rings/2 > 20
				player.actionrings = 40
			else
				player.actionrings = player.rings/2
			end
			player.action2text = nil
			player.action2rings = 0
			
			if not(B.CanDoAction(player))
				player.actionstate = 0
				return end	
	
			if player.actionstate == 0
				if doaction == 1
					player.actionstate = 1
					player.actiontime = 0
					if player.rings/2 > 20
						player.getcharge = 20
					else
						player.getcharge = player.rings/2
					end
					B.PayRings(player)
					S_StartSound(mo,sfx_s3k3c)
					mo.state = S_PLAY_SUPER_TRANS1
					mo.tics = 11
				end
			end
			
			if player.actionstate == 1
				player.actiontime = $+1
				if player.getcharge
					player.ghbag = $+1
					if player.ghbag > player.getcharge
						player.ghbag = player.getcharge
					end
				end
				
				if (player.getcharge and player.actiontime >= player.getcharge)
				or player.actiontime >= 20
					B.ApplyCooldown(player,TICRATE*15)
					player.actionstate = 0
					player.actiontime = 0
				end
			end
		end
		
		CBW_Battle.SkinVars["leknux"] = {
			flags = SKINVARS_NOSPINSHIELD, --No guard because crouch.
			weight = 100,
			special = MaxCharge,
			shields = 1,
			guard_frame = C
		}
	end
end)

if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["sonicnew"] = 8
kirbyabilitytable["recenttails"] = 7
kirbyabilitytable["leknux"] = -6	