freeslot("MT_WINDBALL","MT_DIGSPOT","MT_CYAURA","MT_SONICSPRING")

--Dummy functions
rawset(_G, "SNEWSpringThinker", 	function(mo) 	end)
rawset(_G, "WindThinker", 			function(mo) 	end)
rawset(_G, "IForgorWhatThisDoes", 	function(l)		end)
rawset(_G, "ChargeThinker", 		function(mo) 	end)
rawset(_G, "BallThink", 			function(mo)	end)
rawset(_G, "MonitorRespawn", 		function(mo)	end)
rawset(_G, "RockThinker", 			function(mo)	end)
rawset(_G, "KnuxPunchThink", 		function(mo)	end)

local N_ThinkerFunctions = { --Kinda messy but... OPTIMIZED!
    [MT_SONICSPRING] = SNEWSpringThinker,
    [MT_WINDBALL] = BallThink,
    [MT_DEMONFIRE] = function(mo)
        if mo.ghostmis or mo.knuxpunch
            KnuxPunchThink(mo)
        end end,
    [MT_FLINGRING] = function(mo)
        if mo.target and mo.target.player
        and mo.fhome and mo.fuse <= TICRATE*8 and mo.health 
            P_HomingAttack(mo, mo.target)
        end end,
	[MT_PARTICLE] = function(mo)
		if mo.jumppad WindThinker(mo) end end,
	[MT_FALLINGROCK] = function(mo)
		if mo.knuxrock RockThinker(mo) end end,
	[MT_DIGSPOT] = function(mo)
		if mo.state == S_DIGSPOT_SHOW
		or mo.state == S_DIGSPOT
			if devparm 
			and ((mo.state == S_DIGSPOT) or (mo.state == S_DIGSPOT_SHOW))
				mo.state = S_DIGSPOT_SHOW
				mo.tics = 3
			end
			if mo.state != S_DIGSPOT
				if mo.wasdug
					mo.frame = B
				else
					mo.frame = A
				end
			end
		end end,
	[MT_CYAURA] = function(mo)
		if mo.target and mo.target.valid
		and mo.target.health
			if mo.target.player and mo.target.player.valid
				mo.target.player.cyaura = mo
			end
			if mo.target.skin
				mo.skin = mo.target.skin
			end
			mo.sprite = mo.target.sprite
			mo.sprite2 = mo.target.sprite2
			mo.frame = mo.target.frame
			mo.blendmode = AST_ADD
		end end,
	[MT_THOK] = function(mo)
		if mo.breakwalls --Windball FOF breaker
		and mo.subsector and mo.subsector.sector
			CheckAndCrumble(mo, mo.subsector.sector)
		end 
		if mo.switchteam --Team switching trail
			local f = P_SpawnMobjFromMobj(mo,0,0,0, MT_THOK)
			f.scale = mo.scale
			f.color = mo.color
			f.destscale = mo.scale/5
			
			if mo.target and mo.target.valid
				local t = mo.target
				
				local px = t.x-mo.x
				local py = t.y-mo.y
				local pz = (t.z+t.height/2)-(mo.z+mo.height/2)
				
				local fsped = 60*FRACUNIT
				local psped = P_AproxDistance(P_AproxDistance(t.momx,t.momy),t.momz)
				local pdist = P_AproxDistance(P_AproxDistance(px,py),pz)
				if psped+(pdist/7) > fsped
					fsped = psped+(pdist/7)+10*FRACUNIT
				end
				P_FlyTo(mo, t.x, t.y, t.z, fsped, false)
				
				
				if pdist <= 74*FRACUNIT
					P_KillMobj(mo)
				end
			end
		end end
}

addHook("ThinkFrame", function()
    for i,k in pairs(N_GlobalThinkers)
        local mo = N_GlobalThinkers[i]
        if not mo.valid
        or mo.health <= 0
            table.remove(N_GlobalThinkers, i)
            continue
        end
        if not (mo.flags & MF_NOTHINK)
			if mo.shouldgoback then MonitorRespawn(mo) end
            N_ThinkerFunctions[mo.type](mo)
        end
    end
end)

addHook("ShouldDamage", function(mo,mobj) --A fix for Tails`s And Knux`s projectiles.
	if mo and mo.valid
	and mo.type == MT_PLAYER
		if mobj and mobj.valid
		and (mobj.type == MT_WINDBALL
		or mobj.type == MT_FALLINGROCK
		or mobj.type == MT_DEMONFIRE)
		and mobj.target and mobj.target.valid --I dont care if it has a tracer.
			if mobj.target.player and mobj.target.player.valid
			and mo.player and mo.player.valid
				local p2 = mo.player
				local p = mobj.target.player
				if SameTeam(p,p2) != 2
					return false
				end
			end
		end
	end
end)