local function CheckAndCrumble(mo, sec) --Ground breaking invention
	for fof in sec.ffloors()
		if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
		if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
		if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
		if mo.z-mo.height > fof.topheight continue end -- Are we too high?

		-- Check for whatever else you may want to    

		EV_CrumbleChain(fof) -- Crumble
	end
end
addHook("MobjLineCollide", function(mo, line)
	if mo and mo.valid
	and mo.player and mo.player.valid
	and mo.player.playerstate == PST_LIVE
	and mo.skin == SKIN
	and mo.player.groundjump
		for _, sec in ipairs({line.frontsector, line.backsector})
			CheckAndCrumble(mo, sec)
		end
	end
end)

addHook("PreThinkFrame", do --Gotta love some input fuckery
	for player in players.iterate()
		if player.valid and player.playerstate == PST_LIVE
		and not player.spectator and player.powers[pw_carry] != CR_NIGHTSMODE
		and player.mo.skin == "leknux"
			if (player.nocrouch or player.dontstopspin)
			and player.extrabutton
			and player.cmd.buttons & player.extrabutton
				player.cmd.buttons = $&~(player.extrabutton)
			end
		end
	end
end)

local function CheckDig(player) --Diggy check
	local darover = 0
	local roverdig = 0
	local roversurf = 0
	local infodig = {}
	local candig = false
	if P_MobjFlip(player.mo) == 1
		if player.mo.floorrover
			darover = player.mo.floorrover
			roverdig = player.mo.floorrover.topheight
			roversurf = player.mo.floorrover.bottomheight
			candig = true
		end
	else
		if player.mo.ceilingrover
			darover = player.mo.ceilingrover
			roverdig = player.mo.ceilingrover.bottomheight
			roversurf = player.mo.ceilingrover.topheight
			candig = true
		end
	end
	if candig
		local check = P_SpawnMobj(player.mo.x, player.mo.y, roversurf, MT_THOK)
		check.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
		check.flags2 = $|MF2_DONTDRAW
		check.fuse = 1
		check.tics = 1
		check.radius = player.mo.radius
		check.height = player.mo.height
		if P_TryMove(check, check.x, check.y, false)
		and P_CheckPosition(player.mo, check.x, check.y, roversurf)
		and (check.ceilingz-check.floorz) > skins[player.mo.skin].height
		and check.subsector and check.subsector.valid
		and check.subsector.sector and check.subsector.sector.valid
		and R_PointInSubsectorOrNil(check.x, check.y)
			candig = true
		else
			candig = false
		end
	end
	infodig.surf = roversurf
	infodig.dig = roverdig
	infodig.rover = darover
	infodig.candig = candig
	return infodig
end
local function CheckDigWall(mo, pmo)
	if P_TryMove(mo, mo.x, mo.y)
	and P_CheckPosition(pmo, mo.x, mo.y, mo.z)
	and (mo.ceilingz-mo.floorz) > pmo.height
	and mo.subsector and mo.subsector.valid
	and mo.subsector.sector and mo.subsector.sector.valid
	and R_PointInSubsectorOrNil(mo.x, mo.y)
	and pmo.z+pmo.height < mo.ceilingz
	and pmo.z > mo.floorz
		return true
	end
	return false
end

local SEARCHTIME = TICRATE/2*3 --Search for a PROMOTION!

local function DoCrouchRoll(player) --Rollin' down the street.
	local cmdang = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
	local momang = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
	if (player.cmd.forwardmove or player.cmd.sidemove)
		if abs(momang-cmdang) <= ANGLE_45+ANG30
			return true
		end
	end
	return false
end

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "leknux"
		player.nocrouch = $ or 0
		player.dontstopspin = $ or 0
		player.checkdigcd = $ or 0
		if player.checkdigcd
			player.checkdigcd = $ - 1
		end
		if player.dontstopspin
			player.dontstopspin = $ - 1
		end
		if player.nocrouch
			player.nocrouch = $ - 1
		end
		player.nogroundjump = $ or 0
		if player.nogroundjump
			player.nogroundjump = $ - 1
		end
		player.dropdash = $ or 0
	
		if player.pflags & PF_SPINNING
		and player.dontstopspin
		and DoCrouchRoll(player)
			player.dontstopspin = 15
		end
		
		player.ghostchargecd = $ or 0
		if player.ghostchargecd
			player.ghostchargecd = $ - 1
		end
		player.attacknow = $ or 0
		if player.attacknow
			player.attacknow = $ - 1
			player.youfeck = true
		else
			if player.youfeck
				player.mo.flags = $&~MF_NOGRAVITY
			end
			player.youfeck = false
		end
	
		player.hasground = $ or 0
		player.homingshot = $ or 0
		player.searchnrg = $ or 0
		if player.searchnrg
		and CanUse(player)
			player.searchnrg = $ - 1
			local addr = P_RandomRange(0, player.mo.radius>>FRACBITS)<<FRACBITS
			local adda = P_RandomRange(0, 360)*ANG1
			local addx = P_ReturnThrustX(nil, adda, addr)
			local addy = P_ReturnThrustY(nil, adda, addr)
			local addz = (P_RandomRange(0, player.mo.height>>FRACBITS)<<FRACBITS)*P_MobjFlip(player.mo)
			local s = P_SpawnMobjFromMobj(player.mo, addx, addy, addz, MT_THOK)
			s.state = S_NIGHTSPARKLE1
			s.tics = 1
			s.fuse = 15
			s.color = player.mo.color
			s.colorized = true
			s.blendmode = AST_ADD
		end
		player.searchcd = $ or 0
		if player.searchcd
			player.searchcd = $ - 1
		end
		player.searchaccident = $ or 0
		player.searchremove = $ or 0
		player.groundslam = $ or 0
		if player.groundslam
			player.groundslam = $ - 1
			player.nocrouch = 5
			player.mo.state = S_PLAY_SWIM
			player.mo.frame = A
			player.pflags = $|PF_THOKKED|PF_JUMPED|PF_SHIELDABILITY
			player.pflags = $&~(PF_NOJUMPDAMAGE)
			P_SetObjectMomZ(player.mo, P_GetMobjGravity(player.mo)*P_MobjFlip(player.mo), true)
			if P_IsObjectOnGround(player.mo)
				player.groundslam = 0
				player.nocrouch = 5
				P_Earthquake(player.mo, player.mo, 500*FRACUNIT)
				P_ResetPlayer(player)
				player.mo.state = S_PLAY_GLIDE_LANDING
				player.pflags = $|PF_STASIS
				if (player.speed > FixedMul(player.runspeed, player.mo.scale))
					player.skidtime = $+player.mo.tics
				end
				player.mo.momx = ((player.mo.momx - player.cmomx)/2) + player.cmomx
				player.mo.momy = ((player.mo.momy - player.cmomy)/2) + player.cmomy
				S_StartSound(player.mo, sfx_s3k49)
				CheckAndCrumble(player.mo, player.mo.subsector.sector)
			end
		end
		if P_IsObjectOnGround(player.mo)
			player.nogroundslam = false
		end
		player.groundjumprockscd = $ or 0
		if player.groundjumprockscd then player.groundjumprockscd = $-1 end
		if player.extrabutton
		and player.cmd.buttons & player.extrabutton --Crouch stuff
			if not P_PlayerInPain(player)
			and not player.exiting
			and not player.nocrouch
			and not player.diganim
			and not player.climbing
			and CanUse(player)
			and ((player.powers[pw_carry] == 9) 
			or (player.powers[pw_carry] == 10)
			or (player.powers[pw_carry] == 0))
				player.height = skins[player.mo.skin].spinheight
				player.mo.state = S_PLAY_GLIDE_LANDING
				player.crouching = true
				player.searchremove = 15
				player.searchaccident = $ + 1
				if player.searchaccident == SEARCHTIME
					local ghost = P_SpawnGhostMobj(player.mo)
					ghost.scale = player.mo.scale/4*5
					ghost.destscale = player.mo.scale
					ghost.fuse = 13
				end
				if R_PointToDist2(0, 0, player.mo.momx, player.mo.momx) > FRACUNIT --Dropspin
				and P_IsObjectOnGround(player.mo)
					P_SpawnSkidDust(player, player.mo.radius, true)
					if DoCrouchRoll(player)
					and (player.mo.eflags & MFE_JUSTHITFLOOR)
					and not player.holdingrock
						player.dospin = true
						player.nocrouch = 20
						player.dontstopspin = 15
						if player.ghbag
							if player.ghbag >= (player.dropdash/FRACUNIT)
								player.ghbag = $-(player.dropdash/FRACUNIT)
							else
								player.ghbag = 0
							end
							P_Thrust(player.mo, player.mo.angle, player.dropdash)
							S_StartSound(player.mo, sfx_zoom)
							for i = 1, player.dropdash/FRACUNIT
								local ranang = (player.mo.angle+ANGLE_180) + P_RandomRange(-15,15)*ANG1
								local ranrad = FixedMul(player.mo.radius*3, FRACUNIT+cos(P_RandomRange(0, 360)*ANG1))
								local addx = P_ReturnThrustX(nil, ranang, ranrad)
								local addy = P_ReturnThrustY(nil, ranang, ranrad)
								
								local b = P_SpawnGhostMobj(player.mo)
								b.state = S_PLAY_WALK
								b.tics = -1
								if P_RandomRange(1, 2) == 1
									b.frame = D
								else
									b.frame = H
								end
								b.blendmode = AST_ADD
								b.fuse = TICRATE
								b.colorized = true
								P_TryMove(b, player.mo.x+addx, player.mo.y+addy)
								b.angle = R_PointToAngle2(b.x, b.y, player.mo.x, player.mo.y)
							end
						end
					end
					player.dropdash = 0
				end
				if R_PointToDist2(0, 0, player.mo.momx, player.mo.momx) > FRACUNIT --Dropdash
				and not P_IsObjectOnGround(player.mo)
					if DoCrouchRoll(player)
					and not player.holdingrock
					and ((not player.dropdash)
					or (player.dropdash and player.dropdash/FRACUNIT < player.ghbag*4))
						player.dropdash = $ + FRACUNIT/5
						if (player.dropdash/FRACUNIT) >= 2
							local dash = P_SpawnGhostMobj(player.mo)
							dash.blendmode = AST_ADD
							dash.state = S_PLAY_ROLL
							dash.colorized = true
							dash.fuse = player.dropdash/FRACUNIT
						end
					end
				end
				if not P_IsObjectOnGround(player.mo) --This can be exploited easily
					player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE
					player.pflags = $ & ~PF_CANCARRY
				else
					player.pflags = $|PF_STASIS
					player.pflags = $ & ~(PF_CANCARRY|PF_JUMPED|PF_NOJUMPDAMAGE)
				end
				if player.dotheflip
				and player.powers[pw_gravityboots]
				and CheckDig(player)
				and CheckDig(player).candig
				and player.dacrouch
				and not player.checkdigcd
				and consoleplayer == player
					player.hasground = $ + 1
					if player.hasground >= TICRATE
						local alart = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_GHOST)
						alart.state = S_ALART1
						alart.fuse = TICRATE
						alart.spriteyoffset = player.mo.height+15*FRACUNIT
						player.checkdigcd = TICRATE*5
					end
				else
					player.hasground = 0
				end
				if not P_IsObjectOnGround(player.mo) --Ground slam
				and not player.groundslam
				and not player.nogroundslam
					if player.cmd.buttons & BT_SPIN
					and player.searchaccident < SEARCHTIME
						if player.cmd.buttons & BT_JUMP
							if not player.groundslammer
								player.groundslam = TICRATE*3
								player.nogroundslam = true
								P_SetObjectMomZ(player.mo, -15*FRACUNIT, true)
								player.mo.state = S_PLAY_GLIDE
								player.mo.frame = A
							end
							player.groundslammer = true
						else
							player.groundslammer = false
						end
					end
				end
				if player.cmd.buttons & BT_SPIN --Ground jump
					if not player.groundjump
					and not player.startjump
					and not player.dotheflip
					and not player.nogroundjump
						if P_IsObjectOnGround(player.mo)
							CheckAndCrumble(player.mo, player.mo.subsector.sector)
							P_SetObjectMomZ(player.mo, 15*FRACUNIT, true)
							local ranstart = player.drawangle+(P_RandomRange(0, 360)*ANG1)
							if not player.groundjumprockscd
								for i = 1, 10
									local iang = ((360/10)*i)*ANG1
									local ranf = ranstart + (iang + P_RandomRange(-5, 5)*ANG1)
									local rock = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_FALLINGROCK)
									rock.target = player.mo
									rock.tracer = player.mo
									rock.flags = MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE
									rock.fuse = TICRATE*2
									rock.knuxrock = true
									rock.color = player.mo.color
									AddToTable(rock,N_GlobalThinkers)
									/*if player.ghbag < 10
									and not player.ghostchargecd
										rock.hasghost = true
									end*/
									if gametyperules & GTR_TEAMS
										rock.colorized = true
									end
									rock.destscale = FRACUNIT/3
									rock.scalespeed = P_RandomRange((FRACUNIT/30)>>FRACBITS, (FRACUNIT/20)>>FRACBITS)<<FRACBITS --I LOVE FRACBIT SHIFTING!
									P_InstaThrust(rock, ranf, P_RandomRange((FRACUNIT*5)>>FRACBITS,(FRACUNIT*20)>>FRACBITS)<<FRACBITS)
									P_SetObjectMomZ(rock, P_RandomRange((FRACUNIT*2)>>FRACBITS,(player.mo.radius)>>FRACBITS)<<FRACBITS,true)
									
									local randist = P_RandomRange(FRACUNIT*2>>FRACBITS, (FRACUNIT*10)>>FRACBITS)<<FRACBITS
									P_SpawnMobjFromMobj(player.mo, P_ReturnThrustX(nil, ranf, randist), P_ReturnThrustY(nil, ranf, randist), 0, MT_MINUSDIRT)
								end
								if not (gametyperules & GTR_FRIENDLY)
									player.groundjumprockscd = TICRATE*10
								end
							end
							local rock = P_SpawnMobjFromMobj(player.mo, P_ReturnThrustX(nil, player.drawangle, player.mo.radius), P_ReturnThrustY(nil, player.drawangle, player.mo.radius), 0, MT_FALLINGROCK)
							rock.target = player.mo
							rock.tracer = player.mo
							rock.flags = MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE|MF_SPECIAL
							rock.fuse = TICRATE*5
							rock.knuxrock = true
							rock.color = player.mo.color
							rock.scale = FRACUNIT
							if gametyperules & GTR_TEAMS
								rock.colorized = true
							end
							rock.momx = player.mo.momx
							rock.momy = player.mo.momy
							rock.momz = player.mo.momz
							rock.destscale = FRACUNIT/3
							rock.scalespeed = FRACUNIT/TICRATE/5
							AddToTable(rock,N_GlobalThinkers)
							
							S_StartSound(player.mo, sfx_crumbl)
							player.mo.state = S_PLAY_SPRING
							player.nocrouch = 15
							if not player.ghostchargecd
								player.ghostchargecd = TICRATE*5
							end
						elseif ((not player.searchcd) and player.searchaccident >= SEARCHTIME)
							player.searchnrg = TICRATE*30
							player.searchcd = player.searchnrg + TICRATE*10
							for i = 1, 35
								local ranr = P_RandomRange((player.mo.radius*3)>>FRACBITS,(1000*FRACUNIT)>>FRACBITS) <<FRACBITS
								local rana = P_RandomRange(0, 360)*ANG1
								local addx = P_ReturnThrustX(nil, rana, ranr)
								local addy = P_ReturnThrustY(nil, rana, ranr)
								local addz = P_RandomRange(0,(player.mo.height*3)>>FRACBITS)<<FRACBITS --Z Range of the search
								local trail = P_SpawnMobjFromMobj(player.mo, addx, addy, addz, MT_THOK)
								trail.color = player.mo.color
								--trail.target = player.mo
								trail.tracer = player.mo
								trail.blendmode = AST_ADD
								trail.tics = player.searchnrg
								trail.fuse = player.searchnrg
								trail.ghosten = true
								trail.flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SPECIAL|MF_NOGRAVITY
								trail.flags = $&~MF_NOCLIPTHING
								AddToTable(trail,N_GlobalThinkers)
								if multiplayer
									if player != consoleplayer
										trail.flags2 = $|MF2_DONTDRAW
										trail.dontsee = true
									end
								else
									if players[0] == player
									and player != displayplayer
										trail.flags2 = $|MF2_DONTDRAW
										trail.dontsee = true
									end
									if players[1] == player
									and player != displayplayer2
										trail.flags2 = $|MF2_DONTDRAW
										trail.dontsee = true
									end
								end
								if not trail.dontsee
									local zoom = P_SpawnMobjFromMobj(trail, 0, 0, (trail.height/2)*P_MobjFlip(trail), MT_THOK)
									zoom.color = trail.color
									zoom.blendmode = AST_ADD
									zoom.spriteyoffset = -43*FRACUNIT/2
									zoom.scale = FRACUNIT*2
									zoom.destscale = FRACUNIT
									zoom.scalespeed = FRACUNIT/15
									S_StartSound(trail, sfx_monton)
								end
							end
						end
					end
					if player.dotheflip --If you kill yourself with this, not my problem
					and not player.groundjump
					and (player.mo.ceilingrover or player.mo.floorrover)
						if CheckDig(player)
						and CheckDig(player).candig
							local digt = CheckDig(player)
							local flipped = false
							for i = 1, 6
								local ranang = ((360/6)*i)*ANG1 + P_RandomRange(-5, 5)*ANG1
								local ranx = P_ReturnThrustX(nil, ranang, player.mo.radius/3)
								local rany = P_ReturnThrustY(nil, ranang, player.mo.radius/3)
							
								local digdig = P_SpawnMobj(player.mo.x+ranx, player.mo.y+rany, digt.dig, MT_MINUSDIRT)
								if P_MobjFlip(player.mo) == -1
									digdig.flags2 = $|MF2_OBJECTFLIP
									digdig.eflags = $|MFE_VERTICALFLIP
								end
							end
							if P_MobjFlip(player.mo) == -1
								flipped = true
							end
							player.gotodig = {
							x = player.mo.x,
							y = player.mo.y,
							z = digt.surf,
							extra1 = true,
							dig = digt.dig,
							flip = flipped}
							player.mo.momx = 0
							player.mo.momy = 0
							player.mo.momz = 0
							player.diganim = 15
						end
					end
					player.groundjump = true
				else
					player.groundjump = false
				end
				player.charability = CA_NONE --https://cdn.discordapp.com/attachments/220988469785133056/1054037545803075654/image.png
			end
			if player.dacrouch --Wall dig
			and not player.exiting
			and not player.nocrouch
			and player.climbing
				local tpto
				local lastfail
				for i = 1, 50
					local addrad = player.mo.radius + ((player.mo.radius)*i)
					local addx = P_ReturnThrustX(nil, player.drawangle, addrad)
					local addy = P_ReturnThrustY(nil, player.drawangle, addrad)
					
					local mo = P_SpawnMobj(player.mo.x+addx, player.mo.y+addy, player.mo.z, MT_THOK)
					mo.radius = player.mo.radius
					mo.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
					mo.flags2 = $|MF2_DONTDRAW
					mo.fuse = 2
					mo.tics = 2
					mo.height = player.mo.height
					
					if CheckDigWall(mo, player.mo)
						tpto = mo
						if lastfail and lastfail.valid --Extra check
							for i = 1, 50
								local radfix = R_PointToDist2(tpto.x, tpto.y, lastfail.x, lastfail.y)/50
								local ranang = R_PointToAngle2(tpto.x, tpto.y, lastfail.x, lastfail.y)
								local radi = radfix*i
								local addxi = P_ReturnThrustX(nil, ranang, radi)
								local addyi = P_ReturnThrustY(nil, ranang, radi)
								local chk = P_SpawnMobj(tpto.x+addxi, tpto.y+addyi, tpto.z, MT_THOK)
								chk.radius = player.mo.radius
								chk.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
								chk.flags2 = $|MF2_DONTDRAW
								chk.fuse = 2
								chk.tics = 2
								chk.height = player.mo.height
								if CheckDigWall(chk, player.mo)
									tpto = chk
								end
							end
						end
						break
					else
						lastfail = mo
					end
				end
				if tpto and tpto.valid --Start digging
					local digspawn
					for i = 1, 50
						local radfix = R_PointToDist2(tpto.x, tpto.y, player.mo.x, player.mo.y)/50
						local ranang = R_PointToAngle2(tpto.x, tpto.y, player.mo.x, player.mo.y)
						local radi = radfix*i
						local addxi = P_ReturnThrustX(nil, ranang, radi)
						local addyi = P_ReturnThrustY(nil, ranang, radi)
						local chk = P_SpawnMobjFromMobj(tpto, addxi, addyi, 0, MT_THOK)
						chk.radius = player.mo.radius
						chk.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						chk.flags2 = $|MF2_DONTDRAW
						chk.fuse = 2
						chk.tics = 2
						chk.height = player.mo.height
						if CheckDigWall(chk, player.mo)
							digspawn = chk
							break
						end
					end
					if not (digspawn and digspawn.valid)
						digspawn = player.mo
					end
					local dig = P_SpawnMobjFromMobj(digspawn, 
						P_ReturnThrustX(nil, player.drawangle, player.mo.radius-FRACUNIT), 
						P_ReturnThrustY(nil, player.drawangle, player.mo.radius-FRACUNIT), 
						player.mo.height/2, MT_MINUSDIRT)
					if P_MobjFlip(player.mo) == 1
						dig.flags2 = $&~MF2_OBJECTFLIP
						dig.eflags = $&~MFE_VERTICALFLIP
					else
						dig.flags2 = $|MF2_OBJECTFLIP
						dig.eflags = $|MFE_VERTICALFLIP
					end
					dig.flags = $|MF_NOGRAVITY
					dig.renderflags = $|RF_PAPERSPRITE
					dig.angle = player.drawangle+ANGLE_90
					player.gotodig = {
					x = tpto.x,
					y = tpto.y,
					z = tpto.z}
					player.mo.momx = 0
					player.mo.momy = 0
					player.mo.momz = 0
					player.digwallanim = 15
				end
			end
			player.dacrouch = true
		else
			if player.searchremove
				player.searchremove = $ - 1
				player.dotheremoval = true
			else
				if player.dotheremoval
					if player.searchaccident >= SEARCHTIME
						local ghost = P_SpawnGhostMobj(player.mo)
						ghost.scale = player.mo.scale
						ghost.destscale = player.mo.scale/4*5
						ghost.fuse = 13
					end
					player.searchaccident = 0
				end
				player.dotheremoval = false
			end
			player.hasground = 0
			if player.dacrouch
			and player.crouching
				player.crouching = false
				player.nocrouch = 5
				player.charability = CA_GLIDEANDCLIMB --yes i know i could just do 3
				player.height = skins[player.mo.skin].height
				if not P_IsObjectOnGround(player.mo)
					player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE
					if player.panim != PA_ABILITY
						player.mo.state = S_PLAY_FALL
					end
				end
				if player.dospin
					player.pflags = $|PF_SPINNING
					player.pflags = $&~PF_STARTDASH
					player.mo.state = S_PLAY_ROLL
					S_StartSound(player.mo, sfx_spin)
				end
			end
			player.dospin = false
			player.dacrouch = false
		end
	end
end)