local function IsInZ(mobj, mo)
	if mo.z > (mobj.z+mobj.height)
		return
	end
	if (mobj.z-mobj.height) > (mo.z+mo.height)
		return
	end
	return true
end

local function GhostThink(mo)
	if mo and mo.valid
	and mo.auragh
	and mo.type == MT_GHOST
		if mo.target and mo.target.valid
		and mo.target.player and mo.target.player.valid
		and mo.target.player.playerstate == PST_LIVE
			A_CapeChase(mo, 0)
			local mobj = mo.target
			mo.sprite = mobj.sprite
			mo.sprite2 = mobj.sprite2
			mo.frame = mobj.frame
			mo.frame = $&~FF_TRANSMASK
			mo.frame = $|tr_trans70<<FF_TRANSSHIFT
			mo.blendmode = AST_ADD
			mo.skin = mobj.skin
			mo.tics = mobj.tics
			mo.flags2 = mobj.flags2
			mo.eflags = mobj.eflags
		end
	end
end
addHook("ThinkFrame", do
	for mo in mobjs.iterate()
		if mo and mo.valid
		and mo.auragh
		and mo.type == MT_GHOST
			GhostThink(mo)
		end
	end
end)

rawset(_G, "P_ParabolicMove", function(mo, px, py, pz, speed) //Arrow movement func
	local dx = px - mo.x
	local dy = py - mo.y
	local dz = pz - mo.z
	local dh = P_AproxDistance(dx, dy)
	local c = FixedDiv(1+dx, 1+dh)
	local s = FixedDiv(1+dy, 1+dh)
	local fixConst = FixedDiv(1+speed, 1+gravity)
	mo.momx = FixedMul(FixedMul(c, speed), mo.scale)
	mo.momy = FixedMul(FixedMul(s, speed), mo.scale)
	mo.momz = FixedMul((FixedDiv(1+dh, 2*(1+fixConst)) + FixedDiv(1+dz, 1+FixedDiv(1+dh, (1+fixConst)/2))), mo.scale)
end)

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "leknux"
		if player.extrabutton == nil
			player.extrabutton = BT_CUSTOM1
			local file = io.openlocal("client/knuxconfig.cfg", "r")
			if file //I/O is pretty weird. And some people made a Gameboy emulator with it
				local readresult = file:read("*l")
				player.extrabutton = readresult
				file:close()
			end
		end
		if player.tricksenabled == nil
			player.tricksenabled = true
			local file = io.openlocal("client/knuxconfig2.cfg", "r")
			if file //I/O is pretty weird. And some people made a Gameboy emulator with it
				local readresult = file:read("*l")
				player.tricksenabled = readresult
				file:close()
			end
		end
		if player.trickstype == nil
			player.trickstype = "ledges"
			local file = io.openlocal("client/knuxconfig3.cfg", "r")
			if file //I/O is pretty weird. And some people made a Gameboy emulator with it
				local readresult = file:read("*l")
				player.trickstype = readresult
				file:close()
			end
		end
		player.ghbag = $ or 0
		if not player.ptargets
			player.ptargets = {}
		end
		if player.ptargets
			for i,k in pairs(player.ptargets)
				if player.ptargets[i] and player.ptargets[i].valid
					if player.ptargets[i].health
						P_SpawnLockOn(player, player.ptargets[i], S_LOCKON1)
					else
						player.ptargets[i] = nil
					end
				end
			end
		end
		if player.ghbag
			local levang = (player.realtime%360)*ANG1
			for i = 1, player.ghbag
				local addr = FixedMul(player.mo.radius/8, cos(levang))
				
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.target = player.mo
				ghost.frame = $&~FF_TRANSMASK
				ghost.frame = $|tr_trans90<<FF_TRANSSHIFT
				if player.ghbag > 1
					if i&1
						ghost.spritexoffset = addr
					else
						ghost.spritexoffset = -addr
					end
				end
				ghost.auragh = true
				ghost.colorized = true
				ghost.blendmode = AST_ADD
				ghost.fuse = 2
			end
			if player.ghbag > 20 --You can get 10 but max is 20
				player.ghbag = 20
			end
		end
	end
end)