/*
addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "leknux"
	end
end)
*/

local function IsInZ(mobj, mo)
	if mo.z > (mobj.z+mobj.height)
		return
	end
	if (mobj.z-mobj.height) > (mo.z+mo.height)
		return
	end
	return true
end

addHook("MobjDamage", function(mo, mobj, src, dmg, dmgtype)
	if mo and mo.valid
	and mo.player and mo.player.valid
	and mo.skin == "leknux"
	and not (dmgtype & DMG_DEATHMASK)
		if mobj and mobj.valid
		and mo.player.crouching
		and dmg <= 1
		and IsInZ(mo, mobj)
		and not (mobj.type == MT_SPIKE
		or mobj.type == MT_WALLSPIKE
		or mobj.type == MT_WALLSPIKEBASE)
		and abs(mo.player.drawangle-R_PointToAngle2(
		  mo.x+P_ReturnThrustX(nil, mo.player.drawangle, -mobj.radius), 
		  mo.y+P_ReturnThrustY(nil, mo.player.drawangle, -mobj.radius), 
		  mobj.x+P_ReturnThrustX(nil, mo.player.drawangle, mo.radius), 
		  mobj.y+P_ReturnThrustY(nil, mo.player.drawangle, mo.radius))) <= ANG30
			local cancelback = 1
			if mo.player.ghbag
				cancelback = mo.player.ghbag
			end
			local addspeed = R_PointToDist2(0, 0, mo.momx, mo.momy)
			local dasped = addspeed+mobj.info.speed+5*FRACUNIT
			P_InstaThrust(mobj, mo.player.drawangle, dasped)
			P_Thrust(mo, mo.player.drawangle, (-(mobj.info.speed+5*FRACUNIT))/cancelback)
			return true
		end
		
		if mobj and mobj.valid
		and mo.player.attacking
		and IsInZ(mo, mobj)
		and abs(mo.player.drawangle-R_PointToAngle2(
		  mo.x+P_ReturnThrustX(nil, mo.player.drawangle, -mobj.radius), 
		  mo.y+P_ReturnThrustY(nil, mo.player.drawangle, -mobj.radius), 
		  mobj.x+P_ReturnThrustX(nil, mo.player.drawangle, mo.radius), 
		  mobj.y+P_ReturnThrustY(nil, mo.player.drawangle, mo.radius))) <= ANG30
			return true
		end
		if mo.player.ghbag --Lose ghosts when getting hit
			if mo.player.rings
				if mo.player.ghbag 
				and mo.player.ghbag > 1
					mo.player.ghbag = $/2
				else
					mo.player.ghbag = 0
				end
				local ghost = P_SpawnGhostMobj(mo)
				ghost.colorized = true
				ghost.fuse = TICRATE*2
				ghost.flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
				ghost.blendmode = AST_ADD
				ghost.state = S_PLAY_PAIN
				ghost.color = mo.color
				if (mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(ghost, FixedDiv(10511*FRACUNIT,2600*FRACUNIT), false)
				else
					P_SetObjectMomZ(ghost, FixedDiv(69*FRACUNIT,10*FRACUNIT), false)
				end
				P_InstaThrust(ghost, mo.player.drawangle, -5*FRACUNIT)
			else
				for i = 1, mo.player.ghbag --Do a fancy ghost scatter when dying
					local ghost = P_SpawnGhostMobj(mo)
					ghost.colorized = true
					ghost.fuse = TICRATE*2
					ghost.flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
					ghost.blendmode = AST_ADD
					if (mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER))
						ghost.state = S_PLAY_DRWN
					else
						ghost.state = S_PLAY_DEAD
					end
					ghost.color = mo.color
					P_SetObjectMomZ(ghost, 15*FRACUNIT, false)
					local ran1 = FRACUNIT
					local ran2 = FRACUNIT*15
					local ranpow = P_RandomRange(ran1>>FRACBITS, ran2>>FRACBITS) <<FRACBITS
					local ranang = P_RandomRange(0, 360)*ANG1
					P_Thrust(ghost, ranang+(P_RandomRange(-15, 15)*ANG1), ranpow)
				end
				mo.player.ghbag = 0
			end
		end
	end
end, MT_PLAYER)

addHook("MobjDamage", function(mo, mobj, src, dmg, dmgtype)
	if mo and mo.valid
	and not mo.type == MT_PLAYER --Punch nerf on players.
		if mobj and mobj.valid
			if mobj.knuxpunch
				mobj.knuxpunch = false
				P_DamageMobj(mo, mobj, src, 1)
				mo.flags2 = $&~MF2_FRET
				return false
			end
			if mobj.damageadd
				local dmgf = mobj.damageadd
				mobj.damageadd = 0
				P_DamageMobj(mo, mobj, src, dmgf)
				mo.flags2 = $&~MF2_FRET
				return false
			end
		end
	end
end)

addHook("PlayerSpawn", function(player) --Almost all knux`s variables
	if player.valid and not player.spectator 
	and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == "leknux"
		player.ghbag = 0
		player.throwrock = 0
		player.holdingrock = 0
		player.attacking = 0
		player.stopedge = $ or 0
		player.istop = false
		player.attack = false
		player.diganim = 0
		player.digwallanim = 0
		player.washolding = false
		player.crouching = false
		player.dotheflip = false
		player.nocrouch = 5
		player.throwrock = 0
		player.pleaseplayanim = false
		player.holdrock = nil
		player.dontstopspin = 0
		player.checkdigcd = 0
		player.nogroundjump = 0
		player.deggin = false
		player.deggin2 = 0
		player.mo.mirrored = false
		player.dontunflip = 0
		player.unfliptrue = 0
		player.dontstopspin = 0
		player.hasground = 0
		player.dospin = false
		player.climbspeed = 0
		player.flipclimb = false
		player.ghostchargecd = 0
		player.ptargets = {}
		player.searchnrg = 0
		player.searchcd = 0
		player.trickcombo = 0
		player.trickstate = false
		player.trickstate2 = SPR2_FALL
		player.trickstart = 0
		player.rotang = 0
		player.savemom = {}
		player.trickanim = 0
		player.stopanim = -1
		player.trickcd = 0
	end
end)