local function IsInZ(mobj, mo)
	if mo.z > (mobj.z+mobj.height)
		return
	end
	if (mobj.z-mobj.height) > (mo.z+mo.height)
		return
	end
	return true
end

rawset(_G,"IForgorWhatThisDoes", function(l) if l and l.valid and l.bruhlamp and l.target and l.target.valid then 
	P_TeleportMove(l,l.target.x,l.target.y,l.target.z+(l.target.height/2)*P_MobjFlip(l)) end 
end)

addHook("TouchSpecial", function(mobj, mo) --Grab rock
	if mobj and mobj.valid
	and mobj.knuxrock
		if mo and mo.valid
		and mo.player and mo.player.valid
		and mo.skin == "leknux"
			if mo.player.crouching
			and not mo.player.nocrouch
			and CanUse(mo.player, true)
				if not mo.player.holdingrock
					local midheg = mo.z+(mo.height/2)
					P_TeleportMove(mobj, mo.x, mo.y, midheg)
					mobj.scale = FRACUNIT
					mobj.fuse = TICRATE*5
					mo.player.holdingrock = 5
					mo.player.holdrock = mobj
					local grab = P_SpawnGhostMobj(mobj)
					grab.scale = FRACUNIT*2
					grab.destscale = FRACUNIT
					grab.colorized = true
					S_StartSound(mobj, sfx_ngjump)
				end
				return true
			end
			return true
		end
		return true
	end
end, MT_FALLINGROCK)

rawset(_G,"RockThinker", function(mo) --Rock does ghost
	if mo and mo.valid
	and mo.knuxrock
		if (leveltime%5) == 0
			local ghost = P_SpawnGhostMobj(mo)
			ghost.colorized = true
			ghost.scale = mo.scale
			ghost.spriteyoffset = mo.spriteyoffset
			ghost.destscale = FRACUNIT/6
		end
	end
end)

addHook("MobjMoveCollide", function(mo, mobj)
	if mo and mo.valid
	and mo.knuxpunch
		if mobj and mobj.valid
		and (mobj.type == MT_SPIKE
		or mobj.type == MT_WALLSPIKE
		or mobj.type == MT_WALLSPIKEBASE)
		and IsInZ(mo, mobj)
			P_KillMobj(mobj)
		end
	end
end, MT_DEMONFIRE)

rawset(_G,"KnuxPunchThink",function(mo) --Ghost stuff
	if mo and mo.valid
	and mo.ghostmis
	and mo.target and mo.target.valid
		mo.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
		if mo.tracer and mo.tracer.valid
			mo.flags2 = $|MF2_DONTDRAW
			local zoom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			zoom.color = mo.color
			zoom.blendmode = AST_ADD
			zoom.scale = FRACUNIT
			zoom.destscale = FRACUNIT/15
			zoom.scalespeed = FRACUNIT/15
			zoom.fuse = 14
			zoom.tics = 14
			P_FlyTo(mo, mo.tracer.x, mo.tracer.y, mo.tracer.z, FRACUNIT*60)
			if P_AproxDistance(P_AproxDistance(mo.tracer.x-mo.x,mo.tracer.y-mo.y),mo.tracer.z-mo.z) <= 50*FRACUNIT
				local zoom = P_SpawnMobjFromMobj(mo.tracer, 0, 0, 0, MT_THOK)
				zoom.color = mo.color
				zoom.blendmode = AST_ADD
				zoom.scale = FRACUNIT
				zoom.destscale = FRACUNIT*2
				zoom.fuse = 15
				zoom.tics = 15
				P_DamageMobj(mo.tracer, mo, mo.target, 1)
				P_KillMobj(mo)
			end
		else
			mo.ghostmis = false
			local zoom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			zoom.color = mo.color
			zoom.blendmode = AST_ADD
			zoom.scale = FRACUNIT
			zoom.destscale = FRACUNIT*2
			zoom.fuse = 15
			zoom.tics = 15
			P_KillMobj(mo)
		end
	end
end)

rawset(_G,"ChargeThinker", function(mo) --Ghost stuff
	if mo and mo.valid
	and mo.ghosten
		mo.flags = $|MF_NOGRAVITY
		mo.becomecollectable = $ or 0
		if mo.becomecollectable
			mo.becomecollectable = $ - 1
			mo.collectda = true
		else
			if mo.collectda
				if mo.tracer and mo.tracer.valid
					local zoom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
					zoom.color = mo.color
					zoom.blendmode = AST_ADD
					zoom.scale = FRACUNIT*2
					zoom.destscale = FRACUNIT
					zoom.scalespeed = FRACUNIT/15
					zoom.fuse = 14
					zoom.tics = 14
					AddToTable(zoom,N_GlobalThinkers)
					mo.dontsee = false
					mo.target = mo.tracer
				end
			end
			mo.collectda = false
		end
		mo.flags2 = $|MF2_DONTDRAW
		if mo.target and mo.target.valid
			P_FlyTo(mo, mo.target.x, mo.target.y, mo.target.z, FRACUNIT*40)
		end
		if mo.fuse < 15
			mo.scale = $-FRACUNIT/15
		else
			local zoom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			zoom.color = mo.color
			zoom.blendmode = AST_ADD
			zoom.scale = FRACUNIT
			zoom.destscale = FRACUNIT/15
			zoom.scalespeed = FRACUNIT/15
			zoom.fuse = 14
			zoom.tics = 14
			if mo.dontsee
				zoom.flags2 = $|MF2_DONTDRAW
			end
			AddToTable(zoom,N_GlobalThinkers)
		end
	end
end)

addHook("TouchSpecial", function(mobj, mo)
	if mobj and mobj.valid
	and mobj.ghosten
		if mo and mo.valid
		and mo.player and mo.player.valid
		and mobj.target and mobj.target.valid
		and mobj.target == mo
			mo.player.ghbag = $ + 1
			S_StartSound(mobj, sfx_emfind)
			local zoom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			zoom.color = mo.color
			zoom.blendmode = AST_ADD
			zoom.scale = FRACUNIT
			zoom.destscale = FRACUNIT*2
			zoom.fuse = 15
			zoom.tics = 15
			return false
		end
		if mo and mo.valid
		and mo.player and mo.player.valid
		and mobj.tracer and mobj.tracer.valid
		and mobj.tracer == mo
			mobj.becomecollectable = 15
			P_FlyTo(mobj, mobj.tracer.x, mobj.tracer.y, mobj.tracer.z, -FRACUNIT*5)
			return true
		end
		return true
	end
end, MT_THOK)

addHook("TouchSpecial", function(mobj, mo) --Dig back
	if mobj and mobj.valid
	and mobj.digdown
		if mo and mo.valid
		and mo.player and mo.player.valid
		and mo.skin == "leknux"
			if not mo.player.dotheflip
				if mo.player.crouching
					if mo.player.cmd.buttons & BT_SPIN
						mobj.flags = mobj.info.flags
						for i = 1, 6
							local ranang = ((360/6)*i)*ANG1 + P_RandomRange(-5, 5)*ANG1
							local ranx = P_ReturnThrustX(nil, ranang, mo.radius/3)
							local rany = P_ReturnThrustY(nil, ranang, mo.radius/3)
							
							local digdig = P_SpawnMobj(mobj.x+ranx, mobj.y+rany, mobj.z, MT_MINUSDIRT)
							if P_MobjFlip(mo) == -1
								digdig.flags2 = $|MF2_OBJECTFLIP
								digdig.eflags = $|MFE_VERTICALFLIP
							end
						end
						mo.player.gotodig = {
						x = mobj.digdown.x,
						y = mobj.digdown.y,
						z = mobj.digdown.z,
						extra1 = false,
						flip = flipped}
						mo.momx = 0
						mo.momy = 0
						mo.momz = 0
						mo.player.diganim = 15
						return false
					else
						mo.player.nogroundjump = 3
						return true
					end
				end
			end
		end
		return true
	end
end, MT_MINUSDIRT)