local function PunchEffects(player)
	local momang = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
	local addx1 = P_ReturnThrustX(nil, momang, player.mo.radius*2)
	local addy1 = P_ReturnThrustY(nil, momang, player.mo.radius*2)
	
	if not (leveltime&4)
		local daheg = 0
		if P_MobjFlip(player.mo) == -1
			daheg = -player.mo.height/2
		end
		local dash = P_SpawnMobjFromMobj(player.mo, 0, 0, daheg, MT_FACESTABBERSPEAR)
		dash.flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
		dash.fuse = 5
		dash.tics = 5
		dash.colorized = true
		dash.angle = player.drawangle+ANGLE_90
		dash.scale = FRACUNIT/3*2
		dash.destscale = FRACUNIT
		dash.color = player.mo.color
		dash.blendmode = AST_OVERLAY
	end
	
		local cen = P_SpawnMobjFromMobj(player.mo, addx1, addy1, 0, MT_THOK)
		cen.tics = 10
		cen.fuse = 10
		cen.destscale = FRACUNIT*2
		cen.scalespeed = FRACUNIT/10
		//cen.renderflags = $|RF_PAPERSPRITE
		cen.angle = player.drawangle
		cen.color = player.mo.color
		cen.blendmode = AST_ADD
end

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "leknux"
		player.attacking = $ or 0
		player.stopedge = $ or 0
		if player.attacking
			player.attacking = $ - 1
			player.nocrouch = 5
			player.friction = FRACUNIT/2*3
			player.pflags = $|PF_FULLSTASIS
			player.mo.state = S_PLAY_WALK
			player.mo.tics = -1
			player.mo.frame = G
			player.attack = true
			if player.speed > FRACUNIT*15 --Extendo punch
				if P_IsObjectOnGround(player.mo)
					player.attacking = 5
				elseif (player.mo.momz == 0 or ((player.mo.momz*P_MobjFlip(player.mo) <= -7*FRACUNIT) and (player.mo.momz*P_MobjFlip(player.mo) >= -8*FRACUNIT)))
					player.attacking = 0
				end
			end
			if not P_IsObjectOnGround(player.mo)
				player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE
			end
			local hit = P_SPMAngle(player.mo, MT_DEMONFIRE, player.drawangle)
			if hit and hit.valid
				hit.momx = player.mo.momx
				hit.momy = player.mo.momy
				hit.momz = player.mo.momz
				hit.fuse = 3
				hit.tics = 3
				hit.knuxpunch = true
				hit.flags2 = $|MF2_DONTDRAW
				hit.height = player.mo.height
				hit.radius = player.mo.radius/2*3
				AddToTable(hit,N_GlobalThinkers)
			end
			local goang = player.drawangle
			if player.speed
				goang = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
			else
				goang = $
			end
			player.drawangle = goang
			PunchEffects(player)
		else
			if player.attack
				player.mo.state = S_PLAY_EDGE
				player.stopedge = 5
				player.istop = true
				player.pflags = $&~PF_SPINNING
				player.friction = 29*FRACUNIT/32
				if P_IsObjectOnGround(player.mo)
					player.mo.momx = $/2
					player.mo.momy = $/2
				end
			end
			player.attack = false
		end
		if player.stopedge
			player.stopedge = $-1
			player.istop = true
			if player.mo.state != S_PLAY_EDGE
				player.mo.state = S_PLAY_EDGE
			end
			player.pflags = $|PF_FULLSTASIS
			if not P_IsObjectOnGround(player.mo)
				player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE
			end
		else	
			if player.istop
				player.pflags = $|PF_JUMPSTASIS
				if not P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_FALL
				else
					player.mo.state = S_PLAY_STND
				end
			end
			player.istop = false
		end
	end
end)