local function FindGhostTargets(player)
	local closestmo = nil
	local maxdist = 2048*FRACUNIT
	local mindist = 150*FRACUNIT
	local span = ANGLE_90
	local dist = 0
	local closestdist = 0
	local table = {}
	
	for mo in mobjs.iterate()
		if (mo.flags & MF_NOCLIPTHING) then continue end
		if (mo.health <= 0) then continue end
		
		if not (mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) and (mo.flags & MF_SHOOTABLE)) then continue end
		
		if (mo == player.mo) then continue end
		if (mo.flags2 & MF2_FRET) then continue end
		
			
		local zdist = (player.mo.z+player.mo.height/2) - (mo.z+mo.height/2)
		dist = P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y)
		if (abs(R_PointToAngle(mo.x, mo.y) - player.mo.angle) > ANGLE_45) then continue end
		
		dist = P_AproxDistance(dist, zdist)
		if (dist > maxdist) then continue end
		if (dist < mindist) then continue end
		
		if (player.mo.flags2 & MF2_TWOD) and (abs(player.mo.y-mo.y) > player.mo.radius) then continue end
		if mo.player and mo.player.valid
			local p = mo.player
			if p and p.valid
			and p.playerstate == PST_LIVE
			and p.powers[pw_carry] != CR_NIGHTSMODE
			and not p.spectator
				if not mo
					return true
				end
				if (gametyperules & GTR_FRIENDLYFIRE)
				or friendlyfire
					return true
				else
					if (gametyperules & GTR_FRIENDLY)
						return false
					else
						if player and player.valid
							if (gametyperules & GTR_TEAMS)
								if player.ctfteam == p.ctfteam
									return false
								else
									return true
								end
							else
								return true
							end
						else
							return true
						end
					end
				end
			end
		end
		--if (closestmo and dist > closestdist) then continue end
		
		if not P_CheckSight(player.mo, mo) then continue end
		
		if table
		and not table[#table+1]
		and #table <= player.ghbag
			table[#table+1] = mo
		end
		
		closestmo = mo
		closestdist = dist
	end
	return table
end

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "leknux"
		player.attackcd = $ or 0
		if player.attackcd
			player.attackcd = $ - 1
		end
		if player.cmd.buttons & BT_SPIN --Punch
			if not player.punch
			and not player.crouching
			and not player.attackcd
			and player.speed >= FRACUNIT
			and not player.exiting
			and not player.diganim
			and not player.climbing
			and not player.holdingrock
			and not player.climbing2
			and not player.trickstate
			and CanUse(player)
				/*if (player.powers[pw_shield]
				and P_IsObjectOnGround(player.mo))
				or (not player.powers[pw_shield])*/
					local cmdang = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
					player.attacking = 15
					P_Thrust(player.mo, cmdang, 15*FRACUNIT)
					player.drawangle = cmdang
					player.attackcd = 30
					if player.ghbag
						local targ = FindGhostTargets(player)
						if targ
							player.ptargets = targ
							player.ghbag = $-(#targ)
							for k,v in pairs(targ)
								if v and v.valid
								and v.health
									local ghm = P_SpawnMissile(player.mo, v, MT_DEMONFIRE) 
									if ghm and ghm.valid
										ghm.target = player.mo
										ghm.tracer = v
										ghm.state = S_THOK
										ghm.fuse = TICRATE*10
										ghm.tics = TICRATE*10
										if CBW_Battle
											ghm.tics = 15
											ghm.fuse = 15
										end
										ghm.blendmode = AST_ADD
										ghm.color = player.mo.color
										ghm.ghostmis = true
										AddToTable(ghm,N_GlobalThinkers)
									end
								end
							end
						end
					end
				//end
			end
			if not player.punch --Grab rock
			and not player.crouching
			and player.speed < FRACUNIT
			and not player.attackcd
			and P_IsObjectOnGround(player.mo)
			and not player.exiting
			and not player.diganim
			and not player.climbing
			and not player.holdingrock
			and not player.climbing2
			and not player.trickstate
			and CanUse(player)
				for i = 1, 6
					local ranang = ((360/6)*i)*ANG1 + P_RandomRange(-5, 5)*ANG1
					local ranx = P_ReturnThrustX(nil, ranang, player.mo.radius/3)
					local rany = P_ReturnThrustY(nil, ranang, player.mo.radius/3)
							
					local digdig = P_SpawnMobjFromMobj(player.mo, ranx, rany, 0, MT_MINUSDIRT)
				end
				local rock = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_FALLINGROCK)
				rock.target = player.mo
				rock.tracer = player.mo
				rock.flags = MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE|MF_SPECIAL
				rock.fuse = TICRATE*5
				rock.knuxrock = true
				rock.color = player.mo.color
				AddToTable(rock,N_GlobalThinkers)
				--rock.hasghost = true
				rock.scale = FRACUNIT
				if player.dotheflip
					if P_MobjFlip(player.mo) == 1
						rock.flags2 = $|MF2_OBJECTFLIP
						rock.eflags = $|MFE_VERTICALFLIP
					else
						rock.flags2 = $&~MF2_OBJECTFLIP
						rock.eflags = $&~MFE_VERTICALFLIP
					end
				end
				if gametyperules & GTR_TEAMS
					rock.colorized = true
				end
				P_SetObjectMomZ(rock, FRACUNIT*7, true)
				rock.destscale = FRACUNIT/3
				rock.scalespeed = FRACUNIT/TICRATE/5
							
				S_StartSound(player.mo, sfx_crumbl)
				player.attackcd = TICRATE*2
			end
			player.punch = true
		else	
			player.punch = false
		end
	end
end)