local function DoTrick(player)
	player.starttrick = 0
	if player.trickcombo
		player.trickcombo = $ + 1
	else
		player.trickcombo = 1
	end
	local rantrick = {SPR2_SPNG,SPR2_ROLL,SPR2_GLID,SPR2_LAND,SPR2_SPIN,SPR2_WALK,SPR2_RIDE,SPR2_EDGE,SPR2_GASP,SPR2_PAIN}
	local ranframes = {[SPR2_PAIN] = 1,[SPR2_GASP] = 1,[SPR2_SPNG] = 1,[SPR2_ROLL] = -1,[SPR2_GLID] = 1,
		[SPR2_LAND] = 1,[SPR2_SPIN] = -1,[SPR2_WALK] = 8,[SPR2_RIDE] = 1,[SPR2_EDGE] = -1}
	local fincd = 5-(player.trickcombo/5)
	if fincd < 1
		fincd = 1
	end
	player.trickcd = fincd
	S_StartSound(player.mo, sfx_kc48)
			
	if (player.mo.eflags & MFE_UNDERWATER)
		P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/8)*P_MobjFlip(player.mo), true)
	else
		P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/4)*P_MobjFlip(player.mo), true)
	end
			
	local trickstatefr = rantrick[P_RandomRange(1, #rantrick)]
	player.mo.state = S_KNUX_TRICK
	player.mo.sprite2 = trickstatefr
	player.trickstate2 = trickstatefr
	if ranframes and ranframes[player.mo.sprite2]
		if ranframes[player.mo.sprite2] == -1
			player.stopanim = -1
			player.mo.frame = 0
		elseif ranframes[player.mo.sprite2] > 0
			if ranframes[player.mo.sprite2] > 1
				player.stopanim = P_RandomRange(1, ranframes[player.mo.sprite2])
				player.mo.frame = player.stopanim-1
			else
				player.stopanim = 1
				player.mo.frame = 0
			end
		end
		player.mo.tics = TICRATE
		player.trickanim = TICRATE
	end
	
	if (gametyperules & GTR_FRIENDLY)
		P_AddPlayerScore(player, 10) --Small amount because you can spam this very easily
	end
	player.drawangle = P_RandomRange(0, 360)*ANG1
	if P_RandomRange(1, 2) == 1
		player.rotang = -1
	else
		player.rotang = 1
	end
	local tricksc = player.trickcombo
	if player.trickcombo > TICRATE
		tricksc = TICRATE
	end
	for i = 1, tricksc
		local addr = P_RandomRange(0, player.mo.radius>>FRACBITS)<<FRACBITS
		local adda = P_RandomRange(0, 360)*ANG1
		local addx = P_ReturnThrustX(nil, adda, addr)
		local addy = P_ReturnThrustY(nil, adda, addr)
		local addz = P_RandomRange(0, player.mo.height>>FRACBITS)<<FRACBITS
		local s = P_SpawnMobjFromMobj(player.mo, addx, addy, addz, MT_THOK)
		s.state = S_NIGHTSPARKLE1
		s.tics = 15
		s.fuse = 15
		s.color = player.mo.color
		s.colorized = true
		s.blendmode = AST_ADD
		s.momx = player.mo.momx
		s.momy = player.mo.momy
		s.momz = player.mo.momz
		local mx = player.mo.x
		local my = player.mo.y
		local mz = player.mo.z+player.mo.height/2
		local aprx = P_AproxDistance(P_AproxDistance(mx-s.x,my-s.y),mz-s.z)
		P_FlyTo(s, player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, -aprx/5, true)
	end
end

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "leknux"
		local function GetTricktype(player)
			if player.trickstype == "never"
				return 0
			end
			if player.trickstype == "springs"
				if ((player.mo.eflags & MFE_SPRUNG)
				and not player.powers[pw_justlaunched])
				or player.springed
					return 1
				else
					return 0
				end
			elseif player.trickstype == "ledges"
				if not P_IsObjectOnGround(player.mo)
				and not player.springed
				and not (player.mo.eflags & MFE_SPRUNG)
				and (not (player.pflags & PF_JUMPED)
				or player.powers[pw_justlaunched])
					return 2
				else
					return 0
				end
			elseif player.trickstype == "always"
				if not P_IsObjectOnGround(player.mo)
				and (not (player.pflags & PF_JUMPED)
				or player.powers[pw_justlaunched]
				or (player.mo.eflags & MFE_SPRUNG)
				or player.springed)
					return 3
				else
					return 0
				end
			end
			return 0
		end
		if P_IsObjectOnGround(player.mo) --Frontiers trick stuff
		or player.powers[pw_carry]
		or (player.pflags & PF_JUMPED)
		or P_PlayerInPain(player)
		or not GetTricktype(player)
		or not CanUse(player)
			player.trickstate = false
			player.trickstate2 = SPR2_FALL
			player.trickanim = 0
			player.stopanim = -1
			player.trickcd = 0
			player.trickcombo = 0
			if player.trickstype == "springs"
				player.springed = false
			end
			player.notricks = false
		end
		player.trickcombo = $ or 0
		player.stopanim = $ or -1
		player.trickanim = $ or 0
		player.starttrick = $ or 0
		player.trickcd = $ or 0
		if player.trickcd then player.trickcd = $-1 end
 		if player.starttrick then player.starttrick = $-1 end
		if player.trickanim
			player.trickanim = $ - 1
			if player.mo.state == S_KNUX_TRICK
				if player.trickstate2
					if player.mo.sprite2 != player.trickstate2
						player.mo.sprite2 = player.trickstate2
					end
				end
				if player.stopanim
				and player.stopanim > 0
					player.mo.frame = player.stopanim-1
				end
			else
				player.mo.state = S_KNUX_TRICK
			end
		end
		local function AlwaysOrLedges(player)
			if not player.climbing
			and not player.glidetime
			and not (player.pflags & PF_THOKKED)
			and not (player.cmd.buttons & BT_JUMP)
			and not (player.cmd.buttons & BT_SPIN)
			and not player.trickstate
			and not P_PlayerInPain(player)
			and player.tricksenabled
			and player.trickstype
			and not player.dotheflip
			and not player.notricks
			and CanUse(player)
			and GetTricktype(player)
			and player.bot != 1
				return true
			end
			return false
		end
		if AlwaysOrLedges(player)
		and CanUse(player)
			if (player.mo.eflags & MFE_SPRUNG)
				player.springed = true
			end
			player.trickstate = true
			player.savemom = {
			x = player.mo.momx,
			y = player.mo.momy,
			a = player.drawangle}
			player.trickanim = 2
			if (player.pflags & PF_SPINNING)
				player.starttrick = 15
			else
				player.starttrick = 0
			end
			player.stopanim = -1
			player.trickcd = 0
		end
		
		if player.trickstate
		and player.tricksenabled
		and player.trickstype
		and CanUse(player)
			player.pflags = $|PF_THOKKED & ~PF_SPINNING
			if player.savemom
				--player.mo.momx = player.savemom.x
				--player.mo.momy = player.savemom.y
				if not player.trickanim
					player.drawangle = player.savemom.a
				end
			end
			if player.starttrick
				player.mo.state = S_PLAY_ROLL
			end
			player.nocrouch = 5
			for i = 1, 2
				local addx = P_ReturnThrustX(nil, player.drawangle+ANGLE_90+ANGLE_180*i, player.mo.radius)
				local addy = P_ReturnThrustY(nil, player.drawangle+ANGLE_90+ANGLE_180*i, player.mo.radius)
				local stars = P_SpawnMobjFromMobj(player.mo, addx, addy, (player.mo.height/3*2), MT_THOK)
				stars.state = S_NIGHTSPARKLE1
				stars.tics = TICRATE
				stars.fuse = TICRATE
				stars.color = player.mo.color
				stars.colorized = true
			end
			if (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/4)*P_MobjFlip(player.mo), true)
			else
				P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/2)*P_MobjFlip(player.mo), true)
			end
			if not player.trickanim
			and not player.starttrick
				if player.mo.momz*P_MobjFlip(player.mo) > 0
					if player.mo.state != S_PLAY_SPRING
						player.mo.state = S_PLAY_SPRING
					end
				else
					if player.mo.state != S_PLAY_FALL
						player.mo.state = S_PLAY_FALL
					end
				end
			elseif player.rotang
				player.drawangle = $+(player.rotang*(ANG1*5))
			end
			
			if (player.cmd.buttons & BT_JUMP)
			or (player.cmd.buttons & BT_SPIN)
			or (player.extrabutton and (player.cmd.buttons & player.extrabutton))
				player.trickstate = false
				player.pflags = $|PF_JUMPED
				player.pflags = $&~(PF_THOKKED|PF_NOJUMPDAMAGE)
				player.mo.state = S_PLAY_JUMP
				if (player.cmd.buttons & BT_JUMP) --Only add height if jump is pressed
					if player.mo.momz*P_MobjFlip(player.mo) >= 0
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, true)
						else
							P_SetObjectMomZ(player.mo, 12*FRACUNIT, true)
						end
					else
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_SetObjectMomZ(player.mo, 12*FRACUNIT, false)
						end
					end
				end
				S_StartSound(player.mo, sfx_hidden)
				if (gametyperules & GTR_FRIENDLY)
					P_AddPlayerScore(player, 100)
				end
				local l = P_SpawnMobjFromMobj(player.mo, 0, 0, (player.mo.height/2), MT_THOK)
				l.target = player.mo
				l.state = S_OILLAMPFLARE
				l.scale = FRACUNIT
				l.destscale = FRACUNIT/2
				l.scalespeed = FRACUNIT/16
				l.blendmode = AST_ADD
				l.fuse = 16
				l.colorized = true
				l.color = player.mo.color
				l.bruhlamp = true
				AddToTable(l,N_GlobalThinkers)
			end
		end
	end
end)

addHook("PreThinkFrame", do --i do the weird again
	for player in players.iterate()
		if player.valid and player.playerstate == PST_LIVE
		and not player.spectator and player.powers[pw_carry] != CR_NIGHTSMODE
		and player.mo.skin == "leknux"
			if player.trickstate
			and player.tricksenabled
			and player.trickstype
			and CanUse(player)
				if player.cmd.forwardmove
				and not player.cmd.sidemove
					if (player.cmd.forwardmove >= 25)
					or (player.cmd.forwardmove <= -25)
						if not player.forwtrick
						and not player.trickcd
							DoTrick(player)
						end
						player.forwtrick = true
					else
						player.forwtrick = false
					end
				else
					player.forwtrick = false
				end
				if player.cmd.sidemove
				and not player.cmd.forwardmove
					if (player.cmd.sidemove >= 25)
					or (player.cmd.sidemove <= -25)
						if not player.sidetrick
						and not player.trickcd
							DoTrick(player)
						end
						player.sidetrick = true
					else
						player.sidetrick = false
					end
				else
					player.sidetrick = false
				end
				if player.cmd.forwardmove
				and player.cmd.sidemove
					if ((player.cmd.forwardmove >= 25)
					or (player.cmd.forwardmove <= -25))
					and ((player.cmd.sidemove >= 25)
					or (player.cmd.sidemove <= -25))
						if not player.diagtrick
						and not player.trickcd
							DoTrick(player)
						end
						player.diagtrick = true
					else
						player.diagtrick = false
					end
				else
					player.diagtrick = false
				end
				--In Frontiers the tricks dont actually restrict your movement.
				//player.cmd.forwardmove = 0
				//player.cmd.sidemove = 0
			end
		end
	end
end)