rawset(_G, "P_FlyTo", function(mo, fx, fy, fz, sped, addques) --A very useful command honestly.
	if mo.valid
		local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
		if flyto < 1
			flyto = 1
		end
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
		
		if addques
			mo.momx = $ + FixedMul(FixedDiv(fx - mo.x, flyto), sped)
			mo.momy = $ + FixedMul(FixedDiv(fy - mo.y, flyto), sped)
			mo.momz = $ + FixedMul(FixedDiv(fz - mo.z, flyto), sped)
		else
			mo.momx = FixedMul(FixedDiv(fx - mo.x, flyto), sped)
			mo.momy = FixedMul(FixedDiv(fy - mo.y, flyto), sped)
			mo.momz = FixedMul(FixedDiv(fz - mo.z, flyto), sped)
		end	
	end	
end) 

freeslot("SPR_FLPR")
for i = 1,4
	freeslot("S_PARTNERFLIP"..i)
end
states[S_PARTNERFLIP1] = {SPR_FLPR, A|FF_FULLBRIGHT, 2, nil, 0, 0, S_PARTNERFLIP2}
states[S_PARTNERFLIP2] = {SPR_FLPR, B|FF_FULLBRIGHT, 2, nil, 0, 0, S_PARTNERFLIP3}
states[S_PARTNERFLIP3] = {SPR_FLPR, C|FF_FULLBRIGHT, 2, nil, 0, 0, S_PARTNERFLIP4}
states[S_PARTNERFLIP4] = {SPR_FLPR, D|FF_FULLBRIGHT, 2, nil, 0, 0, S_PARTNERFLIP1}

local function DrawLine(mo,mobj,x1,y1,z1,x2,y2,z2)
	local onem = z1
	local twom = z2
	
	local cd = R_PointToDist2(x1,y1,x2,y2)
	local ca = R_PointToAngle2(x1,y1,x2,y2)
	local cdz = twom-onem
	local caz = R_PointToAngle2(0, 0, cd, cdz)
	local cad = P_AproxDistance(P_AproxDistance(x2-x1,y2-y1),twom-onem)
	
	local cf = cad/FRACUNIT/10
	if cf > 100
		cf = 100
	end
	for i = 1, cf
		local cx = P_ReturnThrustX(nil, ca, (cd/cf)*i)
		local cy = P_ReturnThrustY(nil, ca, (cd/cf)*i)
		local cz = (cdz/cf)*i
	
		local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_PARTICLE)
		P_TeleportMove(t, x1+cx, y1+cy, onem+cz)
		t.state = S_PARTNERFLIP1
		t.fuse = 2
		if i < cf/2
			t.color = mo.color
			t.scale = (FRACUNIT/cf)*(cf-i)
		else
			t.color = mobj.color
			t.scale = (FRACUNIT/cf)*i
		end
		t.colorized = true
	end
end

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and not player.spectator
	and player.powers[pw_carry] != CR_NIGHTSMODE and player.mo
		local s = player.powers[pw_shield]
		local f = s&SH_NOSTACK
		if f == SH_WHIRLWIND
			player.againjump = $ or 0
			player.plusjump = $ or 0
			if player.plusjump > 50
				player.plusjump = 50
			end
			if P_IsObjectOnGround(player.mo)
				if player.againjump 
					player.againjump = $-1 
					player.nomorejumps = true
				end
			elseif player.plusjump
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.fuse = player.plusjump
				ghost.colorized = true
				ghost.scalespeed = (player.mo.scale*2)/player.plusjump
				ghost.scale = player.mo.scale
				ghost.destscale = player.mo.scale/player.plusjump
				if ghost.tracer and ghost.tracer.valid
					local t = ghost.tracer
					t.fuse = player.plusjump
					t.colorized = true
					t.scalespeed = (player.mo.scale*2)/player.plusjump
					t.scale = player.mo.scale
					t.destscale = player.mo.scale/player.plusjump
				end
			end
			if not player.againjump
			and player.nomorejumps
				player.nomorejumps = false
				player.plusjump = 0
			end
			if (player.pflags & PF_JUMPED)
				if not player.jumpin
				and player.againjump
					player.plusjump = $+1
					P_SetObjectMomZ(player.mo, player.plusjump*(FRACUNIT/4), true)
					player.againjump = 10
				end
				player.jumpin = true
			else
				if player.jumpin
				and P_IsObjectOnGround(player.mo)
					if player.plusjump
						player.mo.state = S_PLAY_BOUNCE_LANDING
					end
					if player.speed >= player.runspeed/2
						player.againjump = 8
					else
						player.againjump = 4
					end
				end
				player.jumpin = false
			end
		end
		if player.pflags & PF_JUMPED
		and (f or player.powers[pw_super])
		and not (player.mo.state >= 59 and player.mo.state <= 64)
			local t = P_LookForEnemies(player,true,false)
			if f == SH_ATTRACT
			and t and t.valid
				P_SpawnLockOn(player, t, S_LOCKON2)
			end
			if player.shieldbutton and player.cmd.buttons & player.shieldbutton
			and CanUse(player)
			and not (player.pflags & (PF_SHIELDABILITY|PF_THOKKED))
			and not player.bashstate
			and not P_SuperReady(player)
			and not player.powers[pw_super]
				if s & SH_FORCE
					local x = -player.mo.momx
					local y = -player.mo.momy
					local z = player.mo.height+(player.mo.momz*P_MobjFlip(player.mo))*2
					player.curve = P_SpawnMobjFromMobj(player.mo,x,y,z,MT_THOK)
					local c = player.curve
					c.color = player.mo.color
					c.fuse = TICRATE*5
					c.tics = TICRATE*5
					local cx = c.x-player.mo.x
					local cy = c.y-player.mo.y
					local cz = (c.z+c.height/2)-(player.mo.z+player.mo.height/2)
					local zd = P_AproxDistance(P_AproxDistance(cx,cy),cz)
					player.rad = 70*FRACUNIT
					player.curvethok = (TICRATE*5) - 2
					S_StartSound(player.mo, sfx_thok)
					player.usespring = true
					player.pflags = $|PF_THOKKED
				end
				if f == SH_WHIRLWIND
				or f == SH_THUNDERCOIN
					player.usespring = true
					P_DoJumpShield(player)
				end
				if f == SH_ARMAGEDDON
					player.usespring = true
					player.pflags = $|PF_THOKKED|PF_SHIELDABILITY
					P_BlackOw(player)
				end
				if f == SH_ATTRACT
					player.usespring = true
					player.pflags = $|PF_THOKKED|PF_SHIELDABILITY
					player.homing = 2
					if t and t.valid
						player.mo.target = t
						player.mo.tracer = t
						P_HomingAttack(player.mo,player.mo.target)
						player.mo.angle = R_PointToAngle2(player.mo.x,player.mo.y,t.x,t.y)
						player.pflags = $&~PF_NOJUMPDAMAGE
						player.mo.state = S_PLAY_ROLL
						S_StartSound(player.mo, sfx_s3k40)
						player.homing = 3*TICRATE
					else
						S_StartSound(player.mo, sfx_s3ka6)
					end
				end
				if f == SH_BUBBLEWRAP
				or f == SH_ELEMENTAL
					local elem = ((player.powers[pw_shield]&SH_NOSTACK) == SH_ELEMENTAL)
					player.pflags = $|PF_THOKKED|PF_SHIELDABILITY
					if elem
						player.mo.momx = 0
						player.mo.momy = 0
						S_StartSound(player.mo, sfx_s3k43)
					else
						player.mo.momx = $-(player.mo.momx/3)
						player.mo.momy = $-(player.mo.momy/3)
						player.pflags = $&~(PF_NOJUMPDAMAGE|PF_SHIELDABILITY)
						player.mo.state = S_PLAY_ROLL
						S_StartSound(player.mo,sfx_s3k44)
					end
					player.secondjump = 0
					P_SetObjectMomZ(player.mo, -24*FRACUNIT, false)
				end
				if f == SH_FLAMEAURA
					player.pflags = $|PF_THOKKED|PF_SHIELDABILITY
					P_Thrust(player.mo, player.mo.angle, FixedMul(30*FRACUNIT-FixedSqrt(FixedDiv(player.speed,player.mo.scale)),player.mo.scale))
					player.drawangle = player.mo.angle
					player.pflags = $&~PF_NOJUMPDAMAGE
					player.mo.state = S_PLAY_ROLL
					S_StartSound(player.mo,sfx_s3k43)
				end
			end
			
			if player.shieldbutton and player.cmd.buttons & player.shieldbutton
			and CanUse(player)
			and not player.bashstate
			and player.powers[pw_super]
				if player.speed > 5*player.mo.scale
				and (P_MobjFlip(player.mo)*player.mo.momz <= 0 or player.secondjump)
					if player.speed >= FixedMul(player.runspeed,player.mo.scale)
						if player.mo.state != S_PLAY_FLOAT_RUN
							player.mo.state = S_PLAY_FLOAT_RUN
						end
					else
						if player.mo.state != S_PLAY_FLOAT
							player.mo.state = S_PLAY_FLOAT
						end
					end
					player.mo.momz = 0
					player.pflags = $&~(PF_STARTJUMP|PF_SPINNING)
					player.secondjump = 1
					
					local superfloat = 15*FRACUNIT
					local floataccel = FRACUNIT
					if player.cmd.buttons & BT_JUMP
						if P_MobjFlip(player.mo)*player.mo.momz <= FixedMul(superfloat,player.mo.scale)
							P_SetObjectMomZ(player.mo, floataccel, true)
						end
					end
					if player.cmd.buttons & BT_SPIN
						if P_MobjFlip(player.mo)*player.mo.momz >= -FixedMul(superfloat,player.mo.scale)
							P_SetObjectMomZ(player.mo, -floataccel, true)
						end
					end
				end
			end
		end
		if player.shieldbutton and player.cmd.buttons & player.shieldbutton
		and CanUse(player)
		and not P_IsObjectOnGround(player.mo)
		and not player.powers[pw_carry]
		and player.curvethok
		and player.pflags & PF_THOKKED
			player.curvethok = $-1
			if player.curvethok
			and player.curve and player.curve.valid
				local c = player.curve
				local cx = c.x-player.mo.x
				local cy = c.y-player.mo.y
				local cz = (c.z+c.height/2)-(player.mo.z+player.mo.height/2)
				local zd = P_AproxDistance(P_AproxDistance(cx,cy),cz)
				local rad = 70*FRACUNIT
				if player.rad
					rad = player.rad
				end
				
				local fx = c.x
				local fy = c.y
				local fz = c.z+c.height/2
				if zd > rad
					P_FlyTo(player.mo,fx,fy,fz,abs(zd-rad)/15,true)
				end
				player.usespring = true
				player.pflags = $|PF_THOKKED|PF_JUMPED|PF_NOJUMPDAMAGE
				if player.mo.state != S_PLAY_RIDE
					player.mo.state = S_PLAY_RIDE
				end
				local cang = R_PointToAngle2(player.mo.x,player.mo.y,c.x,c.y)
				player.drawangle = cang
				
				local rz = (player.mo.height/2)
				local pz = (c.height/2)
				DrawLine(player.mo,c,player.mo.x+player.mo.momx,player.mo.y+player.mo.momy,player.mo.z+player.mo.momz+rz,c.x+c.momx,c.y+c.momy,c.z+c.momz+pz)
			end
			player.docurve = true
		else
			if player.docurve
				if not P_IsObjectOnGround(player.mo)
					player.usespring = true
					player.pflags = $|PF_THOKKED|PF_JUMPED
					player.pflags = $&~PF_NOJUMPDAMAGE
					player.mo.state = S_PLAY_JUMP
				end
				if player.curve and player.curve.valid
					player.curve.tics = 10
				end
			end
			player.docurve = false
		end
	end
end)