freeslot("SPR_DRUN", "S_DASHRUN")
states[S_DASHRUN] = {SPR_DRUN,A|FF_PAPERSPRITE,2,nil,0,0,S_NULL}

local DASHMAX = TICRATE*10
local DASHTHR = TICRATE/2*5
local TICFORFU = 20
local MAXSPEED = 100*FRACUNIT

local function SpeedHackCheck(player)
	if player.spedhack
		return true
	else	
		if (player.pflags & PF_SPINNING)
			return false
		else
			return true
		end
	end
end

rawset(_G, "DoSpindashDust", function(player)
	for i = 1, (leveltime%7)/2
		local p = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
		if player.mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER)
			p.state = S_SPINDUST_BUBBLE1
		elseif (player.powers[pw_shield] == SH_ELEMENTAL)
			p.state = S_SPINDUST_FIRE1
		end
		p.target = player.mo
		p.scale = (2*player.mo.scale)/3
		if P_MobjFlip(player.mo) == -1
			P_TeleportMove(p, p.x, p.y, player.mo.z+player.mo.height-p.height)
		end
		local pr = {}
		pr[0] = P_RandomFixed()<<2
		pr[1] = P_RandomRange(-30, 30)
		pr[2] = P_RandomFixed()<<3
		P_SetObjectMomZ(p, player.dashspeed/50+pr[0], false)
		P_InstaThrust(p,
			player.drawangle + (pr[1]*ANG1),
			-FixedMul(player.dashspeed/12+FRACUNIT+pr[2], player.mo.scale))
		P_TryMove(p, p.x+p.momx, p.y+p.momy, true)
	end
end)

addHook("PlayerThink", function(player) --Simple dashmode.
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		player.dashsped = $ or 0
		player.speedhackactivated = $ or 0
		player.speedhackdeactivated = $ or 0
		if player.speedhackactivated
			player.speedhackactivated = $ - 1
		end
		if player.speedhackdeactivated
			player.speedhackdeactivated = $ - 1
		end
		local runsped = player.speed >= FixedMul(player.runspeed, player.mo.scale)
		if player.mo.eflags & MFE_UNDERWATER
			runsped = player.speed >= FixedMul(player.runspeed, player.mo.scale)>>1
		else
			runsped = player.speed >= FixedMul(player.runspeed, player.mo.scale)
		end
		if not (player.gotflag)
		and not (player.powers[pw_carry])
		and not (player.exiting)
		and not (maptol & TOL_NIGHTS)
		and not player.cyl
			if runsped and P_IsObjectOnGround(player.mo)
			and not player.gotflagdebuff
				if player.dashsped < DASHMAX
					player.dashsped = $ + 1
					player.goingdown = false
					player.goinfest = 0
				end
				if player.dashsped == DASHTHR
					player.dashsped = $ + 1
					S_StartSound(player.mo, sfx_3db16)
				end
			end
			if not runsped
			and not player.bashstate
			and not player.nobash
				if player.dashsped
					if player.dashsped > DASHTHR+2
						player.dashsped = DASHTHR+1
					else
						player.dashsped = $ - 1
					end	
					if player.dashsped == DASHTHR
						player.dashsped = $ - 1
						player.normalspeed = skins[player.mo.skin].normalspeed
						player.jumpfactor = skins[player.mo.skin].jumpfactor
						player.charflags = $ & ~SF_RUNONWATER
						S_StartSound(player.mo, sfx_cdfm17)
					end
				end
			end
			if player.dashsped >= DASHTHR/4*3
				if (player.cmd.forwardmove or player.cmd.sidemove)
				and player.dashsped >= DASHTHR
				and runsped and SpeedHackCheck(player)
				and (P_IsObjectOnGround(player.mo))
					local cmdangle = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
					P_Thrust(player.mo, cmdangle, FRACUNIT/2)
				end
			end
			if player.dashsped >= DASHTHR
				player.charflags = $|SF_RUNONWATER
			end
			if player.dashsped < DASHTHR/4*3
				if P_IsObjectOnGround(player.mo)
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.jumpfactor = skins[player.mo.skin].jumpfactor
				end
			elseif P_IsObjectOnGround(player.mo)
				if player.dashsped >= DASHTHR + 5*TICRATE
					if player.normalspeed < MAXSPEED
						player.normalspeed = $ + FRACUNIT/TICFORFU
					end
					if player.jumpfactor < FixedMul(skins[player.mo.skin].jumpfactor, 5*FRACUNIT/4)
						player.jumpfactor = $ + FRACUNIT/500
					end
				end
				player.airwalk = false
				if runsped
					if player.powers[pw_shield] == SH_ELEMENTAL --This shit`s so annoying
					and (gametyperules & GTR_FRIENDLY)
						P_ElementalFire(player, false)
					end
					if not player.powers[pw_super]
						DoSpindashDust(player)
					else
						if not (leveltime&7)
							local d = P_SpawnMobjFromMobj(player.mo,0,0,player.mo.height/2,MT_PARTICLE)
							d.state = S_SPRK3
							d.frame = S
							d.tics = 15
							d.fuse = 15
							d.scale = player.mo.scale
							d.destscale = player.mo.scale/2*3
							d.renderflags = $|RF_PAPERSPRITE
							d.angle = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)+ANGLE_90
						end
					end
					if player.dashsped >= DASHTHR
						local ghost = P_SpawnGhostMobj(player.mo)
						ghost.fuse = 2
						if ghost.tracer and ghost.tracer.valid
							ghost.tracer.fuse = 2
						end
					end
				end
			end
			if player.normalspeed >= MAXSPEED-(2*FRACUNIT)
			and player.speed >= FixedMul(player.mo.scale,MAXSPEED-(10*FRACUNIT))
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.fuse = 3
				if ghost.tracer and ghost.tracer.valid
					ghost.tracer.fuse = 3
				end
				if player.panim == PA_RUN
				and not player.powers[pw_super]
					player.mo.sprite2 = SPR2_DASH
					player.mo.tics = 3
				end
			end
		elseif player.dashmode
			player.normalspeed = skins[player.mo.skin].normalspeed
			player.jumpfactor = skins[player.mo.skin].jumpfactor
			S_StartSound(player.mo, sfx_cdfm17)
		end
		if player.speed >= MAXSPEED/3*2
		and player.panim == PA_RUN
		and not player.powers[pw_super]
			player.mo.sprite2 = SPR2_DASH
			player.mo.tics = 3
		end
		if player.mo.sprite2 == SPR2_DASH
			for a = 1,5
				for i = 0,1
					local momr = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
					if (player.speed<FRACUNIT)
						momr = player.drawangle
					end
					local ar = FRACUNIT*a
					local ax = P_ReturnThrustX(nil,momr+ANGLE_90+(ANGLE_180*i), player.mo.radius/2+ar)
					local ay = P_ReturnThrustY(nil,momr+ANGLE_90+(ANGLE_180*i), player.mo.radius/2+ar)
					local az = 0
					if P_MobjFlip(player.mo) == -1 az = player.mo.height end
					local dr = P_SpawnMobj(player.mo.x+ax,player.mo.y+ay,player.mo.z+az,MT_PARTICLE)
					if P_MobjFlip(player.mo) == -1
						dr.flags2 = $|MF2_OBJECTFLIP
						dr.eflags = $|MFE_VERTICALFLIP
					end
					dr.scale = player.mo.scale/4*5
					dr.spriteyscale = FRACUNIT+FixedMul(FRACUNIT/10, cos((leveltime%360)*FixedAngle(player.speed)))
					dr.state = S_DASHRUN
					dr.color = SKINCOLOR_RED
					dr.angle = momr
					dr.momx = player.mo.momx
					dr.momy = player.mo.momy
					dr.momz = player.mo.momz
					if i == 0
						dr.angle = $-ANG10
					else
						dr.angle = $+ANG10
					end
				end
			end
		end
	end
end)