freeslot("MT_BASHCOLLIDE")
mobjinfo[MT_BASHCOLLIDE] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1,
	reactiontime = 5,
	speed = 36*FRACUNIT,
	radius = 124*FRACUNIT,
	height = 74*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 1,
	flags = MF_NOGRAVITY
}

local function IsInZ(mobj, mo)
	if mo.z > (mobj.z+mobj.height)
		return
	end
	if (mobj.z-mobj.height) > (mo.z+mo.height)
		return
	end
	return true
end

freeslot("MT_TARGETDUMMY")
local function AcceptThose(mo)
	if mo.type == MT_TARGETDUMMY
		return false
	end
	if SNEW_CyloopInteract[mo.type]
		return false
	end
	if mo.type == MT_DETON then return false end
	if mo.player and mo.player.valid
		local player = mo.player
		if player and player.valid
		and player.playerstate == PST_LIVE
		and player.powers[pw_carry] != CR_NIGHTSMODE
		and not player.spectator
			if mo.cylooped or P_PlayerInPain(player) --A lot of trolling potential
				return true
			else
				return false
			end
		end
		return false
	end
	if (mo.flags & (MF_ENEMY|MF_MONITOR|MF_MISSILE)) --If not in list then if has these flags
		return true
	end
	if (mo.flags & MF_SHOOTABLE) --If doesnt have these flags you gotta have MF_SHOOTABLE
		return true
	end
	return false --Everything failed.
end
local function ReturnBash(mo,mobj)
	if mo and mo.valid
	and mobj and mobj.valid
	and IsInZ(mo, mobj)
	and AcceptThose(mobj)
	and mobj != mo
	and mo.player and mo.player.valid
	and not mo.player.nobash
	and mo.player.bashhome
		return true
	end
	return false
end

local function BashMoveCollider(mo, mobj)
	if not ReturnBash(mo,mobj) return end
	
	if mobj.freeze return end
	local player = mo.player
	player.bashstate = 5
	player.mo.momz = 0
	mobj.bashcontact = 15
	if not player.bashing
		player.bashcd = TICRATE*3
		player.justbashed = 3
		player.bashing = mobj
		mobj.bashed = mo
		AddToTable(mobj,N_CyloopEnemies)
	end
end
addHook("MobjMoveCollide", BashMoveCollider, MT_PLAYER)

rawset(_G, "DoEnemyDust", function(mo, ch, an)
	local dashspeed = 50*FRACUNIT
	local ang = mo.angle
	if ch
		dashspeed = ch
	end
	if an
		ang = an
	end
	for i = 1, (leveltime%7)/2
		local p = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SPINDUST)
		if mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER)
			p.state = S_SPINDUST_BUBBLE1
		end
		p.target = mo
		p.scale = (2*mo.scale)/3
		if P_MobjFlip(mo) == -1
			P_TeleportMove(p, p.x, p.y, mo.z+mo.height-p.height)
		end
		local pr = {}
		pr[0] = P_RandomFixed()<<2
		pr[1] = P_RandomRange(-30, 30)
		pr[2] = P_RandomFixed()<<3
		P_SetObjectMomZ(p, dashspeed/50+pr[0], false)
		P_InstaThrust(p,
			ang + (pr[1]*ANG1),
			-FixedMul(dashspeed/12+FRACUNIT+pr[2], mo.scale))
		P_TryMove(p, p.x+p.momx, p.y+p.momy, true)
	end
end)
local function BashableThinker(mo)
		if mo.nodamageing
			mo.nodamageing = $ - 1
		end
		if mo.nobash
			mo.nobash = $-1
		end
		if mo.basht
			if R_PointToDist2(0,0,mo.momx,mo.momy) > mo.info.speed*FRACUNIT
				mo.bashspeed = R_PointToDist2(0,0,mo.momx,mo.momy)
				mo.bashangle = R_PointToAngle2(0,0,mo.momx,mo.momy)
				mo.target = nil
				mo.movedir = -1
				if P_IsObjectOnGround(mo)
				and P_RandomChance(FRACUNIT/10)
					DoEnemyDust(mo, R_PointToDist2(0,0,mo.momx,mo.momy), R_PointToAngle2(0,0,mo.momx,mo.momy))
				end
				if mo.player and mo.player.valid
					local player = mo.player
					if player and player.valid
					and player.playerstate == PST_LIVE
					and player.powers[pw_carry] != CR_NIGHTSMODE
					and not player.spectator
						if P_IsObjectOnGround(player.mo)
							player.mo.state = S_PLAY_EDGE
						else
							player.mo.state = S_PLAY_PAIN
						end
						player.pflags = $|PF_FULLSTASIS
						local speedspeen = FixedAngle(R_PointToDist2(0,0,mo.momx,mo.momy)/2)
						if mo.lore
							player.drawangle = (leveltime%360)*speedspeen
						else
							player.drawangle = -(leveltime%360)*speedspeen
						end
					end
				else
					local speedspeen = FixedAngle(R_PointToDist2(0,0,mo.momx,mo.momy)/2)
					if mo.type != MT_GFZFISH
						if mo.lore
							mo.angle = $+speedspeen
						else
							mo.angle = $-speedspeen
						end
					end
				end
			else
				if R_PointToDist2(0,0,mo.momx,mo.momy) < FRACUNIT
				and not (mo.godown and mo.godown.t)
				and P_IsObjectOnGround(mo)
					mo.basht = false
					mo.backthrow = false
				end
			end
		end
		if mo.godown and mo.godown.t
			mo.godown.t = $ - 1
			if (mo.flags & MF_BOSS)
				mo.godown.t = 0
			else
				if mo.godown.z
					P_SetObjectMomZ(mo, mo.godown.z)
				end
				if mo.godown.f and mo.godown.a
					P_InstaThrust(mo, mo.godown.a,mo.godown.f)
				end
			end
		end
		if mo.bashed and mo.bashed.valid
			if mo.bashed.player and mo.bashed.player.valid
				local player = mo.bashed.player
				if player.bashing != mo
					mo.bashed = nil
				end
			end
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			mo.bash = true
		else
			mo.bash = false
		end
end
freeslot("sfx_stasis","sfx_stsbep","sfx_stslch",
	"SPR_STSC", "S_GOLD_CHAIN", "SPR_STSA", "S_STASIS_ARROW", "MT_GOLD_CHAIN")
states[S_GOLD_CHAIN] = {SPR_STSC, A|FF_PAPERSPRITE, TICRATE*5,nil,0,0,S_NULL}
states[S_STASIS_ARROW] = {SPR_STSA, A|FF_PAPERSPRITE, 2,nil,0,0,S_NULL}
mobjinfo[MT_GOLD_CHAIN] = {
	-1,             // doomednum
	S_GOLD_CHAIN,     // spawnstate
	1000,           // spawnhealth
	S_NULL,         // seestate
	sfx_None,       // seesound
	8,              // reactiontime
	sfx_None,       // attacksound
	S_NULL,         // painstate
	0,              // painchance
	sfx_None,       // painsound
	S_NULL,         // meleestate
	S_NULL,         // missilestate
	S_NULL,         // deathstate
	S_NULL,         // xdeathstate
	sfx_None,       // deathsound
	4*FRACUNIT,     // speed
	4*FRACUNIT,     // radius
	4*FRACUNIT,     // height
	1,              // display offset
	4,              // mass
	0,              // damage
	sfx_None,       // activesound
	MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP, // flags
	S_NULL          // raisestate
}
local function SpawnGoldenChains(mo,mobj)
	local num = 7
	local rst = P_RandomRange(0,360)*ANG1
	for i = 1, num
		local fa = ((360/num)*i)*ANG1
		local faz = ((180/num)*i)*ANG1
		local rang = rst+fa+(P_RandomRange(-5,5)*ANG1)
		local rzang = faz
		local c = P_SpawnMobjFromMobj(mo,0,0,mo.height/2,MT_GOLD_CHAIN)
		c.target = mo
		c.fuse = mo.freeze
		c.color = mobj.color
		if mobj.player and mobj.player.valid
		and mobj.player.powers[pw_super]
			c.color = SKINCOLOR_SUPERGOLD5
		end
		c.state = S_GOLD_CHAIN
		c.angle = rang
		c.rollangle = rzang
		c.scalespeed = FRACUNIT/15
		c.scale = mo.scale/2*3
		c.destscale = mo.scale
		c.spriteyscale = P_RandomRange(FRACUNIT>>FRACBITS, (FRACUNIT/3*4)>>FRACBITS)<<FRACBITS
		c.chain = true
		AddToTable(c,N_CyloopEnemies)
	end
end
addHook("ThinkFrame", function()
	for i,k in pairs(N_CyloopEnemies)
        local mo = N_CyloopEnemies[i]
		if mo.valid
			if mo.type == MT_GOLD_CHAIN
			and mo.chain
			and mo.target and mo.target.valid
			and not mo.target.freeze
				P_KillMobj(mo)
			end
			mo.freeze = $ or 0
			if mo.freeze and mo.freeze > 0
				mo.removecy = TICRATE
				if not mo.wasf
					if mo.colorized
						mo.wascolorized = true
					end
					mo.wasyellow = mo.color
				end
				mo.freeze = $-1
				local step = TICRATE
				local speed = mo.freeze
				local dobep = 0
				if speed >= step*3
					if (mo.freeze%20) == 0
						dobep = 1
					else
						dobep = 0
					end
				elseif speed >= step*2
					if (mo.freeze%10) == 0
						dobep = 1
					else
						dobep = 0
					end
				elseif speed >= step/3*2
					if (mo.freeze%5) == 0
						dobep = 1
					else
						dobep = 0
					end
				else
					dobep = 1
				end
				if dobep
					S_StartSoundAtVolume(mo,sfx_stsbep,255)
				end
				mo.flags = MF_NOTHINK
				if mo.chacolor
					mo.color = mo.chacolor
				else
					mo.color = SKINCOLOR_BLUE
				end
				mo.colorized = true
				searchBlockmap("objects", function(mo,mobj)
					if mobj and mobj.valid
					and IsInZ(mo,mobj)
						if (mobj.player and mobj.player.valid
						and P_PlayerCanDamage(mobj.player, mo))
						or (mobj.flags & MF_MISSILE)
							local dist, zdiff
							local angle, aimangle
							
							dist = R_PointToDist2(0,0,mobj.momx,mobj.momy)
							zdiff = (mobj.momz)
						
							local mom = R_PointToAngle2(0,0,mobj.momx,mobj.momy)
							local momd = R_PointToDist2(0,0,mobj.momx,mobj.momy)
							
							angle = R_PointToAngle2(0,0,mobj.momx,mobj.momy)
							aimangle = R_PointToAngle2(0, 0, dist, zdiff)
							
							mo.stasisbash.ang = angle
							mo.stasisbash.zang = aimangle
							mo.stasisbash.power = $+FRACUNIT/6*5
						end
					end
				end,mo,mo.x-mo.radius,mo.x+mo.radius,mo.y-mo.radius,mo.y+mo.radius)
				if mo.stasisbash
					local zang = mo.stasisbash.zang
					local ang = mo.stasisbash.ang
					local pow = mo.stasisbash.power
					
					local a = P_SpawnMobjFromMobj(mo,0,0,mo.height/2,MT_PARTICLE)
					a.state = S_STASIS_ARROW
					a.color = SKINCOLOR_RED
					a.spritexscale = FRACUNIT+abs(FixedMul(pow/5,cos(zang)))
					a.spriteyscale = FRACUNIT+abs(FixedMul(pow/5,sin(zang)))
					a.angle = ang
					a.rollangle = -zang
					a.fuse = 2
				end
				
				mo.nomorefreezing = true
				mo.wasf = true
			else
				if mo.wasf
					if not mo.wascolorized
						mo.colorized = false
					end
					if mo.wasyellow
						mo.color = mo.wasyellow
					else
						mo.color = SKINCOLOR_GREEN
					end
				
					mo.freeze = 0
					
					local e = P_SpawnMobjFromMobj(mo,0,0,0,MT_THOK)
					e.state = S_BIGMINE_BLAST1
					S_StartSoundAtVolume(mo,sfx_stslch,255)
					mo.freeze = 0
					
					
					if mo.stasisbash
						local zang = mo.stasisbash.zang
						local ang = mo.stasisbash.ang
						local pow = mo.stasisbash.power
						
						local mx = P_ReturnThrustX(nil,ang,FixedMul(cos(zang),pow))
						local my = P_ReturnThrustY(nil,ang,FixedMul(cos(zang),pow))
						local mz = FixedMul(sin(zang),pow)
						
						local fx = FixedMul(cos(zang),pow)
						local fz = mz
						if (mo.flags & MF_BOSS)
							fx = $/5
							fz = $/5
						end
						mo.godown = {t = 3, z = fz, f = fx, a = ang}
						mo.basht = true
						
						if not (mo.flags & MF_MISSILE)
							mo.cylaunch = 5 
							mo.cycontact = TICRATE*5
							mo.cylooped = true
							mo.docylooper = false 
							mo.addroll = ANG15
							if P_RandomRange(0, 1) == 0 mo.addroll = -$ end
						end
					end
					
					mo.flags = mo.info.flags
				end
				mo.wasf = false
			end
			if not (mo.flags & MF_NOTHINK)
				BashableThinker(mo)
			end
			
			if P_IsObjectOnGround(mo) and mo.nomorefreezing mo.nomorefreezing = false end
		end
    end
end)

addHook("MobjDamage", function(mobj, mo)
	if mobj and mobj.valid
		if AcceptThose(mobj)
			mobj.cylooped = false
			mobj.rollangle = 0
			mobj.stap = false
			mobj.slowdown = false
			mobj.basht = false
		end
	end
end)

addHook("ShouldDamage", function(mobj, mo)
	if mobj and mobj.valid
		if mo and mo.valid
			if mobj.type == MT_PLAYER
			and mobj.player and mobj.player.valid
			and (mobj.player.bashstate or mobj.player.bashhome)
				return false
			end
			if mobj.type == MT_PLAYER
			and mobj.player and mobj.player.valid
			and mobj.player.bashhome
			and mobj.tracer and mobj.tracer.valid
			and mobj.tracer == mo
				return false
			end
			if AcceptThose(mobj)
			and mobj.bashed and mobj.bashed.valid
			and mobj.bashed == mo
				return false
			end
			if AcceptThose(mobj)
			and mo.player and mo.player.valid
			and mo.tracer == mobj
			and mo.player.bashhome
				return false
			end
			if AcceptThose(mobj)
			and mobj.nodamageing
				return false
			end
		end
	end
end)

local function Unbash(player, b, just, stop)
	if player.powers[pw_flashing] < 3
		player.powers[pw_flashing] = 3
	end
	local keepdash = false
	if player.mo.state == S_PLAY_FLY
		keepdash = true
	end
	if not just
		local daheg = 0
		if P_MobjFlip(b) == -1
			daheg = -b.height/2
		end
		local dash = P_SpawnMobjFromMobj(b, 0, 0, daheg, MT_FACESTABBERSPEAR)
		dash.flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
		dash.fuse = 5
		dash.tics = 5
		dash.colorized = true
		dash.angle = player.drawangle+ANGLE_90
		dash.scale = FRACUNIT/3*2
		dash.destscale = FRACUNIT
		dash.color = player.mo.color
		dash.blendmode = AST_OVERLAY
		P_SetObjectMomZ(player.mo, FixedMul(player.mo.scale,8*FRACUNIT))
		P_Thrust(player.mo, player.mo.angle, FixedMul(player.mo.scale,-15*FRACUNIT))
		if not (b.flags & MF_BOSS)
			b.godown = {t = 3, z = FixedMul(player.mo.scale,5*FRACUNIT), f = FixedMul(player.mo.scale,60*FRACUNIT), a = player.mo.angle}
			b.lore = P_RandomRange(0, 1)
			b.basht = true
			b.lastthrower = player.mo
			b.backthrow = false
		end
		player.mo.state = S_PLAY_FALL
		if not player.powers[pw_super]
			player.mo.sprite2 = SPR2_STUN
			player.mo.tics = 10
		end
		player.drawangle = player.mo.angle
		S_StartSound(player.mo, sfx_kc5b)
	end
	b.slowdown = 0
	b.lastbasher = player.mo
	b.stap = true
	b.flags = $&~(MF_NOGRAVITY|MF_NOTHINK)
	if (b.info.flags & MF_NOGRAVITY)
		b.flags = $|MF_NOGRAVITY
	end
	player.mo.flags = $&~MF_NOGRAVITY
	player.pflags = $&~PF_THOKKED
	player.usespring = false
	player.nobash = TICRATE
	if not keepdash
		player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE
		player.pflags = $&~(PF_SPINNING|PF_THOKKED)
	end
	if stop
		P_SetObjectMomZ(player.mo, FixedMul(player.mo.scale,8*FRACUNIT))
		P_Thrust(player.mo, player.mo.angle, FixedMul(player.mo.scale,-5*FRACUNIT))
		player.mo.state = S_PLAY_FALL
	end
	if (b.flags & MF_MISSILE)
		b.target = player.mo
		b.basht = false
		b.backthrow = false
		b.godown = {t = 3, z = 0, f = FixedMul(player.mo.scale,b.info.speed), a = player.mo.angle}
		b.nobash = TICRATE
		b.bashcontact = TICRATE/2*3
		b.angle = player.mo.angle
	end
	if b.player and b.player.valid
	and SameTeam(player, b.player)
	and SameTeam(player, b.player) != 2
		local p = b.player
		p.pflags = $|PF_JUMPED
		p.pflags = $&~(PF_THOKKED|PF_NOJUMPDAMAGE)
		b.state = S_PLAY_ROLL
		p.drawangle = player.mo.angle
		b.basht = false
		b.backthrow = false
	end
end

local function ReturnBashDMG(mo)
	if mo and mo.valid
	and AcceptThose(mo)
	and mo.basht
	and not mo.backthrow
		return true
	end
	return false
end
addHook("MobjMoveBlocked", function(mo, mobj, line)
	if not ReturnBashDMG(mo) return end
		if mo.lastthrower and mo.lastthrower.valid
			P_DamageMobj(mo, mo.lastthrower, mo.lastthrower, 1)
		else
			P_DamageMobj(mo, nil, nil, 1)
		end
		if mo.player and mo.player.valid
			mo.state = S_PLAY_FALL
			mo.sprite2 = SPR2_DRWN
			mo.tics = -1
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			local slam = P_SpawnGhostMobj(mo)
			slam.scale = mo.scale
			slam.destscale = mo.scale*2
			S_StartSound(mo, sfx_crumbl)
		end
end)
addHook("HurtMsg", function(player, mo, src) --No idea if this works.
	if player.mo.state == S_PLAY_FALL
	and player.mo.sprite2 == SPR2_DRWN
		if src and src.valid and src.player and src.player.valid
			print(player.name+" was bashed against a wall by "+src.player.name+".")
		else
			print(player.name+" was bashed against a wall.")
		end
		return true
	end
	if player.mo.cylooped and not player.mo.basht
	and player.mo.lastbasher and player.mo.lastbasher.valid
		if player.mo.lastbasher.player and player.mo.lastbasher.player.valid
			local p = player.mo.lastbasher.player
			print(player.name+" was cylooped into a pit by "+p.name+".")
		else
			print(player.name+" was cylooped into a pit.")
		end
	end
	if player.mo.basht
	and player.mo.lastbasher and player.mo.lastbasher.valid
		if player.mo.lastbasher.player and player.mo.lastbasher.player.valid
			local p = player.mo.lastbasher.player
			print(player.name+" was bashed into a pit by "+p.name+".")
		else
			print(player.name+" was bashed into a pit.")
		end
	end
end)

local nomissile = {
[MT_SHOCKWAVE] = true,
[MT_DETON] = true,
[MT_TARGETDUMMY] = true}
local function FindMissile(p)
	local lastmo
	local dist
	local zdist
	local lastdist = 0
	local lastzdist = 0
	for mo in mobjs.iterate()
		if mo == p.mo continue end
		if (mo.health <= 0) continue end
		if not (mo.flags & MF_MISSILE) continue end
		if nomissile[mo.type] continue end
		if mo.target and mo.target.valid
			if (mo.flags2 & MF2_BOUNCERING)
				if not mo.threshold and (mo.target == p.mo) continue end
			else
				if (mo.target == p.mo) continue end
			end
		end
		if not P_CheckSight(p.mo,mo) continue end
		dist = R_PointToDist2(p.mo.x,p.mo.y,mo.x,mo.y)
		zdist = (p.mo.z+p.mo.height/2)-(mo.z+mo.height/2)
		if (dist > 250*FRACUNIT) continue end
		if (abs(zdist) > 100*FRACUNIT) continue end
		if (lastmo and (dist > lastdist)) continue end
		if (lastmo and (zdist > lastzdist)) continue end
		lastmo = mo
		lastdist = dist
		lastzdist = zdist
	end
	return lastmo
end
local function FindEnemy(p)
	local left = p.mo.x-300*FRACUNIT
	local right = p.mo.x+300*FRACUNIT
	local bottom = p.mo.y-300*FRACUNIT
	local top = p.mo.y+300*FRACUNIT
	
	local lastmo
	local dist
	local zdist
	local lastdist = 0
	local lastzdist = 0
	searchBlockmap("objects", function(mo,mobj)
		if mobj and mobj.valid
			dist = R_PointToDist2(p.mo.x,p.mo.y,mobj.x,mobj.y)
			zdist = (p.mo.z+p.mo.height/2)-(mobj.z+mobj.height/2)
			if mobj != p.mo
			and mobj.health
			and AcceptThose(mobj)
			and P_CheckSight(p.mo,mobj)
			and (dist <= 250*FRACUNIT)
			and (abs(zdist) <= 100*FRACUNIT)
				if ((lastmo and lastdist < dist)
				or (lastmo and lastzdist < zdist))
				or not lastmo
					lastmo = mobj
					lastdist = dist
					lastzdist = zdist
				end
			end
		end
	end,p.mo,left,right,bottom,top)
	return lastmo
end
addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		player.justbashed = $ or 0
		player.notrig = $ or 0
		if player.notrig then player.notrig = $-1 end
		if player.justbashed then player.justbashed = $-1 end
		player.bashstate = $ or 0
		player.nobash = $ or 0
		player.bashcd = $ or 0
		if player.nobash then player.nobash = $-1 end
		if player.bashstate
			player.bashstate = $ - 1
			if player.bashing and player.bashing.valid
			and not player.nobash
				player.mo.target = nil
				player.mo.tracer = nil
				player.bashhome = 0
				if player.bashcd
					player.bashcd = $-1
					player.stopbash = true
				elseif player.stopbash
					player.stopbash = false
					player.nobash = 15
				end
				local b = player.bashing
				player.bashstate = 5
				player.usespring = false
				player.pflags = $&~PF_THOKKED
				
				local heg = b.z+b.height+20*FRACUNIT
				if P_MobjFlip(b) == -1
					heg = b.z-player.mo.height
				end
				P_TeleportMove(player.mo, b.x, b.y, heg)
				player.mo.momx = 0
				player.mo.momy = 0
				player.mo.momz = 0
				player.mo.flags = $|MF_NOGRAVITY
				player.mo.state = S_PLAY_ROLL
				b.momx = 0
				b.momy = 0
				b.momz = 0
				b.flags = $|MF_NOGRAVITY|MF_NOTHINK
				if b.shouldgoback
					b.respawn = 0
				end
				b.nodamageing = 15
				if player.cmd.buttons & BT_JUMP
					if not player.enemyj
					and not player.justbashed
						player.nobash = TICRATE
						player.notrig = 3
						Unbash(player, b, true, false)
						if not P_IsObjectOnGround(b)
							b.godown = {t = 3, z = FixedMul(player.mo.scale,-15*FRACUNIT), f = 0}
						else
							b.godown = {t = 3, z = FixedMul(player.mo.scale,10*FRACUNIT), f = 0}
						end
						b.backthrow = false
						if (b.flags & MF_MISSILE)
							b.basht = false
							b.target = player.mo
							b.angle = player.mo.angle
						end
						S_StartSound(player.mo, sfx_wdjump)
						S_StartSound(player.mo, sfx_kc5b)
						player.superjump = TICRATE/2*3
						player.startz = player.mo.z+player.mo.height/2
						player.finz = player.startz+(P_MobjFlip(player.mo)*500*FRACUNIT)
						if ((player.cmd.forwardmove or player.cmd.sidemove) >= 25
						or (player.cmd.forwardmove or player.cmd.sidemove) <= -25)
						and player.ctrlAng
							P_Thrust(player.mo, player.ctrlAng, FixedMul(player.mo.scale,15*FRACUNIT))
							b.godown = {t = 3, a = player.ctrlAng, f = FixedMul(player.mo.scale,-15*FRACUNIT)}
						end
						player.usespring = false
						player.bashstate = 0
					end
					player.enemyj = true
				else
					player.enemyj = false
				end
				if player.cmd.buttons & BT_SPIN
					if not player.enemys
						player.nobash = 15
						player.notrig = 3
						Unbash(player, b, true, false)
						player.secondjump = 0
						b.godown = {t = 3, z = FixedMul(player.mo.scale,5*FRACUNIT), f = FixedMul(player.mo.scale,-20*FRACUNIT), a = player.mo.angle}
						b.lore = P_RandomRange(0, 1)
						b.basht = true
						b.backthrow = true
						if (b.flags & MF_MISSILE)
							b.basht = false
							b.backthrow = false
							b.target = player.mo
							b.angle = player.mo.angle+ANGLE_180
						end
						
						S_StartSound(player.mo, sfx_thok)
						S_StartSound(player.mo, sfx_spin)
						S_StartSound(player.mo, sfx_zoom)
						S_StartSound(player.mo, sfx_kc5b)
						
						player.drawangle = player.mo.angle
						P_Thrust(player.mo, player.mo.angle, FixedMul(player.mo.scale,50*FRACUNIT))
						P_SetObjectMomZ(player.mo, FixedMul(player.mo.scale,5*FRACUNIT))
						
						local daheg = 0
						if P_MobjFlip(player.mo) == -1
							daheg = -player.mo.height/2
						end
						local dash = P_SpawnMobjFromMobj(player.mo, 0, 0, daheg, MT_FACESTABBERSPEAR)
						dash.flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
						dash.fuse = 5
						dash.tics = 5
						dash.colorized = true
						dash.angle = player.drawangle+ANGLE_90
						dash.scale = FRACUNIT/3*2
						dash.destscale = FRACUNIT
						dash.color = player.mo.color
						dash.blendmode = AST_OVERLAY
						
						player.bashstate = 0
						player.mo.state = S_PLAY_FLY
						player.pflags = $|PF_JUMPED
						player.pflags = $&~(PF_NOJUMPDAMAGE|PF_THOKKED)
					end
					player.enemys = true
				else
					player.enemys = false
				end
				local stasisbutton = player.shieldbutton
				if stasisbutton and player.cmd.buttons & stasisbutton
				and not b.nomorefreezing
					player.nobash = TICRATE
					Unbash(player, b, true, true)
					b.flags = $|MF_NOTHINK
					b.chacolor = player.mo.color
					if player.powers[pw_super]
						b.chacolor = SKINCOLOR_SUPERGOLD5
					end
					b.momx = 0
					b.momy = 0
					b.momz = 0
					S_StartSoundAtVolume(b,sfx_stasis,255)
					b.freeze = TICRATE*5
					SpawnGoldenChains(b,player.mo)
					player.mo.momx = 0
					player.mo.momy = 0
					player.bashstate = 0
					
					local stspeed = b.info.speed
					if stspeed < 16*FRACUNIT
						stspeed = 16*FRACUNIT
					end
					b.stasisbash = {
						zang = -ANGLE_90,
						ang = player.mo.angle,
						power = stspeed}
				end
			end
			player.bashf = true
		elseif player.bashf
			if player.bashing and player.bashing.valid
				player.bashing.flags = $&~(MF_NOGRAVITY|MF_NOTHINK)
			end
			player.mo.flags = $&~MF_NOGRAVITY
			player.bashing = nil
			player.bashf = false
		end
	
		player.bashuse = $ or 0
		if player.bashuse and player.bashuse < 0
			player.bashuse = $+1
			player.recharge = true
		elseif player.recharge
			player.recharge = false
			player.bashuse = 15
		end
		player.bashhome = $ or 0
		local pm = FindMissile(player)
		local n = FindEnemy(player)
		local m
		if pm and pm.valid
		and not pm.freeze
		and not P_IsObjectOnGround(player.mo)
		and CanUse(player)
		and not player.nobash
		and not player.bashhome
		and not player.bashstate
			m = pm
			P_SpawnLockOn(player,pm,S_LOCKON3)
		end
		if n and n.valid
		and not n.freeze
		and not pm --Missiles have priority
		and not P_IsObjectOnGround(player.mo)
		and CanUse(player)
		and not player.nobash
		and not player.bashhome
		and not player.bashstate
			m = n
			P_SpawnLockOn(player,n,S_LOCKON3)
		end
		if player.bashhome
			player.bashhome = $ - 1
			if player.mo.tracer
			and player.mo.tracer.valid
			and not player.mo.tracer.freeze
			and not P_IsObjectOnGround(player.mo)
				local t = player.mo.tracer
				P_FlyTo(player.mo,t.x,t.y,t.z+t.height/2,player.runspeed)
				P_SpawnLockOn(player,t,S_LOCKON1)
				local minrad = t.radius/2*3
				local minheg = t.height/2*3
				if minrad < 50*FRACUNIT minrad = 50*FRACUNIT end
				if minheg < 60*FRACUNIT minheg = 60*FRACUNIT end
				if R_PointToDist2(player.mo.x+player.mo.momx,player.mo.y+player.mo.momy,t.x,t.y) <= minrad
				and abs((t.z+t.height/2)-(player.mo.z+player.mo.momz+player.mo.height/2)) <= minheg
					S_StartSound(player.mo, sfx_s3k9a)
					BashMoveCollider(player.mo, t)
					player.bashhome = 0
				end
			else
				player.bashhome = 0
			end
			player.home = true
		else
			if player.home
				player.bashhome = 0
			end
			player.home = false
		end
		if player.extrabutton and player.cmd.buttons & player.extrabutton
		and not P_IsObjectOnGround(player.mo)
		and CanUse(player)
		and not player.nobash
		and not (player.pflags & PF_SHIELDABILITY) --No more Attract bash.
			if not player.bashbut
			and m and m.valid
			and not m.freeze
			and not player.bashstate
			and not player.bashhome
				player.mo.target = m
				player.mo.tracer = m
				local t = player.mo.tracer
				player.bashhome = 2*TICRATE
				P_FlyTo(player.mo,t.x,t.y,t.z+t.height/2,player.normalspeed)
				player.drawangle = R_PointToAngle2(player.mo.x,player.mo.y,t.x,t.y)
				player.mo.state = S_PLAY_FLY
				player.pflags = $|PF_JUMPED|PF_THOKKED
				player.pflags = $&~PF_NOJUMPDAMAGE
				S_StartSound(player.mo,sfx_s3k6d)
			end
			player.bashbut = true
		else
			if player.bashbut
				player.bashuse = -15
				if player.bashing and player.bashing.valid
					local b = player.bashing
					if not player.notrig
						if player.nobash
							Unbash(player, b, true, true)
						else
							Unbash(player, b)
						end
					end
				end
				player.bashing = nil
			end
			if player.bashcollide and player.bashcollide.valid
				P_KillMobj(player.bashcollide)
				player.bashcollide = nil
			end
			player.bashbut = false
		end
	end
end)

addHook("MapChange", function()
	N_CyloopEnemies = {}
end)