rawset(_G, "SNEW_CyloopInteract", {}) --mobj_t cyloop, mobj_t mobj
freeslot("MT_DIGSPOT")

local function GetRings(cyl, mo)
	if mo and mo.valid
		local startran = P_RandomRange(0,360)*ANG1
		local rcount = (mo.radius+mo.height/2)/FRACUNIT/16
		if mo.type == MT_DIGSPOT
			rcount = mo.angle/ANG1
		end
		for i = 1, rcount
			local fa = (360/rcount)*i*ANG1
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, mo.height, MT_FLINGRING)
			ring.fhome = true
			ring.fuse = TICRATE*10
			if cyl.target and cyl.target.valid
				ring.target = cyl.target
			elseif cyl.player and cyl.player.valid
				ring.target = cyl
			else
				ring.target = no
			end
			P_InstaThrust(ring, startran+fa, 5*FRACUNIT/2)
			P_SetObjectMomZ(ring, FRACUNIT/2)
		end
		if (mo.flags2 & MF2_DONTDRAW)
		or (mo.sprite == SPR_NULL)
			local f = P_SpawnMobjFromMobj(mo,0,0,mo.height/2, MT_THOK)
			f.state = S_SPRK3
			f.frame = S
			f.spriteyoffset = 15*FRACUNIT
			f.tics = TICRATE
			f.fuse = TICRATE
			f.scalespeed = mo.scale/16
			f.scale = mo.scale/15
			f.destscale = mo.scale*2
		end
		mo.wasdug = true --To make the object no longer cyloop`able
	end
end

SNEW_CyloopInteract[MT_GFZTREE] = GetRings --GFZ
SNEW_CyloopInteract[MT_GFZBERRYTREE] = GetRings
SNEW_CyloopInteract[MT_GFZCHERRYTREE] = GetRings
SNEW_CyloopInteract[MT_CHECKERTREE] = GetRings
SNEW_CyloopInteract[MT_CHECKERSUNSETTREE] = GetRings
SNEW_CyloopInteract[MT_FHZTREE] = GetRings
SNEW_CyloopInteract[MT_FHZPINKTREE] = GetRings
SNEW_CyloopInteract[MT_POLYGONTREE] = GetRings
SNEW_CyloopInteract[MT_BUSHTREE] = GetRings
SNEW_CyloopInteract[MT_BUSHREDTREE] = GetRings
SNEW_CyloopInteract[MT_SPRINGTREE] = GetRings

SNEW_CyloopInteract[MT_THZTREE] = GetRings --THZ

SNEW_CyloopInteract[MT_BIGGARGOYLE] = GetRings --DSZ
SNEW_CyloopInteract[MT_GARGOYLE] = GetRings

SNEW_CyloopInteract[MT_PINETREE] = GetRings --CEZ
SNEW_CyloopInteract[MT_EGGSTATUE] = GetRings
SNEW_CyloopInteract[MT_CRAWLASTATUE] = GetRings
SNEW_CyloopInteract[MT_FACESTABBERSTATUE] = GetRings
SNEW_CyloopInteract[MT_SUSPICIOUSFACESTABBERSTATUE] = GetRings

SNEW_CyloopInteract[MT_TORCHFLOWER] = GetRings --RVZ

SNEW_CyloopInteract[MT_SNOWMAN] = GetRings --Xmas
SNEW_CyloopInteract[MT_SNOWMANHAT] = GetRings
SNEW_CyloopInteract[MT_LAMPPOST1] = GetRings
SNEW_CyloopInteract[MT_LAMPPOST2] = GetRings

SNEW_CyloopInteract[MT_EGGSTATUE2] = GetRings --Disco


freeslot("S_DIGSPOT", "S_DIGSPOT_SHOW", "SPR_CING", "S_LOCKDIG")
states[S_DIGSPOT_SHOW] = {SPR_CING,A,1,nil,0,0,S_DIGSPOT} --So that object place works.
states[S_DIGSPOT] = {SPR_NULL,A,-1,nil,0,0,S_NULL} --The actual in-game sprite
states[S_LOCKDIG] = {SPR_CING,A,2,nil,0,0,S_NULL} --Lock-on state (Useful for tutorials)
//Dig spot
mobjinfo[MT_DIGSPOT] = {
	//$Name "Dig Spot"
	//$Sprite CINGA0
	//$Category "Team New Objects"
	doomednum = 3469,
	spawnstate = S_DIGSPOT_SHOW,
	spawnhealth = 1000,
	reactiontime = 5,
	speed = 50*FRACUNIT,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 1,
	flags = MF_NOGRAVITY|MF_SHOOTABLE
}
SNEW_CyloopInteract[MT_DIGSPOT] = GetRings


local function ActivateACZTarget(cyl, mo)
	if mo and mo.valid
		mo.flags = $|MF_PUSHABLE
	end
end
SNEW_CyloopInteract[MT_TARGET] = ActivateACZTarget

addHook("ThinkFrame", do --Spawn a dig mobj there.
	if leveltime == 3
		for m in mapthings.iterate
			if m and m.valid
			and m.type == mobjinfo[MT_EMBLEM].doomednum
				local z = (m.options>>4)*FRACUNIT
				local sec = R_PointInSubsector(m.x*FRACUNIT,m.y*FRACUNIT)
				if sec and sec.valid
					z = $+sec.sector.floorheight
					if (m.options & MTF_AMBUSH)
						z = $+24*FRACUNIT
					end
					local a = P_SpawnMobj(m.x*FRACUNIT,m.y*FRACUNIT,z,MT_DIGSPOT)
					a.angle = ANG1*5
				end
			end
		end
	end
end)