freeslot("MT_CYLOOP", "SPR_CYLP", "MT_CYCHECK", "S_CYCHECK", "SPR_CYSH", "S_CYLOOP_P")
for i = 1, 4
	freeslot("S_CYSLASH"..i)
end
for i = 1, 6
	freeslot("S_CYLOOP"..i)
end
states[S_CYSLASH1] = {SPR_CYSH, A|FF_FULLBRIGHT, 2, nil, 0, 0, S_CYSLASH2}
states[S_CYSLASH2] = {SPR_CYSH, B|FF_FULLBRIGHT, 2, nil, 0, 0, S_CYSLASH3}
states[S_CYSLASH3] = {SPR_CYSH, C|FF_FULLBRIGHT, 2, nil, 0, 0, S_CYSLASH4}
states[S_CYSLASH4] = {SPR_CYSH, D|FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}
local byebye = {[0] = 0,[1] = FF_TRANS90,[2] = FF_TRANS80,[3] = FF_TRANS70,
	[4] = FF_TRANS60,[5] = FF_TRANS50,[6] = FF_TRANS40,
	[7] = FF_TRANS30,[8] = FF_TRANS20,[9] = FF_TRANS10}
local function A_CyloopParticles(actor, var1, var2)
	local mo = actor
	if P_RandomChance(FRACUNIT/7)
		local rana = P_RandomRange(0, 360)*ANG1
		local ranr = P_RandomRange(1>>FRACBITS, mo.radius>>FRACBITS)<<FRACBITS
		local ranx = P_ReturnThrustX(nil, rana, ranr)
		local rany = P_ReturnThrustX(nil, rana, ranr)
		local part = P_SpawnMobjFromMobj(mo, ranx, rany, 0, MT_THOK)
		part.state = S_CYLOOP_P
		part.tics = 15
		part.fuse = 15
		part.spriteyoffset = P_RandomRange(0, 40)*FRACUNIT
		part.color = mo.color
	end
	local bop = byebye[0]
	if mo.fuse < 10
		bop = byebye[mo.fuse]
		mo.frame = $|bop
	end
	if mo.target and mo.target.valid
		if mo.target.player and mo.target.player.valid
			if mo.first
			and mo.cyloop
				mo.target.player.cyloopin = 5
			end
			local player = mo.target.player
			if player.mo.skin != "sonicnew"
			or player.stopcyloop
				mo.target = nil
			end
		end
		mo.hastarg = true
	else
		if mo.hastarg
			mo.fuse = 9
		end
		mo.hastarg = false
	end
	mo.cyloopcontact = TICRATE*5
end

states[S_CYLOOP1] = {SPR_CYLP, A|FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT, 2, A_CyloopParticles, 0, 0, S_CYLOOP2}
states[S_CYLOOP2] = {SPR_CYLP, B|FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT, 2, A_CyloopParticles, 0, 0, S_CYLOOP3}
states[S_CYLOOP3] = {SPR_CYLP, C|FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT, 2, A_CyloopParticles, 0, 0, S_CYLOOP4}
states[S_CYLOOP4] = {SPR_CYLP, D|FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT, 2, A_CyloopParticles, 0, 0, S_CYLOOP5}
states[S_CYLOOP5] = {SPR_CYLP, E|FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT, 2, A_CyloopParticles, 0, 0, S_CYLOOP6}
states[S_CYLOOP6] = {SPR_CYLP, F|FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT, 2, A_CyloopParticles, 0, 0, S_CYLOOP1}

states[S_CYLOOP_P] = {SPR_CYLP, G|FF_TRANS10|FF_FULLBRIGHT, 5, nil, 0, 0, S_NULL}
states[S_CYCHECK] = {SPR_NULL, A|FF_FULLBRIGHT, TICRATE, nil, 0, 0, S_NULL}
mobjinfo[MT_CYLOOP] = {
	doomednum = -1,
	spawnstate = S_CYLOOP1,
	spawnhealth = 1,
	reactiontime = 5,
	speed = 50*FRACUNIT,
	radius = 50*FRACUNIT,
	height = 35*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY
}

mobjinfo[MT_CYCHECK] = {
	doomednum = -1,
	spawnstate = S_CYCHECK,
	spawnhealth = 1,
	reactiontime = 5,
	speed = 50*FRACUNIT,
	radius = 50*FRACUNIT,
	height = 100*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

local function ZAng(x,y,z, fx,fy,fz)
	local dist = 0
	local zdiff = 0
	local angle = 0
	local aimangle = 0
	dist = R_PointToDist2(x, y, fx, fy)
	zdiff = (fz - z)
	angle = R_PointToAngle2(x,y, fx, fy)
	aimangle = R_PointToAngle2(0, 0, dist, zdiff)
	return aimangle
end

local function DoCyloop(player) --Function for making the cyloop trail
	if player.lastcl and player.lastcl.valid
		local aprx = P_AproxDistance(P_AproxDistance(player.lastcl.x-player.mo.x,player.lastcl.y-player.mo.y),player.lastcl.z-player.mo.z)
		local cyspeed = FixedMul(player.mo.scale,FixedMul(player.speed, FRACUNIT/100*144))
		if aprx >= cyspeed
			local cl = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_CYLOOP)
			cl.target = player.mo
			cl.fuse = TICRATE/2*7
			cl.angle = R_PointToAngle2(cl.x, cl.y, player.lastcl.x, player.lastcl.y)+ANGLE_180
			cl.lastcl = player.lastcl
			cl.rollangle = (ZAng(cl.x,cl.y,cl.z, player.lastcl.x,player.lastcl.y,player.lastcl.z)*2)+ANGLE_180
			local diff = aprx-(cyspeed-FRACUNIT)
			cl.spritexscale = diff/10
			cl.addspecial = 15
			if aprx <= 0
			or cl.spritexscale >= FRACUNIT*11
				cl.spritexscale = FRACUNIT
				cl.angle = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
			end
			cl.color = player.mo.color
			player.lastcl.nextcl = cl
			player.lastcl = cl
			if player.cyloop
				local theumuh = #player.cyloop
				player.cyloop[theumuh+1] = cl
			end
			AddToTable(cl,N_CyloopEnemies)
		end
	else
		local cl = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_CYLOOP)
		cl.target = player.mo
		cl.fuse = TICRATE/2*7
		cl.angle = player.drawangle
		cl.rollangle = ZAng(cl.x,cl.y,cl.z, player.mo.x,player.mo.y,player.mo.z)*2
		cl.color = player.mo.color
		cl.addspecial = 15
		cl.first = true
		player.lastcl = cl
		player.cyloop = {}
		player.cyloop[0] = cl
		AddToTable(cl,N_CyloopEnemies)
	end
end

local function CyloopFlash(mo)
	local f = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	f.blendmode = AST_ADD
	f.scale = mo.scale/2*3
	f.destscale = mo.scale
	f.scalespeed = mo.scale/12
	f.fuse = 10
	f.tics = 10
	f.color = SKINCOLOR_PURPLE
	f.spriteyoffset = (-43*FRACUNIT/2)*P_MobjFlip(mo)
end

local function CheckInsideloop(player, cx, cy, cz, cl) //Fix all of this shit somehow
	if player and player.valid
		local mo = player.mo
		local t = player.cyloop
		
		local pcount = 0
		local x = 0
		local y = 0
		local z = 0
		local alt = {}
			
		for i,k in pairs(t)
			if t[i] and t[i].valid
			and t[i].target and t[i].target.valid
				local uh = P_SpawnMobjFromMobj(t[i], 0, 0, 0, MT_THOK)
				uh.target = player.mo
				uh.tics = 2
				uh.fuse = 2
				uh.flags2 = $|MF2_DONTDRAW
				x = $+uh.x/FRACUNIT
				y = $+uh.y/FRACUNIT
				z = $+uh.z/FRACUNIT
				pcount = $+1
				table.insert(alt, uh)
			end
		end
		if pcount <= 0
			pcount = 1
		end
		x = ($/pcount)*FRACUNIT
		y = ($/pcount)*FRACUNIT
		z = ($/pcount)*FRACUNIT
		
		local cen = P_SpawnMobj(x, y, z, MT_THOK)
		cen.state = S_CYSLASH1
		cen.scale = player.mo.scale*3
		if P_MobjFlip(mo) == -1
			cen.flags2 = $|MF2_OBJECTFLIP
			cen.eflags = $|MFE_VERTICALFLIP
			cen.spriteyoffset = ((44*FRACUNIT))
		end
		
		for i,k in pairs(alt)
			if alt[i] and alt[i].valid
			and alt[i].target and alt[i].target.valid
				local mobj = alt[i]
				local dist = R_PointToDist2(mobj.x,mobj.y,cen.x,cen.y)
				local zdist = mobj.z-cen.z
				local ang = R_PointToAngle2(mobj.x,mobj.y,cen.x,cen.y)
				
				local linelengh = 3
				for f = 1, linelengh
					local rar = (dist/linelengh)*f
					local ax = P_ReturnThrustX(nil, ang, rar)
					local ay = P_ReturnThrustY(nil, ang, rar)
					local az = (zdist/linelengh)*f
					
					local ch = P_SpawnMobjFromMobj(mobj, ax, ay, az, MT_CYCHECK)
					if ch and ch.valid
						ch.target = mo
						ch.tics = 2
						ch.fuse = 2
						ch.color = mo.color
						ch.height = mo.height/2*3
						ch.radius = dist/linelengh
					end
				end
			end
		end
	end
end

local function IsInZ(mobj, mo)
	if mo.z > (mobj.z+mobj.height)
		return
	end
	if (mobj.z-mobj.height) > (mo.z+mo.height)
		return
	end
	return true
end

local function AcceptThose(mo, mobj)
	if SNEW_CyloopInteract[mo.type]
		return true
	end
	local p
	if mobj and mobj.valid
		if mobj.player and mobj.player.valid
			p = mobj.player
		else
			if mobj.target and mobj.target.valid
			and mobj.target.player and mobj.target.player.valid
				p = mobj.target.player
			end
		end
	end
	if mo.player and mo.player.valid
		local player = mo.player
		if player and player.valid
		and player.playerstate == PST_LIVE
		and player.powers[pw_carry] != CR_NIGHTSMODE
		and not player.spectator
			if player.shieldbutton 
			and player.cmd.buttons & player.shieldbutton
			and P_IsObjectOnGround(player.mo)
				return true
			end
			if not mobj
				return true
			end
			if (gametyperules & GTR_FRIENDLYFIRE)
			or friendlyfire
				return true
			else
				if (gametyperules & GTR_FRIENDLY)
					return false
				else
					if p and p.valid
						if (gametyperules & GTR_TEAMS)
							if p.ctfteam == player.ctfteam
								return false
							else
								return true
							end
						else
							return true
						end
					else
						return true
					end
				end
			end
		end
	end
	if (mo.flags & (MF_ENEMY|MF_MONITOR|MF_MISSILE|MF_BOSS)) --If not in list then if has these flags
		return true
	end
	if (mo.flags & MF_SHOOTABLE) --If doesnt have these flags you gotta have MF_SHOOTABLE
		return true
	end
	return false --Everything failed.
end

local function ReturnEndCheck(mo,mobj,thinker)
	if thinker == "cyloopcollision"
		if mo and mo.valid
		and mo.target and mo.target.valid
		and mobj and mobj.valid
		and IsInZ(mo, mobj)
		and AcceptThose(mobj, mo)
		and mobj != mo.target
		and not mobj.wasdug
		and not mobj.recyloop
			return true
		end
	end
	if thinker == "cyloop"
		if mo and mo.valid
		and mo.cyloopcontact
		and (mo.addspecial or mo.dospecial or mo.resetyesitcan or mo.cancyloop or mo.cyloop)
			return true
		end
	end
	if thinker == "enemy"
		if mo and mo.valid
		and mo.cyloopcontact
			return true
		end
	end
	if thinker == "enemydeath"
		if mo and mo.valid
		and AcceptThose(mo,mobj)
			return true
		end
	end
	return false
end

addHook("MobjCollide", function(mo, mobj)
	if mo and mo.valid
	and mo.target and mo.target.valid
		if mobj and mobj.valid
		and mobj.target and mobj.target.valid
		and IsInZ(mo, mobj)
		and mobj.type == MT_CYLOOP
		and mobj.target == mo.target
			mobj.cyloop = 15
		end
	end
end, MT_CYLOOP)

rawset(_G,"N_CyloopEnemies",{})
addHook("MobjMoveCollide", function(mo, mobj)
	if not ReturnEndCheck(mo,mobj,"cyloopcollision") return end
	
	if not mobj.cycontact
		AddToTable(mobj,N_CyloopEnemies)
		mobj.cycontact = 3
	end
	mobj.removecy = TICRATE
	if not SNEW_CyloopInteract[mobj.type]
		if (mobj.flags & MF_BOSS)
			P_DamageMobj(mobj, mo, mo.target, 1, DMG_ELECTRIC)
		else
			mobj.reservecylooper = 15
			mobj.lastbasher = mo.target
			mobj.cylaunch = TICRATE
			if mobj.player and mobj.player.valid
				local player = mobj.player
				if player and player.valid
				and player.playerstate == PST_LIVE
				and player.powers[pw_carry] != CR_NIGHTSMODE
				and not player.spectator
					player.jumprecon = 0
				end
			end
		end
	else
		SNEW_CyloopInteract[mobj.type](mo, mobj)
		mobj.recyloop = TICRATE
	end
	local s = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_THOK)
	s.color = mo.color
	s.blendmode = AST_ADD
	s.fuse = TICRATE
	s.tics = 15
	s.spriteyscale = FRACUNIT/3*2
	s.expandx = true
	AddToTable(s,N_CyloopEnemies)
end, MT_CYCHECK)

local function CyloopableThinker(mo)
	if mo.cycontact mo.cycontact = $-1 end
	if mo.recyloop mo.recyloop = $ - 1 end
	if mo.expandx mo.spritexscale = $+FRACUNIT/3 end
	mo.cylaunch = $ or 0
	if mo.reservecylooper mo.reservecylooper = $ - 1 mo.docylooper = true mo.removecy = TICRATE
	elseif mo.docylooper mo.cylaunch = 5 mo.cycontact = TICRATE*5
		P_SetObjectMomZ(mo, FixedMul(mo.scale,17*FRACUNIT)) mo.cylooped = true
		mo.docylooper = false mo.addroll = ANG15
		if P_RandomRange(0, 1) == 0 mo.addroll = -$ end
	end
	mo.slowdown = $ or 0
	mo.intheairtoolong = $ or 0
	if mo.cylaunch mo.cylaunch = $-1 end
	if mo.slowdown mo.slowdown = $-1 end
	if mo.cylooped
		mo.removecy = TICRATE
		mo.cycontact = TICRATE*5
		
		if mo.addroll
			mo.rollangle = $+mo.addroll
		end
		
		if mo.momz*P_MobjFlip(mo) <= FRACUNIT
			if not mo.slowdown
				if not mo.stap
					mo.momz = $/5
					mo.slowdown = TICRATE
					mo.stap = true
				end
			else
				mo.momz = $/5*P_MobjFlip(mo)
			end
		end
		
		if mo.player and mo.player.valid
		and not mo.basht
			local player = mo.player
			if player and player.valid
			and player.playerstate == PST_LIVE
			and player.powers[pw_carry] != CR_NIGHTSMODE
			and not player.spectator
				player.pflags = $|PF_STASIS|PF_THOKKED
				player.powers[pw_tailsfly] = 0
				player.usespring = true
				player.mo.state = S_PLAY_PAIN
				mo.stap = true
				mo.slowdown = 0
				if player.cmd.buttons & BT_JUMP
					if not player.recontr
						local g = P_SpawnGhostMobj(mo)
						g.destscale = mo.scale/2*3
						if g.tracer and g.tracer.valid
							g.tracer.destscale = mo.scale/2*3
						end
						S_StartSound(player.mo, sfx_iceb)
						if player.jumprecon
							player.jumprecon = $+1
						else
							player.jumprecon = 1
						end
						if player.jumprecon >= 7
							mo.cylooped = false
							mo.rollangle = 0
							mo.cylaunch = 0
							mo.slowdown = 0
							mo.removecy = 0
							mo.cycontact = 0
							mo.stap = false
							player.jumprecon = 0
							P_DoJump(player)
							mo.state = S_PLAY_JUMP
							player.pflags = $&~PF_JUMPED
							player.usespring = false
							player.powers[pw_flashing] = TICRATE*2
						end
					end
					player.recontr = true
				else
					player.recontr = false
				end
			end
		end
		if not P_IsObjectOnGround(mo)
			mo.intheairtoolong = $+1
			if mo.intheairtoolong >= TICRATE*5
				mo.intheairtoolong = 0
				mo.cylooped = false
				mo.rollangle = 0
				mo.cylaunch = 0
				mo.slowdown = 0
				mo.removecy = 0
				mo.cycontact = 0
				mo.stap = false
				if mo.player and mo.player.valid
					local player = mo.player
					if player and player.valid
					and player.playerstate == PST_LIVE
					and player.powers[pw_carry] != CR_NIGHTSMODE
					and not player.spectator
						player.jumprecon = 0
						mo.state = S_PLAY_FALL
						player.usespring = false
						player.powers[pw_flashing] = 5
					end
				end
			end
		end
		
		if P_IsObjectOnGround(mo)
		and not mo.cylaunch
			mo.cylooped = false
			mo.rollangle = 0
			mo.cylaunch = 0
			mo.slowdown = 0
			mo.removecy = 0
			mo.cycontact = 0
			mo.stap = false
			if mo.player and mo.player.valid
				local player = mo.player
				if player and player.valid
				and player.playerstate == PST_LIVE
				and player.powers[pw_carry] != CR_NIGHTSMODE
				and not player.spectator
					player.jumprecon = 0
					mo.state = S_PLAY_EDGE
					player.usespring = false
					player.powers[pw_flashing] = 5
				end
			end
		end
	end
end
local function CyloopTrailThinker(mo)
	if not ReturnEndCheck(mo,nil,"cyloop") return end
		if mo.addspecial 
			mo.addspecial = $-1
			mo.dospecial = true
		elseif mo.dospecial
			mo.flags = $|MF_SPECIAL
			mo.dospecial = false
		end
		if mo.resetyesitcan
			mo.resetyesitcan = $ - 1
			mo.doreset = true
		elseif mo.doreset
			mo.cancyloop = false
			mo.yesitcan = false
			mo.doreset = false
		end
		if mo.cancyloop
			if not mo.yesitcan
				mo.cyloop = 5
				CyloopFlash(mo)
				if mo.lastcl and mo.lastcl.valid
					local mobj = mo.lastcl
					mobj.cancyloop = true
					CyloopFlash(mobj)
				end
				if mo.nextcl and mo.nextcl.valid
					local mobj = mo.nextcl
					mobj.cancyloop = true
					CyloopFlash(mobj)
				end
				mo.resetyesitcan = 10
			end
			if not mo.lastcl
			and not mo.first
				if not mo.bruh
					mo.cancyloop = false
				end
				mo.bruh = true
			else
				mo.bruh = false
			end
			mo.yesitcan = true
		else
			mo.yesitcan = false
		end
		if mo.cyloop
			mo.cyloop = $-1
			if mo.lastcl and mo.lastcl.valid
				local mobj = mo.lastcl
				mobj.cyloop = 5
			end
			if mo.nextcl and mo.nextcl.valid
				local mobj = mo.nextcl
				mobj.cyloop = 5
			end
			if mo.target and mo.target.valid
			and mo.target.player and mo.target.player.valid
				mo.target.player.cyloopin = 5
			end
			if not mo.lastcl
			and not mo.first
				if not mo.bruh
					mo.cyloop = 0
				end
				mo.bruh = true
			else
				mo.bruh = false
			end
		end
end

addHook("ThinkFrame", function()
	for i,k in pairs(N_CyloopEnemies)
        local mo = N_CyloopEnemies[i]
        if not mo.valid
		or mo.health <= 0
            table.remove(N_CyloopEnemies, i)
            continue
        end
		if not (mo.flags & MF_NOTHINK)
			CyloopableThinker(mo)
			if mo.type == MT_CYLOOP
				CyloopTrailThinker(mo)
			end
		end
    end
end)

addHook("MobjDeath", function(mobj)
	if not ReturnEndCheck(mobj,nil,"enemydeath") return end
	mobj.cylooped = false
	mobj.rollangle = 0
	mobj.stap = false
	mobj.slowdown = false
	mobj.basht = false
end)

addHook("TouchSpecial", function(mobj, mo)
	if mobj and mobj.valid
		if mo and mo.valid
		and mobj.target and mobj.target.valid
		and mobj.target == mo
			mobj.cancyloop = true
			mobj.cyloop = 5
		end
		return true
	end
end, MT_CYLOOP)

freeslot("sfx_cyloop", "sfx_cylcls")

local function CyloopPhys(player)
	if not player.cyl
		local tang = player.drawangle
		if (player.cmd.forwardmove or player.cmd.sidemove)
		and player.ctrlAng
			tang = player.ctrlAng
		end
		player.cyang = tang
		if player.speed >= FixedMul(player.mo.scale,player.runspeed)
			player.keepspeed = player.speed
		else
			player.keepspeed = FixedMul(player.mo.scale,player.runspeed-5*FRACUNIT)
		end
		player.cyspeed = player.speed
	else
		if player.keepspeed
			local tang = player.drawangle
			if (player.cmd.forwardmove or player.cmd.sidemove)
			and player.ctrlAng
				tang = player.ctrlAng
			end
			local diff = tang-player.cyang
			local factor = 3
			if diff
				if (diff > ANGLE_180)
					diff = InvAngle(InvAngle($)/factor)
				else
					diff = $/factor
				end
				player.cyang = $+diff
			end
			if player.cyspeed+(player.keepspeed-FixedMul(player.mo.scale,player.speed))/3 < player.keepspeed
				player.cyspeed = $+(player.keepspeed-player.speed)/3
			else
				player.cyspeed = player.keepspeed
			end
			if player.cyang
				P_InstaThrust(player.mo, player.cyang, player.cyspeed)
			end
		end
	end
end

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		player.allofem = $ or 0
		player.cyloopin = $ or 0
		if player.cyloopin then player.cyloopin = $-1 end
		if not player.cyloop
			player.cyloop = {}
		end
		if player.cyloop
			local cx = 0
			local cy = 0
			local cz = 0
			local clcount = 0
			local t = player.cyloop
			for i,k in pairs(t)
				if t[i] and t[i].valid
				and t[i].target and t[i].target.valid
					cx = $+(t[i].x>>FRACBITS)
					cy = $+(t[i].y>>FRACBITS)
					cz = $+(t[i].z>>FRACBITS)
					clcount = $+1
				end
			end
			player.allofem = clcount
			player.cypos = {x = cx,y = cy,z = cz}
		end
		
		player.stopcyloop = $ or 0
		if player.stopcyloop then player.stopcyloop = $-1 end
		player.cygrace = $ or 0
		player.keepspeed = $ or 0
		if player.cygrace then player.cygrace = $-1 end
		if player.extrabutton and player.cmd.buttons & player.extrabutton
		and (P_IsObjectOnGround(player.mo) or player.cygrace)
		and player.speed >= FixedMul(player.mo.scale,5*FRACUNIT)
			if not (player.pflags & PF_SPINNING)
				CyloopPhys(player) --Frontiers physics be like
			end
			if not player.cyl
				player.cyloop = {}
				player.lastcl = nil
				if S_SoundPlaying(player.mo, sfx_cyloop)
					S_StopSoundByID(player.mo, sfx_cyloop)
				end
			else
				DoCyloop(player)
				if not S_SoundPlaying(player.mo, sfx_cyloop)
					S_StartSound(player.mo, sfx_cyloop)
				end
				SNEW_Cyaura(player, player.mo.color)
				if P_IsObjectOnGround(player.mo)
					player.cygrace = 5
				end
			end
			player.cyl = true
		else
			if player.cyl
				if player.cyloopin
					CheckInsideloop(player, player.cypos.x, player.cypos.y, player.cypos.z, player.allofem)
					S_StartSoundAtVolume(player.mo, sfx_cylcls, 255)
				end
				player.stopcyloop = 5
				player.lastcl = nil
				if S_SoundPlaying(player.mo, sfx_cyloop)
					S_StopSoundByID(player.mo, sfx_cyloop)
				end
				if player.cyaura and player.cyaura.valid
					P_KillMobj(player.cyaura)
				end
			end
			player.cyl = false
		end
	end
end)