freeslot("SPR_SFRL", "S_JUMPBALL", "S_JUMPOVER")
states[S_JUMPBALL] = {SPR_SFRL,A|FF_PAPERSPRITE|FF_FULLBRIGHT|FF_ADD,2,nil,0,0,S_NULL}
states[S_JUMPOVER] = {SPR_SFRL,B|FF_FULLBRIGHT|FF_ADD,2,nil,0,0,S_NULL}

local function DoJumpBall(player)
	if CanUse(player)
		player.jumproll = $+ANG15
		local sp = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_OVERLAY)
		sp.target = player.mo
		sp.state = S_JUMPBALL
		sp.color = player.mo.color
		sp.rollangle = player.jumproll
		
		if (player.dojumpball and not player.updash)
		or (not player.dojumpball and player.updash)
			local sb = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_OVERLAY)
			sb.target = player.mo
			sb.state = S_JUMPOVER
			sb.color = player.mo.color
		end
	end
end

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		player.dropbouncecd = $ or 0
		if player.dropbouncecd player.dropbouncecd = $-1 end
		player.jumproll = $ or 0
		player.dohijump = $ or 0
		if player.dohijump then player.dohijump = $-1 end
		if player.cmd.buttons & BT_SPIN
		and CanUse(player)
		and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
			if (player.pflags & PF_JUMPED)
			and not (player.pflags & PF_SPINNING)
			and not player.nearWall
			and not player.secondjump
				if not player.updash
				and not player.crollcd
					player.jumproll = 0
				elseif not player.crollcd
					DoJumpBall(player)
					if player.mo.state != S_PLAY_ROLL
					and not P_IsObjectOnGround(player.mo)
					and CanUse(player)
						player.mo.state = S_PLAY_ROLL
						player.mo.tics = 1
					end
					player.dohijump = 3
				end
			end
			player.updash = true
		else
			player.updash = false
		end
		if player.dojumpball
			DoJumpBall(player)
			if player.mo.state != S_PLAY_ROLL
			and not P_IsObjectOnGround(player.mo)
			and CanUse(player)
				player.mo.state = S_PLAY_ROLL
				player.mo.tics = 1
			end
		end
	
		player.crollcd = $ or 0
		if player.crollcd then player.crollcd = $-1 end
		player.redir = $ or 0
		if player.redir
			player.redir = $-1
			if player.ctrlAng
				player.redirect = player.ctrlAng
			else
				player.redirect = player.mo.angle
			end
			if player.redirect
			and R_PointToDist2(0,0,player.mo.momx,player.mo.momy) < player.respeed
			and abs(player.redirect-R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)) > ANG2
				P_Thrust(player.mo,player.redirect,FRACUNIT)
			end
			if ((player.pflags & PF_JUMPED)
			or not (player.pflags & PF_SPINNING))
			and not player.crollcd
				player.redir = 0
			end
		end
		if player.cmd.buttons & BT_SPIN
		and CanUse(player)
		and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
		and P_IsObjectOnGround(player.mo)
			if not player.uncurl
			and not player.crollcd
			and (player.pflags & PF_SPINNING)
				player.pflags = $&~PF_SPINNING
				if player.speed >= player.runspeed
					player.mo.state = S_PLAY_RUN
				else
					player.mo.state = S_PLAY_WALK
				end
				S_StartSound(player.mo, sfx_s3k42)
				player.crollcd = 3
			end
			player.uncurl = true
		else
			player.uncurl = false
		end
		if player.cmd.buttons & BT_SPIN
		and CanUse(player)
		and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
		and P_IsObjectOnGround(player.mo)
			if not player.rollspin
			and not player.crollcd
			and not (player.pflags & PF_SPINNING)
				if player.speed >= FixedMul(player.runspeed, player.mo.scale)
					if player.ctrlAng
						player.redirect = player.ctrlAng
					else
						player.redirect = player.mo.angle
					end
					player.respeed = player.speed
					player.redir = TICRATE*3
					player.pflags = $|PF_SPINNING
					player.mo.state = S_PLAY_ROLL
					S_StartSound(player.mo, sfx_spin)
				else
					if player.ctrlAng
						player.redirect = player.ctrlAng
					else
						player.redirect = player.mo.angle
					end
					player.pflags = $|PF_SPINNING
					player.mo.state = S_PLAY_ROLL
					P_InstaThrust(player.mo, player.redirect, FixedMul(player.mo.scale,30*FRACUNIT))
					player.respeed = player.speed
					player.redir = TICRATE*3
					S_StartSound(player.mo, sfx_spndsh)
					S_StartSound(player.mo, sfx_zoom)
				end
				if player.dohijump
				and not player.dropbouncecd
					P_SetObjectMomZ(player.mo, 10*FRACUNIT, true)
					S_StartSound(player.mo, sfx_thok)
					player.dojumpball = true
					if CBW_Battle
						player.dropbouncecd = TICRATE*3
					end
				end
				player.crollcd = 3
			end
			player.rollspin = true
		else
			player.rollspin = false
		end
		if player.mo.eflags & MFE_TOUCHWATER
		and player.dohijump
		and not player.dropbouncecd
			if player.speed >= FixedMul(player.runspeed, player.mo.scale)
				if player.ctrlAng
					player.redirect = player.ctrlAng
				else
					player.redirect = player.mo.angle
				end
				player.respeed = player.speed
				player.redir = TICRATE*3
				player.pflags = $|PF_SPINNING
				player.mo.state = S_PLAY_ROLL
				S_StartSound(player.mo, sfx_spin)
			else
				if player.ctrlAng
					player.redirect = player.ctrlAng
				else
					player.redirect = player.mo.angle
				end
				player.pflags = $|PF_SPINNING
				player.mo.state = S_PLAY_ROLL
				P_InstaThrust(player.mo, player.redirect, 30*FRACUNIT)
				player.respeed = player.speed
				player.redir = TICRATE*3
				S_StartSound(player.mo, sfx_spndsh)
				S_StartSound(player.mo, sfx_zoom)
			end
			player.pflags = $|PF_JUMPED
			player.pflags = $&~PF_SPINNING
			P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
			S_StartSound(player.mo, sfx_thok)
			player.dojumpball = true
			if CBW_Battle
				player.dropbouncecd = TICRATE*3
			end
			
			local s = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_SPLISH)
			S_StartSound(s, sfx_splish)
		end
		if (P_IsObjectOnGround(player.mo)
			or player.powers[pw_carry] 
			or player.usespring
			or player.wallCling)
		and player.dojumpball
		and not player.crollcd
			player.dojumpball = false
		end
	end
end)

addHook("MobjDamage", function(mo, mobj, src, dmg, dmgtype)
	if mo and mo.valid
	and mo.player and mo.player.valid
	and mo.skin == "sonicnew"
		local player = mo.player
		if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
		and not player.spectator
		and (player.updash or player.dojumpball)
			if dmgtype and dmgtype == DMG_SPIKE
				return true
			end
		end
	end
end, MT_PLAYER)