freeslot("MT_SONICSPRING")

mobjinfo[MT_SONICSPRING] = {
	doomednum = -1,
	spawnstate = S_REDSPRING,
	spawnhealth = 1000,
	painsound = sfx_spring,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 15*FRACUNIT,
	flags = MF_SPRING,
	raisestate = S_REDSPRING2
}

local function SpawnSnewSpring(player)
	local s = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SONICSPRING)
	s.momx = -player.mo.momx/3
	s.momy = -player.mo.momy/3
	s.momz = -player.mo.momz/3
	s.rollspring = ANG1-(ANG2*P_RandomRange(0, 1))
	if s.rollspring < 0
		s.addroll = -ANG1/5
	else
		s.addroll = ANG1/5
	end
	s.fuse = TICRATE/2*3
	if s and s.valid
		player.usespring = true
	end
	AddToTable(s,N_GlobalThinkers)
end

local byebye = {
	[0] = FF_FULLBRIGHT,
	[1] = FF_TRANS90,
	[2] = FF_TRANS80,
	[3] = FF_TRANS70,
	[4] = FF_TRANS60,
	[5] = FF_TRANS50,
	[6] = FF_TRANS40,
	[7] = FF_TRANS30,
	[8] = FF_TRANS20,
	[9] = FF_TRANS10
}

rawset(_G, "SNEWSpringThinker", function(mo)
	if mo and mo.valid
		if mo.addroll
			mo.rollangle = $+FixedAngle(abs(mo.momz))
		end
		if mo.fuse < 10
			local bop = byebye[mo.fuse]
			mo.frame = $|bop
		end
		
		mo.jumper = $ or 0
		if mo.jumper then mo.jumper = $-1 end
		if P_IsObjectOnGround(mo)
		and not mo.jumped
			mo.jumped = true
			mo.addroll = -$*2
			mo.jumper = 5
			P_SetObjectMomZ(mo, 5*FRACUNIT)
			if mo.fuse > 15
				mo.fuse = 15
			end
		end
		
		if (mo.eflags & MFE_JUSTHITFLOOR)
		and mo.jumped and not mo.jumper
			mo.addroll = 0
			mo.rollangle = 0
			for i = 1, 12
				local fa = (((360/12)*i)+P_RandomRange(-5, 5))*ANG1
				local ax = P_ReturnThrustX(nil, fa, mo.radius/2)
				local ay = P_ReturnThrustY(nil, fa, mo.radius/2)
				P_SpawnMobjFromMobj(mo, ax, ay, 0, MT_DUST)
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		if not player.usespring
		and not (player.pflags & PF_THOKKED)
		and CanUse(player, true)
		and not player.wallCling
		and not player.secondjump
		and not player.bashstate
		and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
			SpawnSnewSpring(player)
		end
	end
end)
freeslot("SPR_PTEN", "S_EPIC_UP", "S_EPIC_DOWN")
states[S_EPIC_UP] = {SPR_PTEN, A|FF_FULLDARK|FF_PAPERSPRITE, TICRATE, nil, 0, 0, S_NULL}
states[S_EPIC_DOWN] = {SPR_PTEN, B|FF_FULLDARK|FF_PAPERSPRITE, TICRATE, nil, 0, 0, S_NULL}
addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		if P_IsObjectOnGround(player.mo)
		or player.powers[pw_carry]
		or player.notrig
			player.usespring = false
		end
		if player.cmd.buttons & BT_SPIN
		and not P_IsObjectOnGround(player.mo)
		and not player.superwait
		and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
			if not player.recurl
			and CanUse(player)
			and not player.bashstate
			and not player.nearWall
			and not player.secondjump
			and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
			and (not (player.pflags & PF_JUMPED)
			or (player.pflags & PF_SPINNING) or (player.pflags & PF_NOJUMPDAMAGE))
				if (player.pflags & PF_SPINNING)
					S_StartSound(player.mo, sfx_s3k42)
				else
					S_StartSound(player.mo, sfx_spin)
				end
				player.pflags = $|PF_JUMPED
				player.pflags = $&~(PF_SPINNING|PF_NOJUMPDAMAGE)
				player.mo.state = S_PLAY_JUMP
				player.crollcd = 5
			end
			player.recurl = true
		else
			player.recurl = false
		end
	end
end)