rawset(_G,"TN_RemoveBall", function(mo) --Function for removing the ball
	local d = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	d.state = mo.state
	d.tics = TICRATE
	d.fuse = 15
	mo.state = mo.info.deathstate+3
	mo.tics = 1
end)

rawset(_G,"TN_ExplodeBall", function(mo) --Function for exploding the ball
	if mo.target and mo.target.valid
		P_RadiusAttack(mo, mo.target, 250*FRACUNIT, nil, true)
	end
	for i = 1, 12
		local fa = (360/12)*i*ANG1
		local ax = P_ReturnThrustX(nil, fa, 250*FRACUNIT)
		local ay = P_ReturnThrustY(nil, fa, 250*FRACUNIT)
		local ef = P_SpawnMobjFromMobj(mo, ax, ay, 0, MT_THOK)
		ef.state = S_DUSTLAYER3
		ef.fuse = 15
		ef.angle = R_PointToAngle2(ef.x, ef.y, mo.x, mo.y)+ANGLE_90
		P_Thrust(ef, ef.angle-ANGLE_90,15*FRACUNIT) 
		
		local w = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		w.radius = mo.radius
		w.height = mo.height*3
		w.flags2 = $|MF2_DONTDRAW
		w.breakwalls = true
		w.tics = -1
		w.fuse = 6
		P_Thrust(w, fa,40*FRACUNIT) 
	end
	P_ExplodeMissile(mo)
end)

rawset(_G, "TN_BallInteract", {})
--TN_BallInteract[<Object type>](mobj_t mobj, mobj_t ball)
--Your object type like: MT_TARGET (ATZ puzzle thing, more on wiki)

--Example:
local function ATZTargetBall(mo, b) --b is pretty useless here.
	if not mo.interacted
		mo.flags = $|MF_PUSHABLE
	end
	return 2
end
TN_BallInteract[MT_TARGET] = ATZTargetBall

--When returning 2: if the object has collision then dont execute it.
--But be aware, the collision can happen multiple times
--However you can check if the object and the ball collided before

--TN_RemoveBall(mobj_t ball)
--Might be useful for making the ball disappear after interacting with something.

--TN_ExplodeBall(mobj_t ball)
--Sometimes you may want to guide the ball and make it explode some enemies.