freeslot("SPR_WNDB", "SPR_WNEX", "S_WINDWAVE")
for i = 1, 16
	freeslot("S_WINDBALL"..i)
end
for i = 1, 4
	freeslot("S_WINDEXP"..i)
end

//Normal states (Thrown and not exploded)
states[S_WINDBALL1] = {SPR_WNDB, A|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL2}
states[S_WINDBALL2] = {SPR_WNDB, B|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL3}
states[S_WINDBALL3] = {SPR_WNDB, C|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL4}
states[S_WINDBALL4] = {SPR_WNDB, D|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL5}
states[S_WINDBALL5] = {SPR_WNDB, E|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL6}
states[S_WINDBALL6] = {SPR_WNDB, F|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL7}
states[S_WINDBALL7] = {SPR_WNDB, G|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL8}
states[S_WINDBALL8] = {SPR_WNDB, H|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL9}
states[S_WINDBALL9] = {SPR_WNDB, I|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL10}
states[S_WINDBALL10] = {SPR_WNDB, J|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL11}
states[S_WINDBALL11] = {SPR_WNDB, K|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL12}
states[S_WINDBALL12] = {SPR_WNDB, L|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL13}
states[S_WINDBALL13] = {SPR_WNDB, M|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL14}
states[S_WINDBALL14] = {SPR_WNDB, N|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL15}
states[S_WINDBALL15] = {SPR_WNDB, O|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL16}
states[S_WINDBALL16] = {SPR_WNDB, P|FF_FULLBRIGHT|FF_TRANS30, 3, nil, 0, 0, S_WINDBALL1}

//Explosion
states[S_WINDEXP1] = {SPR_WNEX, A, 2, nil, 0, 0, S_WINDEXP2}
states[S_WINDEXP2] = {SPR_WNEX, B, 2, nil, 0, 0, S_WINDEXP3}
states[S_WINDEXP3] = {SPR_WNEX, C, 2, nil, 0, 0, S_WINDEXP4}
states[S_WINDEXP4] = {SPR_WNEX, D, 2, nil, 0, 0, S_NULL}

mobjinfo[MT_WINDBALL] = {
	doomednum = -1,
	spawnstate = S_WINDBALL1,
	spawnhealth = 1,
	reactiontime = TICRATE*3,
	activesound = sfx_tink,
	deathstate = S_WINDEXP1,
	deathsound = sfx_s3kces,
	speed = 20*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 2,
	flags = MF_NOBLOCKMAP|MF_GRENADEBOUNCE|MF_BOUNCE|MF_MISSILE
}

local function CheckAndCrumble(mo, sec)
	for fof in sec.ffloors()
		if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
		if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
		if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
		if mo.z-mo.height > fof.topheight continue end -- Are we too high?

		-- Check for whatever else you may want to    

		EV_CrumbleChain(fof) -- Crumble
	end
end

addHook("MobjLineCollide", function(mo, line)
	if mo and mo.valid
	and (mo.type == MT_WINDBALL and mo.charged
	and mo.state >= mo.info.deathstate
	and mo.state <= mo.info.deathstate+2) or (mo.type == MT_THOK and mo.breakwalls)
		for _, sec in ipairs({line.frontsector, line.backsector})
			CheckAndCrumble(mo, sec)
		end
	end
end)

rawset(_G,"BallThink",function(mo)
	if mo and mo.valid
		mo.youarenotgoinganywhere = $ or 0
		if mo.youarenotgoinganywhere then mo.youarenotgoinganywhere = $-1 end
	
		if (not (mo.target and mo.target.valid))
		or (mo.target and mo.target.valid and not mo.target.player)
			mo.target = mo.tracer
		end
		mo.interacted = $ or 0
		if mo.interacted then mo.interacted = $-1 end
		local tr = P_SpawnGhostMobj(mo)
		tr.destscale = FRACUNIT/3
		tr.fuse = 7
		if mo.charged
			if mo.state >= mo.info.deathstate
			and mo.state <= mo.info.deathstate+2
				if mo.subsector and mo.subsector.sector
					CheckAndCrumble(mo, mo.subsector.sector)
				end
			end
			local am = 8
			for i = 0, am
				local fang = (360/am)*i*ANG1
				local fa = (leveltime%360)*ANG2+fang
				local rad = mo.radius*2
				local ax = P_ReturnThrustX(nil, fa, rad)
				local ay = P_ReturnThrustY(nil, fa, rad)
				local ef = P_SpawnMobjFromMobj(mo, ax, ay, 0, MT_THOK)
				ef.state = S_DUSTLAYER4
				ef.fuse = 2
				ef.momx = mo.momx
				ef.momy = mo.momy
				ef.momz = mo.momz
				ef.angle = R_PointToAngle2(ef.x, ef.y, mo.x, mo.y)+ANGLE_90
				ef.spriteyscale = FRACUNIT/3*2
				ef.spritexscale = FRACUNIT/3*2
				ef.spriteyoffset = -10*FRACUNIT
			end
		end
		if P_IsObjectOnGround(mo)
		and not mo.starttimer
			mo.starttimer = true
			mo.expt = mo.info.reactiontime
		end
		mo.expt = $ or 0
		if mo.expt
			if mo.starttimer
				mo.expt = $ - 1
				mo.doexplosion = true
			end
		elseif mo.doexplosion
			mo.doexplosion = false
			if mo.charged
				TN_ExplodeBall(mo)
			else
				TN_RemoveBall(mo)
			end
		end
	end
end)

addHook("MobjDeath", TN_ExplodeBall, MT_WINDBALL)

local function IsInZ(mobj, mo)
	if mo.z > (mobj.z+mobj.height)
		return
	end
	if (mobj.z-mobj.height) > (mo.z+mo.height)
		return
	end
	return true
end

addHook("MobjMoveCollide", function(mo, mobj)
	if mo and mo.valid
		if mobj and mobj.valid
		and IsInZ(mobj, mo)
		and TN_BallInteract[mobj.type]
			TN_BallInteract[mobj.type](mobj, mo)
			mo.interacted = 3
			if TN_BallInteract[mobj.type] == 2
				return false
			end
		end
	end
end, MT_WINDBALL)

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		if not CanUse(player)
		or player.powers[pw_tailsfly]
		or player.startascend
		or player.ballcd
			player.chball = false
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
		player.applycd = $ or 0
		player.ballcd = $ or 0
		player.balluses = $ or 0
		if player.applycd 
			player.applycd = $-1 
			player.resetballuses = true
		elseif player.resetballuses
			player.balluses = 0
			player.resetballuses = false
		end
		if player.ballcd then player.ballcd = $-1 end
		player.chargeball = $ or 0
		if player.extrabutton
		and player.cmd.buttons & player.extrabutton
			if ((not P_IsObjectOnGround(player.mo)) or (player.pflags & PF_SPINNING))
			and CanUse(player)
			and not player.powers[pw_tailsfly]
			and not player.airball
			and not player.startascend
			and not player.ballcd
				player.chball = true
				player.chargeball = TICRATE
				player.mo.momx = $/3*2
				player.mo.momy = $/3*2
				player.mo.momz = $/3
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.cantuseboost = 3
			end
			if player.airball
			and player.chball
			and CanUse(player)
			and not player.powers[pw_tailsfly]
			and not player.startascend
			and not player.ballcd
				player.cantuseboost = 3
				player.drawangle = player.mo.angle
				player.mo.state = S_PLAY_ROLL
				if P_IsObjectOnGround(player.mo)
					DoSpindashDust(player)
					player.normalspeed = 0
				else
					if not player.startascend
						player.normalspeed = skins[player.mo.skin].normalspeed
					end
				end
				player.mo.tics = 2
				player.chball = true
				player.chargeball = $-1
				if player.chargeball <= 5
					local mo = player.mo
					local am = 8
					for i = 0, am
						local fang = (360/am)*i*ANG1
						local fa = (leveltime%360)*ANG2+fang
						local rad = mo.radius/2*5
						local ax = P_ReturnThrustX(nil, fa, rad)
						local ay = P_ReturnThrustY(nil, fa, rad)
						local ef = P_SpawnMobjFromMobj(mo, ax, ay, 0, MT_THOK)
						ef.state = S_DUSTLAYER4
						if player.chargeball <= 0
							ef.state = S_DUSTLAYER4
						else
							ef.state = S_DUSTLAYER5
						end
						ef.fuse = 2
						ef.momx = mo.momx
						ef.momy = mo.momy
						ef.momz = mo.momz
						ef.angle = R_PointToAngle2(ef.x, ef.y, mo.x, mo.y)+ANGLE_90
						ef.spriteyscale = FRACUNIT/3
						ef.spritexscale = FRACUNIT/5*4
						ef.spriteyoffset = 10*FRACUNIT
					end
				end
			end
			player.airball = true
		else
			if player.airball
			and player.chball
			and CanUse(player)
			and not player.powers[pw_tailsfly]
			and not player.startascend
			and not player.ballcd
				player.cantuseboost = 3
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.drawangle = player.mo.angle
				player.chball = false
				local ball = P_SpawnPlayerMissile(player.mo, MT_WINDBALL, MF2_EXPLOSION)
				if ball and ball.valid
					AddToTable(ball,N_GlobalThinkers)
					ball.tracer = player.mo
					if player.chargeball <= 0
						ball.charged = true
					end
				end
				player.chargeball = 0
				player.applycd = 25 --You can throw 2 balls but if you try to throw 1 more you will have a cooldown
				player.balluses = $ + 1
				if player.balluses >= 2
					player.balluses = 0
					player.ballcd = TICRATE*2
				end
				P_SetObjectMomZ(player.mo, 5*FRACUNIT, true)
				P_Thrust(player.mo, player.mo.angle, -7*FRACUNIT)
				player.mo.state = S_PLAY_FALL
				player.dotailspin = true
				player.noremovespin = 3
				player.floatrun = 0
			end
			player.airball = false
		end
		player.noremovespin = $ or 0
		if player.noremovespin then player.noremovespin = $-1 end
		if player.dotailspin
		and (P_IsObjectOnGround(player.mo) 
			or player.powers[pw_carry] 
			or (player.mo.eflags & MFE_SPRUNG) 
			or player.boostflying
			or player.floatrunning)
		and not player.noremovespin
			player.dotailspin = false
			if not player.startascend
				player.normalspeed = skins[player.mo.skin].normalspeed
			end
		end
	end
end)