local function BoostCir(player)
	local daheg = 0
	if P_MobjFlip(player.mo) == -1
		daheg = -player.mo.height/2
	end
	local dash = P_SpawnMobjFromMobj(player.mo, 0, 0, daheg, MT_FACESTABBERSPEAR)
	dash.flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
	dash.fuse = 5
	dash.tics = 5
	dash.colorized = true
	dash.angle = player.drawangle+ANGLE_90
	dash.scale = FRACUNIT/3*2
	dash.destscale = FRACUNIT
	dash.color = player.mo.color
	dash.blendmode = AST_OVERLAY
	return dash
end

local function StopBoostfly(player)
	local daheg = 0
	if P_MobjFlip(player.mo) == -1
		daheg = -player.mo.height/2
	end
	local b = BoostCir(player)
	if player.flyup
		b.flags2 = $|MF2_SPLAT
		b.renderflags = $|RF_FLOORSPRITE
		b.scale = FRACUNIT/2*3
		b.destscale = FRACUNIT*2
		b.scalespeed = FRACUNIT/20
	end
	player.mo.state = S_PLAY_FALL
	player.boostflying = false
	S_StartSound(player.mo, sfx_nbmper)
end

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		player.boostfly = $ or 0
		player.boostspeed = $ or 40*FRACUNIT
		if player.boostfly then player.boostfly = $-1 end
		if player.boostfly and player.boostfly <= -1 then player.boostfly = 0 end
		player.doup = $ or 0
		if P_IsObjectOnGround(player.mo) --Reset variables.
			player.boostfly = TICRATE*3
			player.doup = 0
			player.flyup = false
			player.boostflying = false
		end
		player.cantuseboost = $ or 0
		if player.cantuseboost then player.cantuseboost = $ - 1 end
		if not P_IsObjectOnGround(player.mo)
		and not player.powers[pw_tailsfly]
		and CanUse(player)
		and not player.cantuseboost
			if player.cmd.buttons & BT_SPIN
				if not player.bfly
				and player.boostfly --Start the boostfly
					player.acceldash = 0
					player.stopaccel = 0
					player.doaccel = false
					player.pflags = $|PF_THOKKED|PF_JUMPED|PF_NOJUMPDAMAGE
					player.pflags = $&~PF_SPINNING
					player.powers[pw_tailsfly] = 0
					player.floatrun = 0
					player.mo.state = S_PLAY_RUN
					player.drawangle = player.mo.angle
					if player.speed < FixedMul(40*FRACUNIT, player.mo.scale)
						--P_InstaThrust(player.mo, player.drawangle, 30*FRACUNIT)
						player.boostspeed = 40*FRACUNIT
					else
						player.boostspeed = player.speed
					end
					BoostCir(player)
					S_StartSound(player.mo, sfx_ngskid)
					player.boostflying = true
					player.doup = 0
				elseif player.boostfly --Continue boostfly
					player.acceldash = 0
					player.stopaccel = 0
					player.doaccel = false
					local dovertc = false
					if player.lastx and player.lasty
					and R_PointToDist2(player.lastx, player.lasty, player.mo.x, player.mo.y) <= 30*FRACUNIT
						player.doup = $ + 1
						if player.doup >= 10
							if player.doup == 10
								S_StartSound(player.mo, sfx_prloop)
							end
							dovertc = true
						else
							dovertc = false
						end
					else
						player.doup = 0
					end
					
					player.pflags = $|PF_THOKKED|PF_JUMPED|PF_NOJUMPDAMAGE
					player.pflags = $&~PF_SPINNING
					player.powers[pw_tailsfly] = 0
					player.floatrun = 0
					if player.speed < FixedMul(player.boostspeed, player.mo.scale)
						P_Thrust(player.mo, player.drawangle, 2*FRACUNIT)
					end
					if (leveltime%5) == 0
						local b = BoostCir(player)
						if player.followmobj and player.followmobj.valid
						and not dovertc
							local mo = player.followmobj
							P_TeleportMove(b, mo.x, mo.y, b.z)
						end
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT
						b.scalespeed = FRACUNIT/15
						b.fuse = 10
						b.tics = 10
						b.blendmode = AST_ADD
						if dovertc
							P_TeleportMove(b, player.mo.x, player.mo.y, player.mo.z)
							b.flags2 = $|MF2_SPLAT
							b.renderflags = $|RF_FLOORSPRITE
							b.scale = FRACUNIT
							b.destscale = FRACUNIT/2*3
							b.scalespeed = FRACUNIT/20
						end
					end
					if dovertc
						player.mo.state = S_PLAY_FLY
						player.pflags = $|PF_CANCARRY
						player.flyup = true
						if (leveltime%5) == 0
						and (player.cmd.buttons & BT_JUMP)
							if player.followmobj and player.followmobj.valid
							and not (player.mo.eflags & MFE_UNDERWATER)
								player.followmobj.spriteyscale = FRACUNIT/3*4
								player.followmobj.spritexscale = FRACUNIT/3*2
							end
						end
					else
						player.mo.state = S_PLAY_RUN
						player.pflags = $&~PF_CANCARRY
						player.flyup = false
					end
					P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/10*4)*P_MobjFlip(player.mo), true)
					if (player.cmd.buttons & BT_JUMP)
					and player.mo.momz*P_MobjFlip(player.mo) < FixedMul(5*FRACUNIT, player.mo.scale)
						P_SetObjectMomZ(player.mo, FRACUNIT, true)
						player.boostfly = $ - 1
					end
					if not (player.mo.eflags & MFE_UNDERWATER)
					and (leveltime%10) == 0
						S_StartSound(player.mo, sfx_putput)
					end
					player.lastx = player.mo.x
					player.lasty = player.mo.y
					player.boostflying = true
				end
				if player.bfly
				and player.boostflying
				and not player.boostfly --Stop it
					StopBoostfly(player)
				end
				player.bfly = true
			else
				if player.bfly
				and player.boostflying --Stop boost fly
					StopBoostfly(player)
				end
				player.bfly = false
			end
		end
		player.dontdeflect = $ or 0
		if player.dontdeflect then player.dontdeflect = $-1 end
	end
end)

addHook("MobjDamage", function(mo, mobj, src, dmg, dmgtype) --Deflect stuff
	if mo and mo.valid
	and mo.player and mo.player.valid
	and not (dmgtype & DMG_DEATHMASK)
		local player = mo.player
		if player and player.valid and player.playerstate == PST_LIVE and not player.spectator
		and player.powers[pw_carry] != CR_NIGHTSMODE and mo.skin == "recenttails"
			if mobj and mobj.valid
			and not player.dontdeflect
			and player.boostflying
			and player.flyup
			and (mobj.flags & MF_MISSILE)
				mo.momz = $/3*2
				mobj.momx = -$
				mobj.momy = -$
				mobj.momz = -$
				player.boostfly = $-1
				player.dontdeflect = 15
				mo.nofrontiers = 5
				return true
			end
		end
	end
end, MT_PLAYER)