addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		player.floatrun = $ or 0
		local flysped = P_AproxDistance(P_AproxDistance(player.mo.momx,player.mo.momy),player.mo.momz/2*3)
		if P_IsObjectOnGround(player.mo) --Give a timer when on ground and enough speed
		and flysped >= player.runspeed
		and not player.powers[pw_tailsfly]
			if CBW_Battle
				player.floatrun = TICRATE
			else
				player.floatrun = TICRATE*5
			end
		elseif P_IsObjectOnGround(player.mo) --If on ground but no speed then no timer
			player.floatrun = 0
		end
		if (player.mo.eflags & MFE_SPRUNG) --No float run when sprung
		or player.powers[pw_tailsfly]
			player.floatrun = 0
		end
		if not P_IsObjectOnGround(player.mo) --Main float run stuff
		and not (player.pflags & PF_JUMPED)
		and not player.powers[pw_tailsfly]
		and flysped >= player.runspeed
		and player.floatrun
		and CanUse(player)
		and (player.cmd.forwardmove or player.cmd.sidemove)
		and not player.doaccel
			player.floatrun = $ - 1
			player.floatrunning = true
			player.pflags = $&~PF_SPINNING
			player.mo.state = S_PLAY_RUN
			P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/100*101)*P_MobjFlip(player.mo), true) --No gravity
			local minr = 1>>FRACBITS
			local maxr = player.mo.radius>>FRACBITS
			local ranr = P_RandomRange(minr, maxr)<<FRACBITS
			local rana = P_RandomRange(0, 360)*ANG1
			local ranx = P_ReturnThrustX(nil, rana, ranr)
			local rany = P_ReturnThrustY(nil, rana, ranr)
			local d = P_SpawnMobjFromMobj(player.mo, ranx, rany, 0, MT_SPINDUST)
			P_InstaThrust(d, 
				R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)+ANGLE_180+
				P_RandomRange(-15, 15)*ANG1, 
				P_RandomRange(FRACUNIT>>FRACBITS,(FRACUNIT*20)>>FRACBITS)<<FRACBITS)
			P_SetObjectMomZ(d, P_RandomRange(FRACUNIT>>FRACBITS,(FRACUNIT*5)>>FRACBITS)<<FRACBITS)
			if player.floatrun <= TICRATE*2
			and player.floatrun > TICRATE
			and P_RandomChance(FRACUNIT/2)
				d.state = S_NIGHTSPARKLE1
			end
			if player.floatrun <= TICRATE
			and P_RandomChance(FRACUNIT/2)
				d.state = S_NIGHTSPARKLESUPER1
			end
			d.tics = P_RandomRange(1, 8)
			if player.cmd.buttons & BT_JUMP --Air jump
				if not player.airjump
					player.floatrunning = false
					P_DoJump(player)
					for i = 1, 16
						local fixa = ((360/16)*i)*ANG1
						local rana2 = fixa+P_RandomRange(-5, 5)*ANG1
						local ranr2 = P_RandomRange(minr, maxr)<<FRACBITS
						local ranx2 = P_ReturnThrustX(nil, rana, ranr)
						local rany2 = P_ReturnThrustY(nil, rana, ranr)
						local d2 = P_SpawnMobjFromMobj(player.mo, ranx, rany, 0, MT_SPINDUST)
						P_InstaThrust(d2, R_PointToAngle2(d2.x, d2.y, player.mo.x, player.mo.y)+ANGLE_180, R_PointToDist2(d2.x, d2.y, player.mo.x, player.mo.y)/5)
						P_SetObjectMomZ(d2, FRACUNIT)
					end
					player.floatrun = 0
				end
				player.airjump = true
			else
				player.airjump = false
			end
			if (leveltime%10) == 0
				S_StartSound(player.mo, sfx_putput)
			end
		end
		if ((flysped < player.runspeed) or not player.floatrun) --When no longer float running go to fall state
		and player.floatrunning
			player.mo.state = S_PLAY_FALL
			player.floatrunning = false
		end
		if P_IsObjectOnGround(player.mo)
			player.floatrunning = false
		end
	end
end)