--Most of this is Source Code.

rawset(_G, "DoSpindashDust", function(player)
	for i = 1, (leveltime%7)/2
		local p = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
		if player.mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER)
			p.state = S_SPINDUST_BUBBLE1
		elseif (player.powers[pw_shield] == SH_ELEMENTAL)
			p.state = S_SPINDUST_FIRE1
		end
		p.target = player.mo
		p.scale = (2*player.mo.scale)/3
		if P_MobjFlip(player.mo) == -1
			P_TeleportMove(p, p.x, p.y, player.mo.z+player.mo.height-p.height)
		end
		local pr = {}
		pr[0] = P_RandomFixed()<<2
		pr[1] = P_RandomRange(-30, 30)
		pr[2] = P_RandomFixed()<<3
		P_SetObjectMomZ(p, player.dashspeed/50+pr[0], false)
		P_InstaThrust(p,
			player.drawangle + (pr[1]*ANG1),
			-FixedMul(player.dashspeed/12+FRACUNIT+pr[2], player.mo.scale))
		P_TryMove(p, p.x+p.momx, p.y+p.momy, true)
	end
end)

addHook("PlayerCanDamage", function(player, mo)
	if player.valid and player.playerstate == PST_LIVE and not player.spectator
	and player.powers[pw_carry] != CR_NIGHTSMODE and player.mo.skin == "recenttails"
		local bottomheight = player.mo.z
		local topheight = player.mo.z+player.mo.height
		if (player.mo.eflags & MFE_VERTICALFLIP)
			local swap = bottomheight
			bottomheight = topheight
			topheight = swap
		end
		if P_MobjFlip(player.mo)*(topheight-(mo.z+(mo.height/2))) > 0
			if not (player.mo.eflags & MFE_UNDERWATER) and (P_MobjFlip(player.mo)*(player.mo.momz - mo.momz) > 0)
			and player.powers[pw_tailsfly]
				return true
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		if not (player.pflags & PF_THOKKED)
		and not (player.powers[pw_tailsfly])
		and CanUse(player)
			player.mo.state = S_PLAY_FLY
			player.powers[pw_tailsfly] = tailsflytics+1
			
			player.pflags = $&~(PF_JUMPED|PF_NOJUMPDAMAGE|PF_SPINNING|PF_STARTDASH)
			player.pflags = $|PF_THOKKED|PF_CANCARRY
			if player.followmobj and player.followmobj.valid
			and not (player.mo.eflags & MFE_UNDERWATER)
				player.followmobj.spriteyscale = FRACUNIT/3*4
				player.followmobj.spritexscale = FRACUNIT/3*2
			end
			player.acceldash = 0
			player.stopaccel = 0
			player.doaccel = false
		elseif (player.pflags & PF_THOKKED) and CanUse(player)
			if player.powers[pw_tailsfly]
				if player.followmobj and player.followmobj.valid
				and not (player.mo.eflags & MFE_UNDERWATER)
					player.followmobj.spriteyscale = FRACUNIT/3*4
					player.followmobj.spritexscale = FRACUNIT/3*2
				end
				player.fly1 = 20
				
				if player.speed > FixedMul(8*FRACUNIT,player.mo.scale) and player.speed > FixedMul(player.normalspeed>>1, player.mo.scale)
					P_Thrust(player.mo, R_PointToAngle2(0,0, player.mo.momx, player.mo.momy), FixedMul(-4*FRACUNIT, player.mo.scale))
				end
			end
			player.acceldash = 0
			player.stopaccel = 0
			player.doaccel = false
		end
		return true
	end
end)

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		if player.followmobj and player.followmobj.valid --Make the tails`s tails go back.
			local diffy = FRACUNIT-player.followmobj.spriteyscale
			local diffx = FRACUNIT-player.followmobj.spritexscale
			local factor = FRACUNIT/6
			if diffy
				diffy = FixedMul($,factor)
				player.followmobj.spriteyscale = $+diffy
			end
			if diffx
				diffx = FixedMul($,factor)
				player.followmobj.spritexscale = $+diffx
			end
		end
		if not (player.pflags & PF_STARTDASH) --Make tails squish back
			local diffy = FRACUNIT-player.mo.spriteyscale
			local diffx = FRACUNIT-player.mo.spritexscale
			local factor = FRACUNIT/5
			if diffy
				diffy = FixedMul($,factor)
				player.mo.spriteyscale = $+diffy
			end
			if diffx
				diffx = FixedMul($,factor)
				player.mo.spritexscale = $+diffx
			end
		end
		if P_IsObjectOnGround(player.mo)
			player.powers[pw_tailsfly] = 0
			player.wasflying = false
		end
		if player.powers[pw_tailsfly] --Tails fly
		and (player.mo.eflags & MFE_UNDERWATER) --When underwater decrease gravity
			P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/tailsflytics*player.powers[pw_tailsfly])*P_MobjFlip(player.mo), true)
		end
		if player.powers[pw_tailsfly] --Tails fly
		and not (player.mo.eflags & MFE_UNDERWATER) --Decrease gravity and other stuff
			player.wasflying = true
			P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/tailsflytics*player.powers[pw_tailsfly])*P_MobjFlip(player.mo), true)
			player.powers[pw_tailsfly] = $ - 1 --Decrease fly time because CA_SWIM doesnt do that
			local actionspd = player.actionspd/100
			if (player.charflags & SF_MULTIABILITY) 
			and player.cmd.buttons & BT_JUMP and not (player.pflags & PF_STASIS) and not player.exiting
				if player.followmobj and player.followmobj.valid
				and not (player.mo.eflags & MFE_UNDERWATER)
					player.followmobj.spriteyscale = FRACUNIT/3*4
					player.followmobj.spritexscale = FRACUNIT/3*2
				end
			end
			if P_MobjFlip(player.mo)*player.mo.momz < FixedMul(5*actionspd, player.mo.scale) --The actual fly part
				if (player.charflags & SF_MULTIABILITY) 
					if player.cmd.buttons & BT_JUMP and not (player.pflags & PF_STASIS) and not player.exiting
						P_SetObjectMomZ(player.mo, actionspd/3, true)
					end
				else
					if player.fly1
						if P_MobjFlip(player.mo)*player.mo.momz < FixedMul(5*actionspd, player.mo.scale)
							P_SetObjectMomZ(player.mo, actionspd/2, true)
						end
						player.mo.state = states[player.mo.state].nextstate
						player.fly1 = $-1
					end
				end
			end
			if player.powers[pw_tailsfly]
			and not (player.mo.eflags & MFE_UNDERWATER) --Play the sound
			and (leveltime%10) == 0
			and not player.spectator
			and not player.boostflying
				S_StartSound(player.mo, sfx_putput)
			end
			
			--Go down with spin
			if player.cmd.buttons & BT_SPIN and not (player.pflags & PF_STASIS) and not player.exiting and not (player.mo.eflags & MFE_GOOWATER)
				if P_MobjFlip(player.mo)*player.mo.momz > -FixedMul(5*actionspd, player.mo.scale)
					if player.fly1 > 2
						player.fly1 = 2
					end
					P_SetObjectMomZ(player.mo, -actionspd/2, true)
					if player.followmobj and player.followmobj.valid
					and not (player.mo.eflags & MFE_UNDERWATER)
						player.followmobj.spriteyscale = FRACUNIT/5*4
						player.followmobj.spritexscale = FRACUNIT/5*6
					end
				end
			end
		elseif not (player.mo.eflags & MFE_UNDERWATER) --Get tired
		and player.wasflying
			if player.panim == PA_ABILITY and player.mo.state != S_PLAY_FLY_TIRED
				player.mo.state = S_PLAY_FLY_TIRED
			end
			if player.mo.state == S_PLAY_FLY_TIRED
				P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/4*3)*P_MobjFlip(player.mo), true)
			end
			if (leveltime%10) == 0
			and player.mo.state == S_PLAY_FLY_TIRED
			and not (player.mo.eflags & MFE_UNDERWATER)
			and not player.spectator
			and not player.boostflying
				S_StartSound(player.mo, sfx_pudpud)
			end
		end
		--Spindash but cool
		if player.acceldash and player.doaccel
		and player.speed <= FRACUNIT
		and P_IsObjectOnGround(player.mo)
			player.acceldash = 0
			player.stopaccel = 0
			player.doaccel = false
		end
		local canstand = (not player.mo.standingslope or (player.mo.standingslope.flags & SL_NOPHYSICS) or abs(player.mo.standingslope.zdelta) < FRACUNIT/2)
		//Start revving
		if ((player.cmd.buttons & BT_SPIN) and (player.speed < FixedMul(5<<FRACBITS, player.mo.scale)) --Start up anim.
		and not player.mo.momz and P_IsObjectOnGround(player.mo) and not (player.pflags & PF_SPINNING) and not player.wasspindashing
		and canstand)
		and CanUse(player)
			player.mo.momx = player.cmomx
			player.mo.momy = player.cmomy
			player.pflags = $|PF_SPINDOWN|PF_STARTDASH|PF_SPINNING
			player.dashspeed = player.mindash
			player.mo.state = S_PLAY_ROLL
			if not player.spectator
				S_StartSound(player.mo, sfx_spndsh)
			end
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
		elseif ((player.cmd.buttons & BT_SPIN) and (player.pflags & PF_STARTDASH))
		and CanUse(player)
			DoSpindashDust(player) --Mics. stuff
			player.cantuseboost = TICRATE
			if player.stunpainrings
				player.stunpainrings = 0
				P_SetObjectMomZ(player.mo, 5*FRACUNIT)
				P_InstaThrust(player.mo, player.drawangle, 15*FRACUNIT)
				player.mo.state = S_PLAY_ROLL
				player.pflags = $|PF_JUMPED|PF_THOKKED|PF_SPINNING
				player.pflags = $&~PF_NOJUMPDAMAGE
				player.floatrun = 0
				player.powers[pw_flashing] = flashingtics-1
				S_StartSound(player.mo, sfx_zoom)
			end
			if player.mo.tics <= 1
				local step = (player.maxdash - player.mindash)/6
				local speed = (player.dashspeed - player.mindash)
				if (speed > 6*step) --Yandere dev be like
					player.mo.state = S_PLAY_SPINDASH
					player.mo.tics = 2
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
				elseif (speed > 5*step)
					player.mo.state = S_PLAY_ROLL
					player.mo.tics = 2
				elseif (speed > 4*step)
					player.mo.state = S_PLAY_ROLL
					player.mo.tics = 3
				elseif (speed > 3*step)
					player.mo.state = S_PLAY_ROLL
					player.mo.tics = 3
				elseif (speed > 2*step)
					player.mo.state = S_PLAY_ROLL
					player.mo.tics = 4
				elseif (speed > step)
					player.mo.state = S_PLAY_ROLL
					player.mo.tics = 4
				else
					player.mo.state = S_PLAY_ROLL
					player.mo.tics = 4
				end
				/*if player.mo.state != S_PLAY_SPINDASH
					local toang = FixedAngle(player.dashspeed-player.mindash)
					player.mo.spriteyscale = FRACUNIT + FixedMul(FRACUNIT/8, sin(toang))
					player.mo.spritexscale = FRACUNIT - FixedMul(FRACUNIT/10*3, sin(toang))
				end*/
			end
			player.wasspindashing = true
			if player.speed > 5*player.mo.scale --From spindash into a roll
				player.pflags = $&~PF_STARTDASH
				player.mo.state = S_PLAY_ROLL
				S_StartSound(player.mo, sfx_spin)
				player.mo.spritexscale = FRACUNIT/3*5
				player.mo.spriteyscale = FRACUNIT/3*2
				player.cantuseboost = 2
			end
			if (player.dashspeed < player.mindash) then player.dashspeed = player.mindash end
			if (player.dashspeed > player.maxdash) then player.dashspeed = player.maxdash end
			if (player.dashspeed < player.maxdash and player.mindash != player.maxdash) --Play spindash sound
				local chargecalculation = (6*(player.dashspeed - player.mindash))/(player.maxdash - player.mindash)
				player.dashspeed = $+FRACUNIT
				local soundcalculation = (6*(player.dashspeed - player.mindash))/(player.maxdash - player.mindash)
				if not player.spectator and soundcalculation != chargecalculation
					S_StartSound(player.mo, sfx_spndsh)
				end
			end
			if player.revitem and not (leveltime%5)
				P_SpawnSpinMobj(player, player.revitem)
			end
		elseif ((player.cmd.buttons & BT_SPIN or ((twodlevel or (player.mo.flags2 & MF2_TWOD)) and player.cmd.forwardmove < 20)) --Roll
		and CanUse(player)
			and not player.climbing and not player.mo.momz and P_IsObjectOnGround(player.mo) and (player.speed >= FixedMul(5<<FRACBITS, player.mo.scale)
			or not canstand) and not (player.pflags & PF_SPINNING))
			player.pflags = $|PF_SPINDOWN|PF_SPINNING
			player.mo.state = S_PLAY_ROLL
			player.cantuseboost = 2
			if not player.spectator
				S_StartSound(player.mo, sfx_spin)
			end
			player.mo.spritexscale = FRACUNIT/3*5
			player.mo.spriteyscale = FRACUNIT/3*2
			if player.stunpainrings
				player.stunpainrings = 0
				P_SetObjectMomZ(player.mo, 5*FRACUNIT)
				P_InstaThrust(player.mo, player.drawangle, 15*FRACUNIT)
				player.mo.state = S_PLAY_ROLL
				player.pflags = $|PF_JUMPED|PF_THOKKED|PF_SPINNING
				player.pflags = $&~PF_NOJUMPDAMAGE
				player.floatrun = 0
				player.powers[pw_flashing] = flashingtics-1
				S_StartSound(player.mo, sfx_zoom)
			end
		else --Dash
			if (P_IsObjectOnGround(player.mo) and (player.pflags & PF_STARTDASH) and (player.pflags & PF_SPINNING)) --The actual dash
			and CanUse(player)
				player.pflags = $&~PF_STARTDASH
				if player.powers[pw_carry] == CR_BRAKGOOP
					player.dashspeed = 0
				end
				if (not ((gametyperules & GTR_RACE) and leveltime < 4*TICRATE))
					if player.dashspeed
						player.mo.state = S_PLAY_ROLL
						player.pflags = $|PF_SPINNING
						P_InstaThrust(player.mo, player.mo.angle, 15*FRACUNIT)
					else
						player.mo.state = S_PLAY_STND
						player.pflags = $&~PF_SPINNING
					end
					if not player.spectator
						S_StartSound(player.mo, sfx_zoom)
					end
				end
				player.mo.spritexscale = FRACUNIT/3*5
				player.mo.spriteyscale = FRACUNIT/3*2
				player.acceldash = player.dashspeed
				player.doaccel = true
				player.dashspeed = 0
				player.cantuseboost = 2
				player.wasspindashing = false
			end
		end
		player.stopaccel = $ or 0
		if (not ((gametyperules & GTR_RACE) and leveltime < 4*TICRATE))
		and player.acceldash and player.doaccel
			if not (player.pflags & PF_SPINNING)
				player.pflags = $|PF_SPINNING
			end
			if player.mo.state != S_PLAY_ROLL
				player.mo.state = S_PLAY_ROLL
			end
			if player.speed < player.acceldash
				local maxspeed = FixedMul(player.acceldash, player.mo.scale)
				if player.speed < maxspeed-5*FRACUNIT
					P_Thrust(player.mo, player.mo.angle, FRACUNIT)
				end
				if player.speed >= maxspeed-5*FRACUNIT
					P_Thrust(player.mo, player.mo.angle, maxspeed-player.speed)
				end
				player.stopaccel = $ + 1
				if player.stopaccel >= (player.acceldash/FRACUNIT)/2*5
					player.acceldash = 0
					player.stopaccel = 0
					player.doaccel = false
				end
			end
		end
		if not P_IsObjectOnGround(player.mo) --Revert the player back after spindashing
		and player.wasspindashing
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
			player.wasspindashing = false
		end
		if player.wasspindashing
		and not (player.pflags & PF_SPINNING)
			player.wasspindashing = false
		end
	end
end)