addHook("MobjSpawn", function(mo) --When a monitor spawns set its origin point
	if mo and mo.valid
	and (mo.flags & MF_MONITOR)
		mo.shouldgoback = true
		mo.gobackmonitor = {
		x = mo.x,
		y = mo.y,
		z = mo.z,
		a = mo.angle,
		f = P_MobjFlip(mo)}
		if not TN_EnemyCarry[mo.type]
			TN_EnemyCarry[mo.type] = {type = "heavy", var = FRACUNIT}
		end
	end
end)

rawset(_G,"MonitorRespawn", function(mo) --When it was away from original postion for too long, respawn.
		local px = mo.gobackmonitor.x
		local py = mo.gobackmonitor.y
		local pz = mo.gobackmonitor.z
		if P_AproxDistance(P_AproxDistance(px-mo.x,py-mo.y),pz-mo.z) >= 100*FRACUNIT
		and mo.carry and mo.carry.valid
			mo.respawn = 0
			mo.flags2 = $&~MF2_DONTDRAW
			local g = P_SpawnMobj(px, py, pz, MT_PARTICLE)
			g.state = mo.info.spawnstate
			g.angle = mo.gobackmonitor.a
			g.fuse = 2
			g.frame = mo.frame|tr_trans90<<FF_TRANSSHIFT
			if mo.gobackmonitor.f == 1
				g.flags2 = $&~MF2_OBJECTFLIP
				g.eflags = $&~MFE_VERTICALFLIP
			else
				g.flags2 = $|MF2_OBJECTFLIP
				g.eflags = $|MFE_VERTICALFLIP
			end
		end
		if not mo.carry
			local dist = P_AproxDistance(P_AproxDistance(px-mo.x,py-mo.y),pz-mo.z)
			mo.respawn = $ or 0
			if dist >= 100*FRACUNIT
				local g = P_SpawnMobj(px, py, pz, MT_PARTICLE)
				g.state = mo.info.spawnstate
				g.sprite = mo.sprite
				g.sprite2 = mo.sprite2
				g.frame = mo.frame
				g.angle = mo.gobackmonitor.a
				g.fuse = 2
				local appear = {
				[-1] = tr_trans90,
				[0] = tr_trans90,
				[1] = tr_trans90,
				[2] = tr_trans80,
				[3] = tr_trans70,
				[4] = tr_trans60,
				[5] = tr_trans50,
				[6] = tr_trans40,
				[7] = tr_trans30,
				[8] = tr_trans20,
				[9] = tr_trans10,
				[10] = tr_trans10,
				[11] = tr_trans10,
				[12] = tr_trans10,
				[13] = tr_trans10,
				[14] = tr_trans10,
				[15] = tr_trans10}
				g.frame = mo.frame|appear[mo.respawn/TICRATE]<<FF_TRANSSHIFT
				if mo.gobackmonitor.f == 1
					g.flags2 = $&~MF2_OBJECTFLIP
					g.eflags = $&~MFE_VERTICALFLIP
				else
					g.flags2 = $|MF2_OBJECTFLIP
					g.eflags = $|MFE_VERTICALFLIP
				end
				mo.respawn = $+1
				if mo.respawn >= TICRATE*7
					local flashinc = TICRATE*10-(mo.respawn-(TICRATE/10*19))
					if flashinc < 2
						flashinc = 2
					end
					if (leveltime%flashinc) <= ((flashinc-1)/2)
						mo.flags2 = $|MF2_DONTDRAW
					else
						mo.flags2 = $&~MF2_DONTDRAW
					end
				end
				if mo.respawn >= TICRATE*10
					mo.respawn = 0
					mo.flags2 = $&~MF2_DONTDRAW
					P_TeleportMove(mo, px, py, pz)
					mo.angle = mo.gobackmonitor.a
					if mo.gobackmonitor.f == 1
						mo.flags2 = $&~MF2_OBJECTFLIP
						mo.eflags = $&~MFE_VERTICALFLIP
					else
						mo.flags2 = $|MF2_OBJECTFLIP
						mo.eflags = $|MFE_VERTICALFLIP
					end
					if not (mo.flags & MF_MONITOR) --Monitor was broken
						mo.flags = mo.info.flags &~(MF_SHOOTABLE|MF_MONITOR)
					end
				end
			end
		end
end)

addHook("PlayerSpawn", function(player)
	if not N_ReturnPlayer(player) return end
	
	player.startsucc = 0
	player.dodasuck = false
	player.nodrop = 0
	player.droprangs = false
	player.stopsound = false
	player.applycd = 0
	player.ballcd = 0
	player.balluses = 0
	player.superjump = 0
	player.wjumpcd = 0
end)

addHook("ShieldSpecial", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		return true
	end
end)

addHook("PlayerThink", function(player) --Execute Frontiers DMG last.
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		player.stunpainrings = $ or 0
		if player.stunpainrings then player.stunpainrings = $-1; player.pflags = $|PF_FULLSTASIS; player.mo.state = S_PLAY_PAIN; player.powers[pw_flashing] = flashingtics end
		player.nodrop = $ or 0
		if player.nodrop then player.nodrop = $-1 end
		if player.droprangs --Frontiers DMG system.
		and not player.nodrop
		and P_IsObjectOnGround(player.mo)
			local microp = {x = player.mo.momx, y = player.mo.momy}
			player.mo.momx = -$
			player.mo.momy = -$
			P_PlayerRingBurst(player)
			P_PlayRinglossSound(player.mo)
			player.rings = 0
			player.mo.momx = microp.x
			player.mo.momy = microp.y
			player.droprangs = false
			player.stunpainrings = flashingtics/3
			player.powers[pw_flashing] = flashingtics-1
			player.mo.spriteyscale = FRACUNIT/2
			player.mo.spritexscale = FRACUNIT*2
		end
		if player.mo.nofrontiers then player.mo.nofrontiers = $-1 end
	end
end)

addHook("MobjDamage", function(mo, mobj, src, dmg, dmgtype) --When getting hit, dont drop rings.
	if mo and mo.valid
	and mo.player and mo.player.valid
	and not (dmgtype & DMG_DEATHMASK)
		if mobj and mobj.valid
			if mobj.gotosucc and mobj.gotosucc.valid
			and mobj.gotosucc == mo
				mo.nofrontiers = 5
				return true
			end
			if mobj.carry and mobj.carry.valid
			and mobj.carry == mo
				mo.nofrontiers = 5
				return true
			end
		end
		if mo.player.rings
			local player = mo.player
			if player and player.valid and player.playerstate == PST_LIVE and not player.spectator
			and player.powers[pw_carry] != CR_NIGHTSMODE and mo.skin == "recenttails"
				if not player.powers[pw_shield]
				and not player.mo.nofrontiers
					player.losstime = $+TICRATE*5
					player.powers[pw_shield] = SH_PITY
					player.nodrop = 15
					player.droprangs = true
				end
			end
		end
	end
end, MT_PLAYER)