rawset(_G,"WindThinker", function(mo)
		mo.jumps = $ or 0
		local jum = mo.jumps
		if mo.jumps == 2
			jum = 4
		end
		if jum > 1
			for i = 1, jum
				local fa = (360/jum)*i*ANG1 + (5-jum)*ANG1
				local rot = (leveltime%360)*ANG2 + fa
				local addx = P_ReturnThrustX(nil, rot, mo.radius)
				local addy = P_ReturnThrustY(nil, rot, mo.radius)
				if mo.jumps == 2
					addx = P_ReturnThrustX(nil, rot, mo.radius/4*3)
					addy = P_ReturnThrustY(nil, rot, mo.radius/4*3)
				end
				local wind = P_SpawnMobjFromMobj(mo, addx, addy, 0, MT_PARTICLE)
				wind.state = S_DUSTLAYER1
				wind.fuse = 2
				wind.momx = mo.momx
				wind.momy = mo.momy
				wind.momz = mo.momz
				wind.angle = rot+ANGLE_90
				wind.spriteyscale = FRACUNIT/3
				wind.spritexscale = FRACUNIT/jum*5
				if mo.jumps == 2
					wind.spriteyscale = FRACUNIT/2
				end
				wind.colorized = true
				wind.color = mo.color
				if mo.fuse <= 5
					wind.state = S_DUSTLAYER3
					if mo.fuse <= 2
						wind.state = S_DUSTLAYER5
					end
				end
			end
		end
		for s = 1, 5
			local fa = (360/5)*s*ANG2
			local rot = (leveltime%360)*ANG1 + fa
			local ax = P_ReturnThrustX(nil, rot, mo.radius/3*2)
			local ay = P_ReturnThrustY(nil, rot, mo.radius/3*2)
			local wind = P_SpawnMobjFromMobj(mo, ax, ay, 0, MT_PARTICLE)
			wind.state = S_DUSTLAYER2
			wind.fuse = 2
			wind.momx = mo.momx
			wind.momy = mo.momy
			wind.momz = mo.momz
			wind.angle = rot+ANGLE_90
			wind.spriteyscale = FRACUNIT/2
			if jum <= 1
				wind.colorized = true
				wind.color = mo.color
				wind.state = S_DUSTLAYER1
			end
			if mo.fuse <= 5
				wind.state = S_DUSTLAYER3
				if mo.fuse <= 2
					wind.state = S_DUSTLAYER5
				end
			end
		end
end)

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
		player.superjump = $ or 0
		local sz = 0
		local fz = 0
		if player.startz
			sz = player.startz
		end
		if player.finz
			fz = player.finz
		end
		if player.superjump
			player.superjump = $ - 1
			
			local jumpheg = fz-(player.mo.z+player.mo.height/2)
			P_SetObjectMomZ(player.mo, jumpheg/10)
			player.mo.state = S_PLAY_SPRING
			player.pflags = $|PF_JUMPED|PF_STARTJUMP|PF_THOKKED|PF_NOJUMPDAMAGE
			player.powers[pw_tailsfly] = 0
			
			local fa = (player.superjump%360)*ANG30 - FixedAngle(abs(player.mo.momz))*2
			local ax = P_ReturnThrustX(nil, fa, player.mo.radius*2)
			local ay = P_ReturnThrustY(nil, fa, player.mo.radius*2)
			local wind = P_SpawnMobjFromMobj(player.mo, ax, ay, 0, MT_THOK)
			wind.state = S_DUSTLAYER2
			wind.angle = fa+ANGLE_90
			wind.spritexscale = FRACUNIT/2
			wind.spriteyscale = FRACUNIT/3
			wind.tics = TICRATE/2*3
			wind.fuse = TICRATE*2
			P_Thrust(wind, fa, FRACUNIT)
			
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.scale = player.mo.scale
			ghost.destscale = player.mo.scale/2
			ghost.colorized = true
			ghost.fuse = 5
			ghost.color = SKINCOLOR_GREY
			if ghost.tracer and ghost.tracer.valid
				ghost.tracer.scale = player.mo.scale
				ghost.tracer.destscale = player.mo.scale/2
				ghost.tracer.colorized = true
				ghost.tracer.fuse = 5
				ghost.tracer.color = SKINCOLOR_GREY
			end
			
			local daheight = player.mo.z+player.mo.height
			local dacel = player.mo.ceilingz
			if P_MobjFlip(player.mo) == 1
				daheight = player.mo.z+player.mo.height
				dacel = player.mo.ceilingz
			else
				daheight = player.mo.z
				dacel = player.mo.floorz
			end
			if not (player.pflags & PF_JUMPED)
			or (player.mo.momz*P_MobjFlip(player.mo) <= player.mo.scale*5)
				player.superjump = 0
			end
			player.bravejump = true
		elseif player.bravejump
			player.mo.state = S_PLAY_JUMP
			player.pflags = $|PF_JUMPED
			player.usespring = false
			player.secondjump = 0
			player.pflags = $&~(PF_THOKKED|PF_NOJUMPDAMAGE)
			if (player.charflags & SF_NOJUMPDAMAGE)
				player.pflags = $|PF_NOJUMPDAMAGE
			end
			player.bravejump = false
		end
	if player.mo.skin == "recenttails"
		player.wjumpcd = $ or 0
		if player.wjumpcd then player.wjumpcd = $-1 end
		if player.extrabutton
		and player.cmd.buttons & player.extrabutton
			if P_IsObjectOnGround(player.mo)
			and CanUse(player) and not (player.pflags & PF_SPINNING)
				if not player.wjump
				and not player.wjumpcd
					player.wjumpcd = 15*TICRATE
					local jpad = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PARTICLE)
					jpad.jumppad = true
					jpad.color = player.mo.color
					jpad.flags = MF_NOGRAVITY|MF_SPECIAL
					jpad.height = 60*FRACUNIT/5*6
					jpad.radius = 60*FRACUNIT/5*6
					jpad.tics = -1
					jpad.fuse = 10*TICRATE
					jpad.flags2 = $|MF2_DONTDRAW
					jpad.jumps = 5
					AddToTable(jpad,N_GlobalThinkers)
					
					for i = 1, 12
						local fa = (360/12)*i*ANG1
						local ax = P_ReturnThrustX(nil, fa, player.mo.radius/2*3)
						local ay = P_ReturnThrustY(nil, fa, player.mo.radius/2*3)
						local ef = P_SpawnMobjFromMobj(player.mo, ax, ay, 0, MT_THOK)
						ef.state = S_DUSTLAYER3
						ef.fuse = 15
						ef.colorized = true
						ef.color = player.mo.color
						ef.angle = fa+ANGLE_90
						P_Thrust(ef, ef.angle-ANGLE_90,FixedMul(player.mo.scale,15*FRACUNIT)) 
					end
				end
			end
			player.wjump = true
		else
			player.wjump = false
		end
		
		if (player.mo.eflags & MFE_SPRUNG) --Sprung slow fall
			player.springfall = true
		end
		if P_IsObjectOnGround(player.mo)
			player.springfall = false
		elseif player.springfall and player.cmd.buttons & BT_JUMP and not player.boostflying
			P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/10*5)*P_MobjFlip(player.mo), true)
			if (leveltime%10) == 0
				S_StartSound(player.mo, sfx_pudpud)
			end
		end
	end
end)

addHook("TouchSpecial", function(mo, mobj)
	if mo and mo.valid and mo.jumppad
		if mobj and mobj.valid
		and mobj.player and mobj.player.valid
			if not N_ReturnPlayer(mobj.player) return end
			if mobj.player.cmd.buttons & BT_JUMP
			and (mobj.player.pflags & PF_JUMPED)
			and (mobj.player.pflags & PF_STARTJUMP)
			and not mobj.player.superjump
				S_StartSound(mobj, sfx_wdjump)
				S_StartSound(mobj, sfx_kc5b)
				mobj.player.superjump = TICRATE*3
				mobj.player.startz = mobj.z+mobj.height/2
				if mobj.momx
					mobj.momx = $/3*2
				end
				if mobj.momy
					mobj.momy = $/3*2
				end
				if P_MobjFlip(mo) == 1
					mobj.player.finz = mobj.z+500*FRACUNIT
				else
					mobj.player.finz = mobj.z+mobj.height-500*FRACUNIT
				end
				if mo.jumps
					mo.jumps = $-1
				end
				mo.fuse = 10*TICRATE
				if mo.jumps <= 0
					mo.jumps = 5
					mo.flags = $&~MF_SPECIAL
					mo.fuse = 7
				end
			end
		end
		return true
	end
end, MT_PARTICLE)