rawset(_G, "TN_HeavyCarry", function(mo, var) --When dropped and hit ground damage stuff
	if mo and mo.valid
		if TN_EnemyCarry[mo.type]
		and TN_EnemyCarry[mo.type].type
		and TN_EnemyCarry[mo.type].type == "heavy"
			if mo.carry and mo.carry.valid
			and mo.carry.player and mo.carry.player.valid
			and mo.carry.player.powers[pw_tailsfly]
				local c = mo.carry
				P_SetObjectMomZ(c, FixedMul(P_GetMobjGravity(c)/2,var)*P_MobjFlip(c), true)
				mo.noufaobjects = TICRATE
			end
		end
		if mo.thrown
			if P_IsObjectOnGround(mo)
				mo.thrown = false
				if mo.thrownby and mo.thrownby.valid
				and TN_EnemyCarry[mo.type]
				and TN_EnemyCarry[mo.type].type
				and TN_EnemyCarry[mo.type].type == "heavy"
					local pp = mo.thrownby
					P_Earthquake(mo, pp, 250*var)
					mo.momx = 0
					mo.momy = 0
					if not (mo.flags & MF_MONITOR)
						P_DamageMobj(mo, pp, pp, var/FRACUNIT)
					end
					mo.removecarryopti = 0
					mo.wascarried = true
					mo.noufaobjects = TICRATE
				end
			else
				P_SetObjectMomZ(mo, P_GetMobjGravity(mo)*P_MobjFlip(mo), true) --Increase gravity (1)
				mo.noufaobjects = TICRATE
			end
		end
	end
end)
freeslot("S_NOAISTATE")
states[S_NOAISTATE] = {SPR_NONE, A, 2, nil, 0, 0, S_NOAISTATE}

rawset(_G, "TN_SpeedCarry", function(mo, var) --Zoomies
	if mo and mo.valid
		mo.noai = $ or 0
		if mo.noai then mo.noai = $-1 end
		if mo.type == MT_GOLDBUZZ
		or mo.type == MT_REDBUZZ
			if mo.noai
				if mo.noaiinfo
					mo.state = S_NOAISTATE
					local i = mo.noaiinfo
					mo.sprite = i.sprite
					mo.sprite2 = i.sprite2
					mo.frame = i.frame
				end
				mo.noufaobjects = TICRATE
				mo.noaiing = true
			elseif mo.noaiing
				if mo.noaiinfo
					local i = mo.noaiinfo
					mo.state = i.state
					mo.sprite = i.sprite
					mo.sprite2 = i.sprite2
					mo.frame = i.frame
				end
				mo.noaiing = false
			end
		end
		
		if TN_EnemyCarry[mo.type]
		and TN_EnemyCarry[mo.type].type
		and TN_EnemyCarry[mo.type].type == "speed"
			if mo.carry and mo.carry.valid
			and mo.carry.player and mo.carry.player.valid
			and mo.carry.player.powers[pw_tailsfly]
				local c = mo.carry
				local cp = c.player
				if (cp.cmd.forwardmove or cp.cmd.sidemove)
				and R_PointToDist2(0,0,c.momx, c.momy) < (skins[c.skin].normalspeed/FRACUNIT)*var
					P_Thrust(c, cp.drawangle, var)
				end
				mo.noufaobjects = TICRATE
			end
			if mo.thrown
				if mo.type == MT_GOLDBUZZ
				or mo.type == MT_REDBUZZ
					mo.noaiinfo = {
					sprite = mo.sprite,
					sprite2 = mo.sprite2,
					frame = mo.frame,
					state = mo.state}
					mo.noai = TICRATE
				end
				P_Thrust(mo, mo.angle, 20*FRACUNIT)
				mo.thrown = false
				if mo.flags & MF_MISSILE
					mo.uncarry = 2
				end
				mo.noufaobjects = TICRATE
			end
		end
	end
end)

rawset(_G, "CheckPlayer", function(m1, m2,bruh) --1 = builder, 2 = whos about to get 0%`d
	if m1 and m1.valid
	and m2 and m2.valid
	and m1.player and m1.player.valid
	and m2.player and m2.player.valid
		local p1 = m1.player
		local p2 = m2.player
		if (gametyperules & GTR_FRIENDLY)
			if friendlyfire or (gametyperules & GTR_FRIENDLYFIRE)
				return false
			else
				return true
			end
		else
			if (gametyperules & GTR_TEAMS)
				if friendlyfire or (gametyperules & GTR_FRIENDLYFIRE)
					return false
				else
					if p1.ctfteam and p2.ctfteam
					and p1.ctfteam == p2.ctfteam
						return true
					else
						return false
					end
				end
			else
				return false
			end
		end
	end
	return false
end)
rawset(_G,"SearchForShootables",function(m) --P_LookForEnemies (Edited)
	if m and m.valid
		local closestmo = nil
		local maxdist = 3074*FRACUNIT
		local span = ANGLE_90
		local dist
		local closestdist
		for mo in mobjs.iterate()
			if mo and mo.valid
				if (mo.flags & MF_NOCLIPTHING) continue end
				if mo.health <= 0 continue end
				if (mo.flags & (MF_MONITOR|MF_MISSILE)) continue end
				if not (mo.flags & (MF_ENEMY|MF_BOSS|MF_SHOOTABLE)) continue end
				if mo == m continue end
				if mo.flags2 & MF2_FRET continue end
				
					local zdist = (m.z+m.height/2)-(mo.z+mo.height/2)
					dist = R_PointToDist2(mo.x,mo.y,m.x,m.y)
					
					dist = R_PointToDist2(0,dist,0,zdist)
					if dist > maxdist continue end
					
				if ((twodlevel or m.flags2 & MF2_TWOD)
				and abs(m.y-mo.y) > m.radius) continue end
				
				if m.tracer and m.tracer.valid
					if mo == m.tracer continue end
					if mo.tracer and mo.tracer.valid
					and mo.tracer == m.tracer continue end
					if mo.player and mo.player.valid
						if CheckPlayer(m.tracer, mo) continue end
					end
				end
				
				if (closestmo and dist > closestdist) continue end
				if abs(R_PointToAngle2(m.x,m.y,mo.x,mo.y)-m.angle) > span
					continue
				end
				
				if not P_CheckSight(m,mo) continue end
				
				closestmo = mo
				closestdist = dist
			end
		end
		return closestmo
	end
end)
rawset(_G, "TN_TurretCarry", function(mo, var) --Walking sentry no way!
	if mo and mo.valid
		mo.shootcd = $ or 25
		if mo.turcd then mo.turcd = $-1 end
		if TN_EnemyCarry[mo.type]
		and TN_EnemyCarry[mo.type].type
		and TN_EnemyCarry[mo.type].type == "turret"
			if mo.carry and mo.carry.valid
			and mo.carry.player and mo.carry.player.valid
				mo.noufaobjects = TICRATE
				local c = mo.carry
				local cp = c.player
				mo.tracer = c
				if mo.type == MT_TURRET
				or mo.type == MT_POPUPTURRET
					if P_MobjFlip(mo) == 1
						if mo.z >= (c.z+c.height/2)
							mo.renderflags = $&~RF_VERTICALFLIP
						else
							mo.renderflags = $|RF_VERTICALFLIP
						end
					else
						if mo.z+mo.height >= (c.z+c.height/2)
							mo.renderflags = $|RF_VERTICALFLIP
						else
							mo.renderflags = $&~RF_VERTICALFLIP
						end
					end
				end
				local t = SearchForShootables(mo)
				if mo.type == MT_POPUPTURRET
					mo.state = S_TURRETPOPUP8
				end
				if t and t.valid
				and t.health
				and t != mo
				and t != mo.tracer
				and t != c
					mo.target = t
					P_SpawnLockOn(cp,t,S_LOCKON1)
					if mo.shootcd
						if mo.shootcd == 25
							if mo.info.missilestate
								mo.state = mo.info.missilestate
							end
							P_SpawnXYZMissile(mo,t,mo.info.raisestate,mo.x,mo.y,mo.z+mo.height/2)
							S_StartSound(mo,mo.info.attacksound)
						end
						mo.shootcd = $-1
					end
				end
			end
		end
		if mo.thrown
			if mo.renderflags & RF_VERTICALFLIP
				mo.renderflags = $&~RF_VERTICALFLIP
			end
			mo.tracer = nil
		end
	end
end)

//A FIX FROM THE FUTURE!
addHook("ShouldDamage", function(mo,mobj,src,dmg,dmgtype) --Damage fixes for players
	if mo and mo.valid
		if mobj and mobj.valid
			if mobj.tracer and mobj.tracer.valid
			and mobj.tracer == mo
				return false
			end
			if CheckPlayer(mo,mobj)
				return false
			end
			if (mobj.flags & MF_MISSILE)
			and mobj.target and mobj.target.valid
			and CheckPlayer(mo,mobj.target)
				return false
			end
			if mobj.tracer and mobj.tracer.valid
			and CheckPlayer(mo,mobj.tracer)
				return false
			end
		end
	end
end,MT_PLAYER)

local function FindToBomb(mobj)
	local closestmo = nil
	local maxdist = mobj.radius*5
	local dist = 0
	local closestdist = 0
	
	for mo in mobjs.iterate()
		if (mo.flags & MF_NOCLIPTHING) then continue end
		if (mo.health <= 0) then continue end
		
		if (P_MobjFlip(mo) == 1 and mo.z > mobj.z+mobj.height) then continue end
		if (P_MobjFlip(mo) == -1 and mo.z+mo.height < mobj.z) then continue end
		
		if not (mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) and (mo.flags & MF_SHOOTABLE)) then continue end
		
		if (mo == mobj) then continue end
			
		dist = P_AproxDistance(mobj.x-mo.x, mobj.y-mo.y)
		
		if (dist > maxdist) then continue end
		
		if (mo.type == MT_PLAYER) then continue end
		if (closestmo and dist > closestdist) then continue end
		
		if not P_CheckSight(mobj, mo) then continue end
		
		closestmo = mo
		closestdist = dist
	end
	return closestmo
end

rawset(_G, "TN_BomberCarry", function(mo, var) --Bombs? It`s yours my friend!
	if mo and mo.valid
		mo.bombcd = $ or 0
		if mo.bombcd then mo.bombcd = $-1 end
		if TN_EnemyCarry[mo.type]
		and TN_EnemyCarry[mo.type].type
		and TN_EnemyCarry[mo.type].type == "bomber"
			local t = FindToBomb(mo)
			if t and t.valid
			and not mo.bombcd
				mo.noufaobjects = TICRATE
				local z = mo.z + FixedMul((14*FRACUNIT) - 12*FRACUNIT, mo.scale)
				local m = P_SpawnMobj(t.x, t.y, z, TN_EnemyCarry[mo.type].var)
				if mo.carry and mo.carry.valid
					m.target = mo.carry
				end
				if P_MobjFlip(mo) == -1
					m.flags2 = $|MF2_OBJECTFLIP
					m.eflags = $|MFE_VERTICALFLIP
				end
				m.momz = mo.momz+mo.pmomz
				S_StartSound(mo, mo.info.attacksound)
				mo.bombcd = TICRATE
			end
		end
	end
end)